;Defender Arcade: hack of Stargate (Defender II)

;Optimizing notes added for branching...but be careful that tables don't shift around yet.
;Adding temporary ORG/RORG's above data tables should accomplish that.


;Options:
ARCADE_CONTROL = 1 ;allow the use of a reverse button instead of just moving left or right
MERGE_THRUST = 0 ;put reverse+thrust both on the same button

;Notes on the above...
;By setting ARCADE_CONTROL to 1, the original left and right functions are dropped. Instead,
;LEFT will reverse the ship, and RIGHT will provide thrust.  However, there is still a slight
;conflict with this setup...as it doesn't allow you to reverse the same time as you thrust (the
;reverse button overrides the thrust button).
;To provide a "quick fix" to this problem, the MERGE_THRUST variable has been added...whereby
;moving LEFT reverses the ship and continues to thrust for as long as it's held.  This too has
;a problem...in that you cannot thrust without reversing first.
;(sigh)

;Of course, the only way to properly play the game using this setup would be to rip apart a
;couple of sticks and nail them to a board with Happs buttons added.

; Disassembly of d2_001.bin
; Disassembled Sat Feb 28 07:47:26 2004
; Using DiStella v2.0
; Command Line: C:\BIN\DISTELLA.EXE -pafscd2_001.cfg d2_001.bin 
; d2_001.cfg contents:
;      GFX D000 D100
;      CODE D101 DC6E
;      GFX DC6F DFF1 <- note: bankswitch routine missed @ $DFF2
;      
; Disassembly of d2_002.bin
; Disassembled Sat Feb 28 07:48:16 2004
; Using DiStella v2.0
; Command Line: C:\BIN\DISTELLA.EXE -pafscd2_002.cfg d2_002.bin 
; d2_002.cfg contents:
;      GFX F000 F0FF
;      CODE F100 F67F <- note: data table missed @ $F103
;      GFX F680 F8FF
;      CODE F900 F936
;      GFX F937 FAF3
;      CODE FAF4 FAFF
;      GFX FB00 FFF1 <- note: bankswitch routine missed @ $FFF2

      processor 6502

VSYNC   =  $00
VBLANK  =  $01
WSYNC   =  $02
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUP0  =  $06
COLUP1  =  $07
COLUPF  =  $08
COLUBK  =  $09
CTRLPF  =  $0A
REFP0   =  $0B
REFP1   =  $0C
PF0     =  $0D
PF1     =  $0E
PF2     =  $0F
RESP0   =  $10
RESP1   =  $11
RESM0   =  $12
RESBL   =  $14
AUDC0   =  $15
AUDC1   =  $16
AUDF0   =  $17
AUDF1   =  $18
AUDV0   =  $19
AUDV1   =  $1A
GRP0    =  $1B
GRP1    =  $1C
ENAM0   =  $1D
ENAM1   =  $1E
ENABL   =  $1F
HMP0    =  $20
HMP1    =  $21
HMM1    =  $23
HMBL    =  $24
VDELP0  =  $25
VDEL01  =  $26
HMOVE   =  $2A
HMCLR   =  $2B
CXCLR   =  $2C
CXM0P   =  $30
CXP0FB  =  $32
CXPPMM  =  $37
INPT4   =  $3C
INPT5   =  $3D
SWCHA   =  $0280
SWCHB   =  $0282
INTIM   =  $0284
$0285   =  $0285
TIM64T  =  $0296

;User ram equates:
r80 = $80
r81 = $81
r82 = $82
r83 = $83
r84 = $84 ;unused in this hack
r85 = $85
r86 = $86
r87 = $87
r88 = $88
r89 = $89
r8A = $8A
r8B = $8B
r8C = $8C
r8D = $8D
r8E = $8E
r8F = $8F
r90 = $90
r91 = $91
r92 = $92
r93 = $93
r94 = $94 ;2 bytes (indirect pointer)
;r95 = $95
r96 = $96 ;2 bytes (indirect pointer)
;r97 = $97
r98 = $98
r99 = $99
r9A = $9A
r9B = $9B ;2 bytes (indirect pointer)
;r9C = $9C
r9D = $9D ;2 bytes (indirect pointer)
;r9E = $9E
r9F = $9F ;2 bytes (indirect pointer)
;rA0 = $A0
rA1 = $A1
rA2 = $A2
rA3 = $A3
rA4 = $A4
rA5 = $A5
rA6 = $A6
rA7 = $A7
rA8 = $A8
rA9 = $A9
rAA = $AA
rAB = $AB
rAC = $AC
rAD = $AD
rAE = $AE
rAF = $AF
rB0 = $B0 ;6 bytes
;rB1 = $B1
;rB2 = $B2
;rB3 = $B3
;rB4 = $B4
;rB5 = $B5
rB6 = $B6 ;6 bytes
;rB7 = $B7
;rB8 = $B8
;rB9 = $B9
;rBA = $BA
;rBB = $BB
rBC = $BC ;6 bytes
;rBD = $BD
;rBE = $BE
;rBF = $BF
;rC0 = $C0
;rC1 = $C1
rC2 = $C2 ;6 bytes
;rC3 = $C3
;rC4 = $C4
;rC5 = $C5
;rC6 = $C6
;rC7 = $C7
rC8 = $C8 ;6 bytes
;rC9 = $C9
;rCA = $CA
;rCB = $CB
;rCC = $CC
;rCD = $CD
rCE = $CE ;6 bytes
;rCF = $CF
;rD0 = $D0
;rD1 = $D1
;rD2 = $D2
;rD3 = $D3
rD4 = $D4
rD5 = $D5
rD6 = $D6
rD7 = $D7
rD8 = $D8
rD9 = $D9
rDA = $DA
rDB = $DB
rDC = $DC
rDD = $DD
rDE = $DE
rDF = $DF
rE0 = $E0 ;16 bytes?
;rE1 = $E1
;rE2 = $E2
;rE3 = $E3
;rE4 = $E4
;rE5 = $E5
;rE6 = $E6
;rE7 = $E7
;rE8 = $E8
;rE9 = $E9
;rEA = $EA
;rEB = $EB
;rEC = $EC
;rED = $ED
;rEE = $EE
rEF = $EF

rF0 = $F0 ;2 bytes (indirect pointer)
;rF1 = $F1

;printing temps...12 byte array (6 indirect pointers)
rF2 = $F2
;rF3 = $F3
;rF4 = $F4
;rF5 = $F5
;rF6 = $F6
;rF7 = $F7
;rF8 = $F8
;rF9 = $F9
;rFA = $FA
;rFB = $FB
;rFC = $FC
;rFD = $FD

;rFE = $FE ;stack only
;rFF = $FF ;stack only

;Cartridge ram equates...
;Onboard ram is divided into 2 parts. The first 128 bytes are used for writing values, and the
;next 128 bytes are used for reading them back (so STA $F000 and LDA $F080 are both dealing
;with the same ram location). The ones listed in the code are defined here:
Write00 = $F000
Write01 = $F001
Write02 = $F002
Write12 = $F012
Write22 = $F022
Write28 = $F028
Write31 = $F031
Write32 = $F032
Write38 = $F038
Write41 = $F041
Write42 = $F042
Write43 = $F043
Write48 = $F048
Write49 = $F049
Write4A = $F04A
Write4B = $F04B
Write4C = $F04C
Write4D = $F04D
Write4E = $F04E
Write4F = $F04F
Write56 = $F056
Write5D = $F05D
Write64 = $F064
Write6B = $F06B
Write72 = $F072
Write79 = $F079
Write7A = $F07A
Write7B = $F07B
Write7C = $F07C
Write7D = $F07D

Read00 = Write00+128
Read01 = Write01+128
Read02 = Write02+128
Read12 = Write12+128
Read22 = Write22+128
Read32 = Write32+128
Read42 = Write42+128
Read43 = Write43+128
Read48 = Write48+128
Read49 = Write49+128
Read4A = Write4A+128
Read4B = Write4B+128
Read4C = Write4C+128
Read4D = Write4D+128
Read4E = Write4E+128
Read4F = Write4F+128
Read56 = Write56+128
Read5D = Write5D+128
Read64 = Write64+128
Read6B = Write6B+128
Read72 = Write72+128
Read79 = Write79+128
Read7A = Write7A+128
Read7B = Write7B+128
Read7C = Write7C+128
Read7D = Write7D+128

       ORG  $1000
       RORG $D000

;1st page reserved for cartridge ram
       .ds 256,0 ;256 zeros

LD100:
       .byte $00 ; |        | $D100
       .byte $13 ; |   X  XX| $D101
       .byte $12 ; |   X  X | $D102

START1:
       LDY    #$B5                    ;2
       SEI                            ;2
       CLD                            ;2
       LDX    #$00                    ;2
LD109:
       LDA    #$00                    ;2
LD10B:
       STA    VSYNC,X                 ;4
       STA    r80+$EF00,X             ;5 ??
       INX                            ;2
       BNE    LD10B                   ;2
       DEX                            ;2
       TXS                            ;2 X=$FF...reset stack to beginning
       STY    r80                     ;3
       LDX    #$0F                    ;2
LD119:
       LDA    LDE6A,X                 ;4
       STA    Write02,X               ;5
       DEX                            ;2
       BPL    LD119                   ;2
       LDA    #$01                    ;2
       STA    Write41                 ;4
       LDA    #$10                    ;2
       STA    Write31                 ;4
       LDA    #$49                    ;2
       STA    r99                     ;3
       LDA    #$80                    ;2
       STA    rAE                     ;3
       STA    r85                     ;3
       LDX    r82                     ;3
       BEQ    LD13D                   ;2
       STA    Write7C                 ;4
LD13D:
       LDA    #$01                    ;2
       STA    Write01                 ;4
       LDA    r82                     ;3
       BNE    LD150                   ;2
       STA    rAE                     ;3
       LDA    #$C8                    ;2
       STA    r87                     ;3
       LDA    #$A7                    ;2
       STA    r88                     ;3
LD150:
       LDA    #$FF                    ;2
       STA    rD6                     ;3
       LDA    #$32                    ;2
       STA    Write4A                 ;4
       STA    rD8                     ;3
       LDA    #$FF                    ;2
       STA    r94+1                   ;3
       LDA    #$C8                    ;2
       STA    r81                     ;3
       STA    r9A                     ;3
       LDA    #$0B                    ;2
       STA    rA8                     ;3
ld90b_jmp:
       JMP    LD90B                   ;3

LD16C:
       LDA    #$2B                    ;2
       STA    TIM64T                  ;4
       LDA    r82                     ;3
       BNE    LD181                   ;2
       LDA    rAE                     ;3
       BEQ    LD17D                   ;2
       DEC    rAE                     ;5
       BNE    LD181                   ;2
LD17D:
       LDA    INPT4                   ;3
       BPL    LD188                   ;2
LD181:
       LDA    SWCHB                   ;4
       AND    #$01                    ;2
       BNE    LD197                   ;2
LD188:
       LDA    #$03                    ;2
       STA    r82                     ;3  Lives
;       STA    r84                     ;3 No Inviso in Defender
       STA    r83                     ;3  Smart Bombs
       LDY    r80                     ;3
       LDX    #$89                    ;2
       JMP    LD109                   ;3 could -just barely- use a BNE instead

LD197:
       LDX    #$FF                    ;2
       TXS                            ;2 reset stack to beginning
       LDA    r82                     ;3
;       BNE    LD1A1                   ;2
;       JMP    LD90B                   ;3 could just BEQ to the JMP LD90B above to kill the BNE
       beq    ld90b_jmp               ;2
;LD1A1:
       LDA    CXM0P                   ;3
       BPL    LD1B5                   ;2
       LDA    rAB                     ;3
       BNE    LD1B5                   ;2
       LDA    r99                     ;3
       SBC    #$05                    ;2
       CMP    r9A                     ;3
       BCS    LD1B5                   ;2
       LDA    #$2F                    ;2
       STA    rA6                     ;3
LD1B5:
       LDA    rAC                     ;3
       BEQ    LD200                   ;2
       DEC    rAC                     ;5
       LDX    rA3                     ;3
       BEQ    LD1FD                   ;2
LD1BF:
       DEC    rA3                     ;5
       LDX    rA3                     ;3
       BEQ    LD1FD                   ;2
       LDY    Read42,X                ;4
       LDX    Read22,Y                ;4
       CPX    #$0D                    ;2
       BEQ    LD1E4                   ;2
       BCS    LD1BF                   ;2
       LDA    #$11                    ;2
ld1d3:
       STA    Write22,Y               ;5
LD1D6:
       LDA    LDDEF,X                 ;4
       STA    rF0+1                   ;3
       LDA    LDDFD,X                 ;4
       JSR    LDC4E                   ;6
       JMP    LD1BF                   ;3

LD1E4:
       LDA.wy rE0,Y                   ;4
       SEC                            ;2
       SBC    #$09                    ;2
       STA.wy rE0,Y                   ;5
       LDX    #$0E                    ;2
       CMP    #$58                    ;2
       BCC    LD1F5                   ;2
       LDX    #$0F                    ;2
LD1F5:
       TXA                            ;2
;       STA    Write22,Y               ;5
       LDX    #$09                    ;2
;       BNE    LD1D6                   ;2 always branch
       bne    ld1d3                   ;2 always branch
;branch to the STA above LD1D6 instead... ;)


LD1FD:
       JMP    LD41C                   ;3

LD200:
       LDA    rA7                     ;3
       BNE    LD243                   ;2
       LDA    r8E                     ;3
       BNE    LD243                   ;2
       LDX    rA3                     ;3
       DEX                            ;2
LD20B:
       DEX                            ;2
       BMI    LD243                   ;2
       LDA    rB0,X                   ;4
       BPL    LD20B                   ;2
       LDY    Read43,X                ;4
       LDA    r99                     ;3
       SBC    #$05                    ;2
       CMP.wy rE0,Y                   ;4
       BCS    LD243                   ;2
       LDX    Read22,Y                ;4
       CPX    #$0D                    ;2
       BCC    LD25F                   ;2
       BEQ    LD246                   ;2
       CPX    #$10                    ;2
       BEQ    LD282                   ;2
       CPX    #$10                    ;2 superfluous...X already checked for value #$10...
       BCS    LD243                   ;2 ...performing BCS before the BEQ would do the same.
       LDA    #$00                    ;2
       STA    Write22,Y               ;5
       LDX    rAF                     ;3
       INC    rAF                     ;5
       CLC                            ;2
       LDA    LDE0D,X                 ;4
       JSR    LDC56                   ;6
       LDA    #$D2                    ;2
       STA    r91                     ;3
LD243:
       JMP    LD2F5                   ;3

LD246:
       LDA.wy rE0,Y                   ;4
       SBC    #$09                    ;2
       CMP    r99                     ;3
       BCS    LD243                   ;2
       STA.wy rE0,Y                   ;5
       LDX    #$0E                    ;2
       CMP    #$3A                    ;2
       BCC    LD25A                   ;2
       LDX    #$0F                    ;2
LD25A:
       TXA                            ;2
       LDX    #$09                    ;2
       BNE    LD262                   ;2 always branch

LD25F:
       LDA    LDDD7,X                 ;4
LD262:
       STA    Write22,Y               ;5
       LDA    LDDEF,X                 ;4
       STA    rF0+1                   ;3
       LDA    LDDFD,X                 ;4
       JSR    LDC4E                   ;6
       LDA    #$0F                    ;2
       STA    rA5                     ;3
       LDA    #$76                    ;2
       STA    r91                     ;3
       LDA    rAB                     ;3
       BNE    LD243                   ;2
       LDA    #$2F                    ;2
       STA    rA6                     ;3
       BNE    LD243                   ;2 always branch

LD282:
       LDA    r89                     ;3
       CMP    #$10                    ;2
       BCS    LD2B8                   ;2
       LDX    rAF                     ;3
       CPX    #$04                    ;2
       BCC    LD2B8                   ;2
       SED                            ;2
       ADC    #$02                    ;2
       STA    r89                     ;3
       CLD                            ;2
       LDA    r8A                     ;3
       ADC    #$03                    ;2
       STA    r8A                     ;3
       LDY    #$09                    ;2
       LDA    #$00                    ;2
LD29E:
       DEY                            ;2
       BMI    LD2B3                   ;2
       LDX    Read22,Y                ;4
       STA    Write22,Y               ;5
       CPX    #$0D                    ;2
       BCC    LD29E                   ;2
       CPX    #$10                    ;2
       BCS    LD29E                   ;2
       INC    rAF                     ;5
       BCC    LD29E                   ;2 always branch

LD2B3:
       LDA    #$20                    ;2
       JMP    LD477                   ;3

LD2B8:
       LDX    #$09                    ;2
LD2BA:
       DEX                            ;2
       BMI    LD2E0                   ;2
       LDA    Read22,X                ;4
       CMP    #$0D                    ;2
       BNE    LD2BA                   ;2
       LDA    Read32,X                ;4
       LSR                            ;2
       STA    rF0                     ;3
       LDA    Read02,X                ;4
       ROR                            ;2
       LSR    rF0                     ;5
       ROR                            ;2
       LSR                            ;2
       LSR                            ;2
       SEC                            ;2
       SBC    #$08                    ;2
       AND    #$3F                    ;2
       BNE    LD2E2                   ;2
       LDA    #$40                    ;2
       STA    r99                     ;3
       BNE    LD2E2                   ;2 always branch

LD2E0:
       LDA    #$20                    ;2
LD2E2:
       STA    rAD                     ;3
       LDA    #$2E                    ;2
       STA    r91                     ;3
       LDX    Read01                  ;4
       LDA    LDE15,X                 ;4
       STA    r85                     ;3
       LDA    #$00                    ;2
       STA    Write4C                 ;4
LD2F5:
       LDA    rA7                     ;3
       BNE    LD361                   ;2
       LDA    CXP0FB                  ;3
       BPL    LD361                   ;2
       LDX    rA4                     ;3
       BNE    LD314                   ;2
       LDY    Read48                  ;4
       LDA    LDD02,Y                 ;4
       EOR    #$FF                    ;2
       AND    rD6                     ;3
       STA    rD6                     ;3
       LDA    #$00                    ;2
       STA    r90                     ;3
;       JMP    LD355                   ;3 could use a BEQ instead
       beq    LD355                   ;2 could use a BEQ instead

LD314:
       LDY    Read42,X                ;4
       LDX    Read22,Y                ;4
       CPX    #$10                    ;2
       BCS    LD361                   ;2
       LDA    LDDD7,X                 ;4
       STA    Write22,Y               ;5
       LDA    #$00                    ;2
       STA    r90                     ;3
       CPX    #$0D                    ;2
       BNE    LD34A                   ;2
       LDA.wy rE0,Y                   ;4
       SBC    #$08                    ;2
       CMP    rD7                     ;3
       BCS    LD355                   ;2
       STA.wy rE0,Y                   ;5
       LDX    #$0E                    ;2
       CMP    #$3A                    ;2
       BCC    LD340                   ;2
       LDX    #$0F                    ;2
LD340:
       TXA                            ;2
       STA    Write22,Y               ;5
       LDX    #$BF                    ;2
       STX    r90                     ;3
       LDX    #$09                    ;2
LD34A:
       LDA    LDDEF,X                 ;4
       STA    rF0+1                   ;3
       LDA    LDDFD,X                 ;4
       JSR    LDC4E                   ;6
LD355:
       LDA    #$00                    ;2
       STA    rD7                     ;3
       LDA    #$0F                    ;2
       STA    rA5                     ;3
       LDA    #$76                    ;2
       STA    r91                     ;3
LD361:
       LDA    r81                     ;3
       LSR                            ;2
       BCS    LD369                   ;2
       JMP    LD454                   ;3

LD369:
       LDX    rA9                     ;3
       LDA    LDE3D,X                 ;4
       STA    r8F                     ;3
       LDY    rA6                     ;3
       BEQ    LD3EC                   ;2
       CPY    #$2E                    ;2
       BNE    LD385                   ;2
       LDA    #$02                    ;2
       STA    r90                     ;3
       STA    r8E                     ;3
       LDA    r99                     ;3
       ADC    #$02                    ;2
       STA    Write49                 ;4
LD385:
       CPY    #$24                    ;2
       BNE    LD3D7                   ;2
       LDX    #$00                    ;2
       STX    r99                     ;3
       STX    rF0                     ;3
       DEX                            ;2
       STX    r8F                     ;3
       LDA    #$02                    ;2
       STA    Write41                 ;4
       LDA    #$00                    ;2
       LDX    #$09                    ;2
LD39B:
       DEX                            ;2
       BMI    LD3AA                   ;2
       LDY    Read22,X                ;4
       CPY    #$04                    ;2
       BCS    LD39B                   ;2
       STA    Write22,X               ;5
       BCC    LD39B                   ;2 always branch

LD3AA:
       LDY    #$0E                    ;2
LD3AC:
       LDA    LDE5A,Y                 ;4
       STA.wy rE0,Y                   ;5
       TYA                            ;2
       AND    #$03                    ;2
       STA    Write32,Y               ;5
       LDX    Read22,Y                ;4
       CPX    #$0D                    ;2
       BCC    LD3D0                   ;2
       CPX    #$10                    ;2
       BCS    LD3D0                   ;2
       LDA    LDC6F-13,X              ;4 x = $0E to $10
       STA    Write22,Y               ;5
       LDX    rF0                     ;3
       JSR    LDC39                   ;6
       STX    rF0                     ;3
LD3D0:
       DEY                            ;2
       BPL    LD3AC                   ;2
       LDA    #$1F                    ;2
       STA    rA7                     ;3
LD3D7:
       DEC    rA6                     ;5
       BNE    LD3EC                   ;2
       STY    Write01                 ;4
       DEY                            ;2
       STY    Write4C                 ;4
       LDA    #$53                    ;2
       STA    r85                     ;3
       LDA    #$49                    ;2
       STA    r99                     ;3
       DEC    r82                     ;5
LD3EC:
       LDA    #$20                    ;2 Color of Player's Ship and Mountains (was 32)
       CPY    #$24                    ;2
       BCC    LD3F5                   ;2
       LDA    LDE0D,Y                 ;4
LD3F5:
       STA    Write4A                 ;4
       LDA    rA5                     ;3
       BEQ    LD41C                   ;2
       DEC    rA5                     ;5
       AND    #$03                    ;2
       BNE    LD41C                   ;2
       LDA    rA5                     ;3
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       LDA    LD100,X                 ;4
       LDX    #$0F                    ;2
LD40C:
       DEX                            ;2
       BMI    LD41C                   ;2
       LDY    Read22,X                ;4
       CPY    #$11                    ;2
       BCC    LD40C                   ;2
       STA    Write22,X               ;5
;       JMP    LD40C                   ;3 could use a BCS here instead
       bcs    LD40C                   ;2 could use a BCS here instead

LD41C:
       LDA    rA9                     ;3
       BEQ    LD430                   ;2
       CMP    #$1C                    ;2
       BCS    LD430                   ;2
       INC    rA9                     ;5
       AND    #$03                    ;2
       BNE    LD442                   ;2
       LDA    #$05                    ;2
       STA    r90                     ;3
       BNE    LD442                   ;2 always branch

LD430:
       LDA    r8E                     ;3
       BNE    LD451                   ;2
       LDA    rA7                     ;3
       BEQ    LD442                   ;2
       DEC    rA7                     ;5
       CMP    #$19                    ;2
       BNE    LD442                   ;2
       LDA    #$2E                    ;2
       STA    r91                     ;3
LD442:
       LDX    #$2B                    ;2
       LDA    SWCHA                   ;4
       EOR    #$FF                    ;2
       AND    #$C0                    ;2 left/right
       BEQ    LD44F                   ;2 branch if neither
       LDX    #$28                    ;2
LD44F:
       STX    r92                     ;3
LD451:
       JMP    LD5FF                   ;3

LD454:
       LDA    rA8                     ;3
       CMP    #$06                    ;2
       BCS    LD484                   ;2
       LDY    #$0E                    ;2
LD45C:
       LDA    Read22,Y                ;4
       CMP    #$04                    ;2
       BCS    LD484                   ;2
       DEY                            ;2
       BPL    LD45C                   ;2
       INC    r8A                     ;5
       SED                            ;2
       LDA    r89                     ;3
       CLC                            ;2
       ADC    #$01                    ;2  Affects Multiplier at end of wave
       STA    r89                     ;3
       CLD                            ;2
       CMP    #$05                    ;2
       BCC    LD477                   ;2
       LDA    #$05                    ;2
LD477:
       STA    Write4E                 ;4
       LDA    #$D2                    ;2
       STA    rAA                     ;3
       STA    r8E                     ;3
       LDA    #$0B                    ;2
       STA    rA8                     ;3
LD484:
       LDA    rA9                     ;3
       BNE    LD4A4                   ;2
       LDA    rD6                     ;3
       BNE    LD4A4                   ;2
       LDA    rAF                     ;3
       BNE    LD4A4                   ;2
       LDX    #$08                    ;2
LD492:
       LDA    Read22,X                ;4
       CMP    #$0D                    ;2
       BCS    LD4A4                   ;2
       DEX                            ;2
       BPL    LD492                   ;2
       LDA    #$01                    ;2
       STA    rA9                     ;3
       LDA    #$1F                    ;2
       STA    rA7                     ;3
LD4A4:
       LDA    rA9                     ;3
       BEQ    LD4B9                   ;2
       LDX    #$08                    ;2
LD4AA:
       LDA    Read22,X                ;4
       CMP    #$09                    ;2
       BNE    LD4B6                   ;2
       LDA    #$04                    ;2
       STA    Write22,X               ;5
LD4B6:
       DEX                            ;2
       BPL    LD4AA                   ;2
LD4B9:
       LDA    r81                     ;3
       BEQ    LD4C0                   ;2
LD4BD:
       JMP    LD56C                   ;3

LD4C0:
       LDA    r8E                     ;3
       BNE    LD4BD                   ;2
       DEC    rA8                     ;5
       BEQ    LD542                   ;2
       LDA    rA8                     ;3
       CMP    #$0A                    ;2
       BEQ    LD4FC                   ;2
       CMP    #$08                    ;2
       BEQ    LD4DB                   ;2
       CMP    #$06                    ;2
       BNE    LD4BD                   ;2
       LDX    #$02                    ;2
;       JMP    LD4DD                   ;3 could use BIT_W (.byte $2C) instead, skips 2 bytes
       .byte $2C                      ;4 skip 2 bytes
LD4DB:
       LDX    #$05                    ;2
;LD4DD:
       LDA    r89                     ;3
       AND    #$0F                    ;2
       TAY                            ;2
       LDA    LDFE0,Y                 ;4
       STA    rF0                     ;3
       LDY    #$03                    ;2
LD4E9:
       LDA    rF0                     ;3
       STA    Write22,X               ;5
       TYA                            ;2
       STA    Write32,X               ;5
       LDA    #$87                    ;2
       STA    rE0,X                   ;4
       DEX                            ;2
       DEY                            ;2
       BNE    LD4E9                   ;2
       BEQ    LD56C                   ;2 always branch

LD4FC:
       LDA    #$02                    ;2
       STA    Write41                 ;4
       LDA    r89                     ;3
       AND    #$0F                    ;2
       TAX                            ;2
       LDA    LDF7C,X                 ;4
       STA    rF0                     ;3
       LDA    #$DF                    ;2
       STA    rF0+1                   ;3
       LDA    #$1F                    ;2
       STA    rA7                     ;3
       LDA    #$00                    ;2
       STA    Write22                 ;4
       STA    Write22+1               ;4
       STA    Write22+2               ;4
       STA    Write22+3               ;4
       STA    Write22+4               ;4
       STA    Write22+5               ;4
       LDX    r80                     ;3
       LDY    #$08                    ;2
LD52B:
       LDA    (rF0),Y                 ;5
       STA    Write28,Y               ;5
       LDA    LDE5A,Y                 ;4
       STA.wy rE0+6,Y                 ;5
       TXA                            ;2
       AND    #$03                    ;2
       STA    Write38,Y               ;5
       INX                            ;2
       DEY                            ;2
       BPL    LD52B                   ;2
       BMI    LD56C                   ;2 always branch

LD542:
       LDA    #$02                    ;2
       STA    rA8                     ;3
       LDX    #$07                    ;2
LD548:
       DEX                            ;2
       BMI    LD56C                   ;2
       LDA    Read22,X                ;4
       BNE    LD548                   ;2
       LDA    r80                     ;3
       AND    #$07                    ;2
       TAY                            ;2
       LDA    LDDE7,Y                 ;4
       STA    Write22,X               ;5
       LDA    #$01                    ;2
       STA    Write32,X               ;5
       STA    Write02,X               ;5
       LDA    #$08                    ;2
       STA    Write12,X               ;5
       LDA    #$78                    ;2
       STA    rE0,X                   ;4
LD56C:
       LDA    r8E                     ;3
       BNE    LD5D2                   ;2
       LDA    INPT5                   ;3
       BMI    LD598                   ;2
       LDA    Read4D                  ;4
       BNE    LD5D2                   ;2
       LDA    r83                     ;3
;       BEQ    LD591                   ;2
       beq    LD5BD                   ;2

       DEC    r83                     ;5
       LDA    #$0F                    ;2
       STA    r8F                     ;3
       LDA    #$02                    ;2
       STA    rAC                     ;3
       LDA    #$02                    ;2
       STA    r90                     ;3
       LDA    #$0F                    ;2
       STA    rA5                     ;3
       BNE    LD5CF                   ;2 always branch

;Note: r84 not used in this hack...so the BEQ that leads here can be changed to LD5BD
;LD591:
;       LDA    r84                     ;3
;       BNE    LD5B3                   ;2
;       JMP    LD5BD                   ;3 could use BEQ instead

LD598:
       LDA    SWCHA                   ;4
       EOR    #$FF                    ;2
       AND    #$03                    ;2 right controller up/down
;       BNE    LD5A6                   ;2
;       STA    Write4D                 ;4
;       BEQ    LD5D2                   ;2 always branch
       bne    LD5D2                   ;2 branch if either
       beq    LD5CF                   ;2 neither...always branch
;Could just BEQ LD5CF instead to eliminate the BNE and STA lines ;)


;these lines not needed either with r84 unused...
;LD5A6:
;       LDX    Read4D                  ;4
;       BNE    LD5D2                   ;2
;       CMP    #$01                    ;2
;       BNE    LD5BD                   ;2
;       LDA    r84                     ;3
;       BEQ    LD5D2                   ;2
;LD5B3:
;       DEC    r84                     ;5
;       LDA    rAB                     ;3
;       ADC    #$1E                    ;2
;       STA    rAB                     ;3
;       BNE    LD5CF                   ;2


LD5BD:
       LDA    r80                     ;3
       AND    #$3F                    ;2
       CMP    #$0D                    ;2
       BCS    LD5C9                   ;2
       LDX    #$2F                    ;2
       STX    rA6                     ;3
LD5C9:
       STA    rAD                     ;3
       LDA    #$2E                    ;2
       STA    r91                     ;3
LD5CF:
       STA    Write4D                 ;4
LD5D2:
       LDX    rAF                     ;3
       BEQ    LD5FF                   ;2
       LDA    r99                     ;3
       CMP    #$11                    ;2
       BCS    LD5FF                   ;2
       LDX    #$00                    ;2
       LDA    Read00                  ;4
       ADC    #$40                    ;2
       SBC    r85                     ;3
       BCS    LD5E8                   ;2
       INX                            ;2
LD5E8:
       JSR    LDC39                   ;6
       LDA    rA6                     ;3
       BNE    LD5FD                   ;2
       LDA    rAA                     ;3
       BNE    LD5FD                   ;2
       LDA    #$E0                    ;2
       STA    r91                     ;3
       LDA    #$05                    ;2
       CLC                            ;2
       JSR    LDC56                   ;6
LD5FD:
       DEC    rAF                     ;5
LD5FF:
       LDA    r82                     ;3
       BEQ    LD617                   ;2
       LDA    rAD                     ;3
       BEQ    LD60F                   ;2
       DEC    rAD                     ;5
       LDA    #$10                    ;2
       STA    r98                     ;3
       BNE    LD617                   ;2 always branch

LD60F:
       LDY    #$00                    ;2
       LDA    rA6                     ;3
       BEQ    LD61A                   ;2
       STY    r98                     ;3
LD617:
       JMP    LD6CF                   ;3

LD61A:
       LDA    #$FF                    ;2
       EOR    SWCHA                   ;4
       BNE    LD625                   ;2
       LDX    INPT4                   ;3
       BMI    LD62E                   ;2
LD625:
       STY    Write7D                 ;4
       LDX    rAA                     ;3
       BNE    LD62E                   ;2
       STY    r8E                     ;3
LD62E:
       LDX    r8E                     ;3
       BEQ    LD633                   ;2
       TYA                            ;2
LD633:
       STA    rF0                     ;3
       LDX    Read01                  ;4
       LDY    Read4C                  ;4
       AND    #$C0                    ;2
  IF ARCADE_CONTROL
    IF MERGE_THRUST
       bit    r84                     ;3
       bvs    No_Thrust               ;2
       lda    r84                     ;3
       ror                            ;2
       bcs    LD653                   ;2
       bcc    Lft                     ;2
No_Thrust:
       BEQ    LD64C                   ;2
       ROL                            ;2
       bcs    LD65A                   ;2
;left being pressed...
       bit    r84                     ;3
       bvc    LD65A                   ;2 skip if pressed on prev. frame
       lda    r84                     ;3
       eor    #$01                    ;2 reverse the ship
       sta    r84                     ;3
       lsr                            ;2
       bcs    LD653                   ;2 branch to move left
Lft:
    ELSE
       BEQ    Check_Thrust            ;2
       ROL                            ;2
       bcs    Check_Thrust            ;2
;left being pressed...
       bit    r84                     ;3
       bvc    Check_Thrust            ;2 skip if pressed on prev. frame
       lda    r84                     ;3
       eor    #$01                    ;2 reverse the ship
       sta    r84                     ;3
       lsr                            ;2
       bcs    LD653                   ;2
       bcc    Lft                     ;2
Check_Thrust:
       bit    r84                     ;3
       bmi    No_Thrust               ;2
       lda    r84                     ;3
       ror                            ;2
       bcs    LD653                   ;2
       rol                            ;2
Lft:
    ENDIF
  ELSE
       BEQ    LD64C                   ;2
       ROL                            ;2
       BCS    LD653                   ;2
  ENDIF

       LDX    #$00                    ;2
       CPY    #$C0                    ;2
       BEQ    LD65A                   ;2
LD648:
       DEY                            ;2
       JMP    LD65A                   ;3

;handle slowing down
  IF MERGE_THRUST = 0
No_Thrust:
  ENDIF
LD64C:
       TYA                            ;2
       BEQ    LD65A                   ;2
       BMI    LD659                   ;2
       BPL    LD648                   ;2 always branch

LD653:
       LDX    #$01                    ;2
       CPY    #$40                    ;2
       BEQ    LD65A                   ;2
LD659:
       INY                            ;2
LD65A:
       STY    Write4C                 ;4
       STX    Write01                 ;4

       TYA                            ;2
       CPY    #$80                    ;2
       ROR                            ;2
       STA    rF0+1                   ;3
       TYA                            ;2
       LDY    #$00                    ;2
       CLC                            ;2
       ADC    Read4B                  ;4
       BPL    LD67B                   ;2
LD66F:
       CMP    #$DF                    ;2
       BCS    LD67F                   ;2
       DEY                            ;2
       ADC    #$20                    ;2
       BNE    LD66F                   ;2

LD678:
       INY                            ;2
       SBC    #$20                    ;2
LD67B:
       CMP    #$20                    ;2
       BCS    LD678                   ;2
LD67F:
       STA    Write4B                 ;4
       STY    r98                     ;3
       SEC                            ;2
       LDA    r85                     ;3
       TAY                            ;2
       SBC    rF0+1                   ;3
       AND    #$FE                    ;2
       CPX    #$00                    ;2
       BEQ    LD6A6                   ;2
       CMP    #$52                    ;2
       BEQ    LD6BA                   ;2
       BCC    LD6AC                   ;2
LD696:
       CPY    #$53                    ;2
       BEQ    LD6BA                   ;2
       BCC    LD6B2                   ;2
LD69C:
       DEC    r85                     ;5
       CPY    #$A3                    ;2
       BCS    LD6BA                   ;2
       INC    r98                     ;5
       BCC    LD6BA                   ;2 always branch

LD6A6:
       CMP    #$AE                    ;2
       BEQ    LD6BA                   ;2
       BCS    LD696                   ;2
LD6AC:
       CPY    #$AE                    ;2
       BEQ    LD6BA                   ;2
       BCS    LD69C                   ;2
LD6B2:
       INC    r85                     ;5
       CPY    #$57                    ;2
       BCC    LD6BA                   ;2
       DEC    r98                     ;5
LD6BA:
       LDA    rF0                     ;3
       ASL                            ;2
       ASL                            ;2
       LDY    r99                     ;3
       ASL                            ;2
       BPL    LD6C6                   ;2
       INY                            ;2
       CPY    #$89                    ;2
LD6C6:
       BCC    LD6CD                   ;2
       CPY    #$09                    ;2
       BCC    LD6CD                   ;2
       DEY                            ;2
LD6CD:
       STY    r99                     ;3
LD6CF:
       LDA    rD8                     ;3
       BEQ    LD6D8                   ;2
       DEC    rD8                     ;5
       JMP    LD70A                   ;3

LD6D8:
       LDA    r8E                     ;3
       BNE    LD70A                   ;2
       LDY    INPT4                   ;3
       BMI    LD70A                   ;2
       LDA    #$4C                    ;2
       STA    r90                     ;3
       LDA    #$10                    ;2
       STA    rD8                     ;3
       LDX    Read01                  ;4
       LDA    r85                     ;3
       SEC                            ;2
       SBC    LDF7A,X                 ;4
       LSR                            ;2
       LSR                            ;2
       ORA    LDE30,X                 ;4
       BMI    LD6FF                   ;2
       STA    rF0                     ;3
       LDA    #$27                    ;2
       SEC                            ;2
       SBC    rF0                     ;3
LD6FF:
       STA    rD9                     ;3
       LDA    r99                     ;3
       AND    #$FE                    ;2
       SEC                            ;2
       SBC    #$03                    ;2
       STA    rD7                     ;3
LD70A:
       LDA    rD9                     ;3
       AND    #$7F                    ;2
       TAX                            ;2
       BEQ    LD713                   ;2
       DEC    rD9                     ;5
LD713:
  IF ARCADE_CONTROL
       lda    r84                     ;3
       and    #$01                    ;2
       sta    r84                     ;3
       lda    SWCHA                   ;4
       and    #$FE                    ;2
       ora    r84                     ;3
       sta    r84                     ;3
  ENDIF
       LDA    rD9                     ;3
       BMI    LD737                   ;2
       LDA    #$00                    ;2
       STA    rDA                     ;3
       LDA    LDCA5,X                 ;4
       STA    rDB                     ;3
       LDA    LDC72,X                 ;4
       STA    rDC                     ;3
       LDA    LDC76,X                 ;4
       STA    rDD                     ;3
       LDA    LDCB9,X                 ;4
       STA    rDE                     ;3
       LDA    LDC86,X                 ;4
       STA    rDF                     ;3
       JMP    LD754                   ;3

LD737:
       LDA    #$00                    ;2
       STA    rDF                     ;3
       LDA    LDC85,X                 ;4
       STA    rDA                     ;3
       LDA    LDC84,X                 ;4
       STA    rDB                     ;3
       LDA    LDCB7,X                 ;4
       STA    rDC                     ;3
       LDA    LDCB3,X                 ;4
       STA    rDD                     ;3
       LDA    LDC70,X                 ;4
       STA    rDE                     ;3
LD754:
       LDA    r81                     ;3
       AND    #$0F                    ;2
       TAY                            ;2
       LDA    LDD12,Y                 ;4
       STA    rF0                     ;3
       LDA    #$0F                    ;2
       LDX    r8A                     ;3
       CPX    #$0F                    ;2
       BCS    LD767                   ;2
       TXA                            ;2
LD767:
       STA    rF2                     ;3
       LDY    rAD                     ;3
       BNE    LD79B                   ;2
       ORA    #$05                    ;2
       AND    rF0                     ;3
       BEQ    LD785                   ;2
       LDY    rCE+5                   ;3
       LDA    r9A                     ;3
       CMP    #$8C                    ;2
       BCS    LD799                   ;2
       ADC    LDD58,Y                 ;4
       AND    #$FE                    ;2
       STA    r9A                     ;3
       LDA    LDD68,Y                 ;4
LD785:
       SEC                            ;2
       SBC    r98                     ;3
       CLC                            ;2
       ADC    r86                     ;3
       STA    r86                     ;3
       CMP    #$CF                    ;2
       BCS    LD795                   ;2
       CMP    #$32                    ;2
       BCS    LD799                   ;2
LD795:
       LDA    #$F0                    ;2
       STA    r9A                     ;3
LD799:
       LDA    rA7                     ;3
LD79B:
       BNE    LD7EA                   ;2
       LDA    r8E                     ;3
       BNE    LD7EA                   ;2
       LDA    r9A                     ;3
       CMP    #$8C                    ;2
       BCC    LD7F0                   ;2
       LDX    rA3                     ;3
       BEQ    LD7EA                   ;2
LD7AB:
       DEX                            ;2
       BEQ    LD7EA                   ;2
       LDY    Read42,X                ;4
       LDA    Read22,Y                ;4
       CMP    #$09                    ;2
       BEQ    LD7C4                   ;2
       CMP    #$01                    ;2
       BEQ    LD7C4                   ;2
       CMP    #$0D                    ;2
       BEQ    LD7C4                   ;2
       CMP    #$04                    ;2
       BNE    LD7AB                   ;2
LD7C4:
       LDA    r80                     ;3
       AND    #$03                    ;2
       STA    rCE+5                   ;3
       LDA    Read02,Y                ;4
       ADC    #$03                    ;2
       CMP    #$C6                    ;2
       BCS    LD7EA                   ;2
       STA    r86                     ;3
       CMP    r85                     ;3
       ROL    rCE+5                   ;5
       LDA.wy rE0,Y                   ;4
       SBC    #$03                    ;2
       STA    r9A                     ;3
       CMP    r99                     ;3
       ROL    rCE+5                   ;5
       LDA    #$B9                    ;2
       STA    r90                     ;3
       BNE    LD7F0                   ;2 always branch

LD7EA:
       LDA    #$CF                    ;2
       STA    r86                     ;3
       STA    r9A                     ;3
LD7F0:
       LDA    r8E                     ;3
;       BEQ    LD7F7                   ;2
;       JMP    LD86E                   ;3 BNE OK...tho it crosses a page
       bne    LD86E                   ;3
;LD7F7:
       LDX    #$0F                    ;2
LD7F9:
       LDY    Read22,X                ;4
       LDA    LDD22,Y                 ;4
       ORA    rF2                     ;3
       AND    rF0                     ;3
       BEQ    LD813                   ;2
       LDY    Read12,X                ;4
       LDA    rE0,X                   ;4
       CLC                            ;2
       ADC    LDD47,Y                 ;4
       STA    rE0,X                   ;4
       LDA    LDD36,Y                 ;4
LD813:
       LDY    Read02,X                ;4
       STY    rF0+1                   ;3
       SEC                            ;2
       SBC    r98                     ;3
       CLC                            ;2
       BPL    LD842                   ;2
       ADC    Read02,X                ;4
       STA    Write02,X               ;5
       LDA    Read32,X                ;4
       ADC    #$FF                    ;2
       AND    #$03                    ;2
       BNE    LD83A                   ;2
       LDY    Read32,X                ;4
       BEQ    LD83A                   ;2
       LDY    rD5                     ;3
       CPY    #$05                    ;2
       BCS    LD866                   ;2
       INC    rD5                     ;5
LD83A:
       STA    Write32,X               ;5
       DEX                            ;2
       BPL    LD7F9                   ;2
       BMI    LD86E                   ;2 always branch

LD842:
       ADC    Read02,X                ;4
       STA    Write02,X               ;5
       LDA    Read32,X                ;4
       ADC    #$00                    ;2
       AND    #$03                    ;2
       BNE    LD85E                   ;2
       LDY    Read32,X                ;4
       BEQ    LD85E                   ;2
       LDY    rD5                     ;3
       CPY    #$05                    ;2
       BCS    LD866                   ;2
       INC    rD5                     ;5
LD85E:
       STA    Write32,X               ;5
       DEX                            ;2
       BPL    LD7F9                   ;2
       BMI    LD86E                   ;2 always branch

LD866:
       LDA    rF0+1                   ;3
       STA    Write02,X               ;5
       DEX                            ;2
       BPL    LD7F9                   ;2
LD86E:
       LDX    Read79                  ;4
       BPL    LD88D                   ;2
       LDY    Read7A                  ;4
       LDX    LDCFA,Y                 ;4
       LDY    #$06                    ;2
       LDA    #$00                    ;2
LD87D:
       STA    Write4F,X               ;5
       INX                            ;2
       DEY                            ;2
       BNE    LD87D                   ;2
       LDX    #$0E                    ;2Removed Stargate blip as per SuperCat/JohnnyWC(Was $0F)
       LDA    r81                     ;3
       AND    #$08                    ;2
       BEQ    LD88D                   ;2
       INX                            ;2
LD88D:
       DEX                            ;2
       BMI    LD8E7                   ;2
       LDA    Read22,X                ;4
       BEQ    LD88D                   ;2
       LDA    Read02,X                ;4
       ASL                            ;2
       LDA    Read32,X                ;4
       ROL                            ;2
       CMP    Read7A                  ;4
       BNE    LD88D                   ;2
       STX    Write79                 ;4
       LDA    Read02,X                ;4
       AND    #$7F                    ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAY                            ;2
       LDA    LDCEA,Y                 ;4
       STA    rF0                     ;3
       LDA    LDCEE,Y                 ;4
       STA    rF0+1                   ;3
       LDA    rE0,X                   ;4
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       LDA    LDCD8,X                 ;4
       LDY    Read7A                  ;4
       CLC                            ;2
       ADC    LDCFA,Y                 ;4
       TAX                            ;2
       LDA    Read4E,X                ;4
       ORA    rF0                     ;3
       STA    Write4E,X               ;5
       LDY    Read79                  ;4
       LDA    Read22,Y                ;4
       CMP    #$0D                    ;2
       BNE    LD90B                   ;2
       LDA    Read4D,X                ;4
       ORA    rF0+1                   ;3
       STA    Write4D,X               ;5
       BNE    LD90B                   ;2
LD8E7:
       STX    Write79                 ;4
       LDX    Read7A                  ;4
       LDY    LDCF2,X                 ;4
       STY    Write7A                 ;4
       LDA    LDD02,Y                 ;4
       AND    rD6                     ;3
       BEQ    LD905                   ;2
       LDA    Read00                  ;4
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       LDA    LDD0A,X                 ;4
LD905:
       LDX    LDCFA,Y                 ;4
       STA    Write4E,X               ;5
LD90B:
       LDA    $0285                   ;4
       BPL    LD90B                   ;2
       LDA    #$02                    ;2
       STA    WSYNC                   ;3
       STA    VSYNC                   ;3
       LDA    r80                     ;3
       ASL                            ;2
       EOR    r80                     ;3
       ASL                            ;2
       EOR    r80                     ;3
       ASL                            ;2
       ASL                            ;2
       EOR    r80                     ;3
       ASL                            ;2
       ROL    r80                     ;5
       LDY    r99                     ;3
       LDA    rAB                     ;3
       BEQ    LD93A                   ;2
       LDA    r81                     ;3
       AND    #$03                    ;2
       BEQ    LD935                   ;2
       LDY    #$00                    ;2
       BEQ    LD93A                   ;2 always branch

LD935:
       DEC    rAB                     ;5
       STA    Write4A                 ;4
LD93A:
       STY    rF0                     ;3
       LDX    rAF                     ;3
       LDA    LDE17,X                 ;4
       STA    r94+1                   ;3
       LDA    #$00                    ;2
       STA    r94                     ;3
       LDA    LDE20,X                 ;4
       SEC                            ;2
       SBC    rF0                     ;3
       STA    r96                     ;3
       LDA    rF0                     ;3
       ADC    #$05                    ;2
       STA    r96+1                   ;3
       LDX    #$01                    ;2
LD957:
       LDA    r87,X                   ;4
       SEC                            ;2
       SBC    r98                     ;3
       CMP    #$30                    ;2
       BCC    LD964                   ;2
       CMP    #$D0                    ;2
       BCC    LD966                   ;2
LD964:
       EOR    #$E0                    ;2
LD966:
       STA    r87,X                   ;4
       DEX                            ;2
       BPL    LD957                   ;2
       LDA    #$FE                    ;2
       STA    r9B+1                   ;3
       LDA    #$00                    ;2
       CLC                            ;2
       ADC    rA9                     ;3
       STA    r9B                     ;3
       LDA    r81                     ;3
       AND    #$01                    ;2
       TAX                            ;2
       LDY    r90,X                   ;4
       LDA    LDE7A,Y                 ;4
       BNE    LD98B                   ;2
       LDY    r92,X                   ;4
       STY    r90,X                   ;4
       STA    r92,X                   ;4
       JMP    LD99F                   ;3

LD98B:
       INC    r90,X                   ;6
       CMP    #$10                    ;2
       BEQ    LD99D                   ;2
       BCS    LD997                   ;2
       STA    AUDC0,X                 ;4
       BCC    LD99F                   ;2 always branch

LD997:
       STA    AUDF0,X                 ;4
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
LD99D:
       STA    AUDV0,X                 ;4
LD99F:
       LDA    #$00                    ;2
       STA    WSYNC                   ;3
       STA    VSYNC                   ;3
       LDA    #$2A                    ;2
       STA    TIM64T                  ;4
       LDX    Read7C                  ;4
       BEQ    LD9CA                   ;2
       DEX                            ;2
       STX    Write7C                 ;4
       LDA    #$06                    ;2
       STA    AUDC0                   ;3
       ASL                            ;2
       STA    AUDF0                   ;3
       LDA    #$01                    ;2
       STA    AUDC1                   ;3
       LDA    #$1A                    ;2
       STA    AUDF1                   ;3
       TXA                            ;2
       STA    AUDV0                   ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       STA    AUDV1                   ;3
LD9CA:
       INC    r81                     ;5
       BNE    LD9D9                   ;2
       LDX    Read7D                  ;4
       INX                            ;2
       BNE    LD9D6                   ;2
       LDX    #$80                    ;2
LD9D6:
       STX    Write7D                 ;4
LD9D9:
       LDA    r81                     ;3
       LSR                            ;2
       BCC    LDA20                   ;2
       LDX    #$00                    ;2
       LDY    #$0F                    ;2
LD9E2:
       LDA    Read22,Y                ;4
       BEQ    LD9EF                   ;2
       LDA    Read32,Y                ;4
       BNE    LD9EF                   ;2
       STY    rCE,X                   ;4
       INX                            ;2
LD9EF:
       DEY                            ;2
       BPL    LD9E2                   ;2
       STX    Write7B                 ;4
       STX    rD5                     ;3
       TXA                            ;2
       BEQ    LDA1D                   ;2
       STX    rF0                     ;3
LD9FC:
       DEC    rF0                     ;5
       BEQ    LDA1D                   ;2
       LDY    #$00                    ;2
LDA02:
       LDX    rCE,Y                   ;4
       LDA    rE0,X                   ;4
       INY                            ;2
       LDX    rCE,Y                   ;4
       CMP    rE0,X                   ;4
       BCC    LDA17                   ;2
       DEY                            ;2
       LDA.wy rCE,Y                   ;4
       STX    rCE,Y                   ;4
       INY                            ;2
       STA.wy rCE,Y                   ;5
LDA17:
       CPY    rF0                     ;3
       BNE    LDA02                   ;2
       BEQ    LD9FC                   ;2 always branch

LDA1D:
       JMP    LDB9B                   ;3

LDA20:
       LDA    rA7                     ;3
       BNE    LDA6D                   ;2
       LDA    r80                     ;3
       AND    #$03                    ;2
       STA    rF0                     ;3
       LDY    Read7B                  ;4
LDA2D:
       DEY                            ;2
       BMI    LDA6D                   ;2
       LDX    rCE,Y                   ;4
       LDA    Read22,X                ;4
       CMP    #$09                    ;2
       BCS    LDA2D                   ;2
       STY    rF2                     ;3
       TAY                            ;2
       LDA    #$00                    ;2
       STA    rF0+1                   ;3
       LDA    Read02,X                ;4
       CMP    r85                     ;3
       ROL    rF0+1                   ;5
       LDA    Read02,X                ;4
       EOR    r85                     ;3
       AND    LDE28,Y                 ;4
       BNE    LDA64                   ;2
       LDA    rE0,X                   ;4
       CMP    r99                     ;3
       LDA    rF0+1                   ;3
       ROL                            ;2
       ASL                            ;2
       ASL                            ;2
       ORA    rF0                     ;3
LDA5C:
       STA    Write12,X               ;5
       LDY    rF2                     ;3
       JMP    LDA2D                   ;3

LDA64:
       ROR    rF0+1                   ;5
       LDA    #$04                    ;2
       BCC    LDA5C                   ;2
       ASL                            ;2
       BCC    LDA5C                   ;2
LDA6D:
       LDX    #$09                    ;2
LDA6F:
       DEX                            ;2
       BPL    LDA75                   ;2
       JMP    LDB30                   ;3

LDA75:
       LDA    Read22,X                ;4
       CMP    #$09                    ;2
       BEQ    LDAE1                   ;2
       CMP    #$0E                    ;2
       BEQ    LDAA3                   ;2
       CMP    #$0D                    ;2
       BEQ    LDACF                   ;2
       CMP    #$0F                    ;2
       BNE    LDA6F                   ;2
       LDA    #$0C                    ;2
       STA    Write12,X               ;5
       LDA    rE0,X                   ;4
       CMP    #$1B                    ;2
       BCS    LDA6F                   ;2
       LDA    #$11                    ;2
       STA    Write22,X               ;5
       LDA    #$0F                    ;2
       STA    rA5                     ;3
LDA9C:
       LDA    #$05                    ;2
       STA    r91                     ;3
LDAA0:
       JMP    LDA6F                   ;3

LDAA3:
       LDA    #$0C                    ;2
       STA    Write12,X               ;5
       LDA    rE0,X                   ;4
       CMP    #$1B                    ;2
       BCS    LDA6F                   ;2
       LDA    #$00                    ;2
       STA    Write22,X               ;5
       LDA    Read02,X                ;4
       ASL                            ;2
       LDA    Read32,X                ;4
       ROL                            ;2
       TAX                            ;2
       JSR    LDC39                   ;6
       LDA    #$02                    ;2
       STA    rF0+1                   ;3
       LDA    #$50                    ;2
       JSR    LDC4E                   ;6
       LDA    #$E0                    ;2
ldA6f_branch:
       STA    r91                     ;3
;       JMP    LDA6F                   ;3 could use a BNE here instead
       bne    LDA6F                   ;2

LDACF:
       LDA    #$00                    ;2
       STA    Write12,X               ;5
       LDA    rE0,X                   ;4
       CMP    #$84                    ;2
       BCC    LDA6F                   ;2
       LDA    #$04                    ;2
       STA    Write22,X               ;5
       BNE    LDA9C                   ;2 always branch

LDAE1:
       TXA                            ;2
       AND    #$01                    ;2
       TAY                            ;2
       LDA    rE0,X                   ;4
       CMP    #$1D                    ;2
       BCS    LDB27                   ;2
       LDA    r80                     ;3
       BMI    LDA6F                   ;2
       LDA    LDFFA,Y                 ;4
       STA    Write12,X               ;5
       LDA    Read00                  ;4
       AND    #$7C                    ;2
       STA    rF0                     ;3
       LDA    Read02,X                ;4
       AND    #$7C                    ;2
       CMP    rF0                     ;3
       BNE    LDAA0                   ;2
       LDA    Read02,X                ;4
       ASL                            ;2
       LDA    Read32,X                ;4
       ROL                            ;2
       TAY                            ;2
       LDA    rD6                     ;3
       AND    LDD02,Y                 ;4
       BEQ    LDAA0                   ;2
       EOR    #$FF                    ;2
       AND    rD6                     ;3
       STA    rD6                     ;3
       LDA    #$0D                    ;2
       STA    Write22,X               ;5
       LDA    #$6B                    ;2
;       STA    r91                     ;3
;       JMP    LDA6F                   ;3could BNE to the lines above LDACF (kills STA and JMP)
       bne    ldA6f_branch            ;2

LDB27:
       LDA    LDFFE,Y                 ;4
       STA    Write12,X               ;5
       JMP    LDA6F                   ;3

LDB30:
       LDY    Read7B                  ;4
       BEQ    LDB6D                   ;2
       DEY                            ;2
       DEY                            ;2
LDB37:
       INY                            ;2
LDB38:
       CPY    #$02                    ;2
       BCC    LDB6D                   ;2
       STY    rF0                     ;3
       LDX    rCE,Y                   ;4
       STX    rF0+1                   ;3
       LDA    rE0,X                   ;4
       DEY                            ;2
       DEY                            ;2
       LDX    rCE,Y                   ;4
       SEC                            ;2
       SBC    rE0,X                   ;4
       CMP    #$15                    ;2
       BCS    LDB37                   ;2
       DEC    rE0,X                   ;6
       LDY    Read22,X                ;4
       LDA    LDDB1,Y                 ;4
       STA    Write12,X               ;5
       LDX    rF0+1                   ;3
       INC    rE0,X                   ;6
       LDY    Read22,X                ;4
       LDA    LDD8B,Y                 ;4
       STA    Write12,X               ;5
       LDY    rF0                     ;3
       DEY                            ;2
       JMP    LDB38                   ;3

LDB6D:
       LDX    #$19                    ;2
       LDA    rA9                     ;3
       BEQ    LDB75                   ;2
       LDX    #$11                    ;2
LDB75:
       STX    rF0                     ;3
       LDX    #$0E                    ;2
LDB79:
       LDY    Read22,X                ;4
       LDA    rE0,X                   ;4
       CMP    #$86                    ;2
       BCC    LDB8C                   ;2
       DEC    rE0,X                   ;6
       LDA    LDD9E,Y                 ;4
       STA    Write12,X               ;5
       BCS    LDB98                   ;2
LDB8C:
       CMP    rF0                     ;3
       BCS    LDB98                   ;2
       INC    rE0,X                   ;6
       LDA    LDD78,Y                 ;4
       STA    Write12,X               ;5
LDB98:
       DEX                            ;2
       BPL    LDB79                   ;2
LDB9B:
       LDA    Read7B                  ;4
       BEQ    LDBC0                   ;2
       STA    rF0+1                   ;3
       LDX    #$00                    ;2
       STX    rA2                     ;3
LDBA6:
       LDY    rCE,X                   ;4
       LDA    Read02,Y                ;4
       CMP    #$30                    ;2
       BCC    LDBBB                   ;2
       CMP    #$D0                    ;2
       BCS    LDBBB                   ;2
       TYA                            ;2
       LDY    rA2                     ;3
       STA    Write43,Y               ;5
       INC    rA2                     ;5
LDBBB:
       INX                            ;2
       CPX    rF0+1                   ;3
       BNE    LDBA6                   ;2
LDBC0:
       LDY    rA2                     ;3
;       BNE    LDBC7                   ;2
;       JMP    LDBF9                   ;3 could just BEQ instead (kills above BNE line)
       beq    LDBF9                   ;2
;LDBC7:
       DEY                            ;2
LDBC8:
       TYA                            ;2
       BEQ    LDBF9                   ;2
       LDX    Read43,Y                ;4
       LDA    Read22,X                ;4
       STA    rF0                     ;3
       LDA    rE0,X                   ;4
       DEY                            ;2
       LDX    Read43,Y                ;4
       CLC                            ;2
       ADC    #$08                    ;2
       SEC                            ;2
       SBC    rE0,X                   ;4
       LDX    rF0                     ;3
       CMP    LDDC4,X                 ;4
       BCS    LDBC8                   ;2
       STY    rF0                     ;3
       LDA    r81                     ;3
       EOR    rF0                     ;3
       AND    #$01                    ;2
       ADC    rF0                     ;3
       TAX                            ;2
       LDA    #$FF                    ;2
       STA    Write43,X               ;5
;       JMP    LDBC8                   ;3 could BNE or BMI instead
       bne    LDBC8                   ;2 always branch

LDBF9:
       LDA    #$6C                    ;2
       STA    rEF                     ;3 never used?
       LDA    Read00                  ;4
       SEC                            ;2
       SBC    r98                     ;3
       STA    Write00                 ;4
       BPL    LDC1C                   ;2
       AND    #$7F                    ;2
       STA    Write00                 ;4
       LDA    rD6                     ;3
       LDY    r98                     ;3
       BMI    LDC19                   ;2
       LSR                            ;2
       ROR    rD6                     ;5
       JMP    LDC1C                   ;3

LDC19:
       ASL                            ;2
       ROL    rD6                     ;5
LDC1C:
       LDX    #$00                    ;2
       LDA    Read00                  ;4
       CMP    #$30                    ;2
       BCC    LDC2E                   ;2
       CMP    #$50                    ;2
       BCS    LDC2F                   ;2
       LDA    r81                     ;3
       LSR                            ;2
       BCS    LDC2F                   ;2
LDC2E:
       INX                            ;2
LDC2F:
       LDY    #$00                    ;2
       LDA    rD6                     ;3
       AND    LDD02,X                 ;4
       JMP    LDFF2                   ;3

LDC39:
       DEX                            ;2
LDC3A:
       INX                            ;2
       TXA                            ;2
       AND    #$07                    ;2
       TAX                            ;2
       LDA    rD6                     ;3
       AND    LDD02,X                 ;4
       BNE    LDC3A                   ;2
       LDA    LDD02,X                 ;4
       ORA    rD6                     ;3
       STA    rD6                     ;3
       RTS                            ;6

LDC4E:
       SED                            ;2
       CLC                            ;2
       ADC    r8D                     ;3
       STA    r8D                     ;3
       LDA    rF0+1                   ;3
LDC56:
       SED                            ;2
       ADC    r8C                     ;3
       STA    r8C                     ;3
       BCC    LDC6D                   ;2
       LDA    #$00                    ;2
       ADC    r8B                     ;3
       STA    r8B                     ;3
       INC    r82                     ;5
       INC    r83                     ;5
;       INC    r84                     ;5 No Inviso in Defender
       LDA    #$8B                    ;2
       STA    r93                     ;3
LDC6D:
       CLD                            ;2
       RTS                            ;6



;       ORG  $1C35
;       RORG $DC35
;free space


       ORG  $1C6F
       RORG $DC6F

LDC6F:
       .byte $09 ; |    X  X| $DC6F
LDC70:
       .byte $00 ; |        | $DC70
       .byte $00 ; |        | $DC71
LDC72:
       .byte $00 ; |        | $DC72
       .byte $00 ; |        | $DC73
       .byte $00 ; |        | $DC74
       .byte $00 ; |        | $DC75
LDC76:
       .byte $00 ; |        | $DC76
       .byte $00 ; |        | $DC77
       .byte $00 ; |        | $DC78
       .byte $00 ; |        | $DC79
       .byte $00 ; |        | $DC7A
       .byte $00 ; |        | $DC7B
       .byte $00 ; |        | $DC7C
       .byte $00 ; |        | $DC7D
       .byte $00 ; |        | $DC7E
       .byte $00 ; |        | $DC7F
       .byte $00 ; |        | $DC80
       .byte $00 ; |        | $DC81
       .byte $00 ; |        | $DC82
       .byte $00 ; |        | $DC83
LDC84:
       .byte $00 ; |        | $DC84
LDC85:
       .byte $00 ; |        | $DC85
LDC86:
       .byte $00 ; |        | $DC86
       .byte $80 ; |X       | $DC87
       .byte $C0 ; |XX      | $DC88
       .byte $E0 ; |XXX     | $DC89
       .byte $F0 ; |XXXX    | $DC8A
       .byte $F8 ; |XXXXX   | $DC8B
       .byte $FC ; |XXXXXX  | $DC8C
       .byte $FE ; |XXXXXXX | $DC8D
       .byte $FF ; |XXXXXXXX| $DC8E
       .byte $FF ; |XXXXXXXX| $DC8F
       .byte $FF ; |XXXXXXXX| $DC90
       .byte $FF ; |XXXXXXXX| $DC91
       .byte $FF ; |XXXXXXXX| $DC92
       .byte $FF ; |XXXXXXXX| $DC93
       .byte $FF ; |XXXXXXXX| $DC94
       .byte $FF ; |XXXXXXXX| $DC95
       .byte $FF ; |XXXXXXXX| $DC96
       .byte $FF ; |XXXXXXXX| $DC97
       .byte $FF ; |XXXXXXXX| $DC98
       .byte $FF ; |XXXXXXXX| $DC99
       .byte $FF ; |XXXXXXXX| $DC9A
       .byte $FF ; |XXXXXXXX| $DC9B
       .byte $FF ; |XXXXXXXX| $DC9C
       .byte $3F ; |  XXXXXX| $DC9D
       .byte $0F ; |    XXXX| $DC9E
       .byte $03 ; |      XX| $DC9F
       .byte $00 ; |        | $DCA0
       .byte $00 ; |        | $DCA1
       .byte $00 ; |        | $DCA2
       .byte $00 ; |        | $DCA3
       .byte $00 ; |        | $DCA4
LDCA5:
       .byte $00 ; |        | $DCA5
       .byte $00 ; |        | $DCA6
       .byte $00 ; |        | $DCA7
       .byte $00 ; |        | $DCA8
       .byte $00 ; |        | $DCA9
       .byte $00 ; |        | $DCAA
       .byte $00 ; |        | $DCAB
       .byte $00 ; |        | $DCAC
       .byte $00 ; |        | $DCAD
       .byte $00 ; |        | $DCAE
       .byte $00 ; |        | $DCAF
       .byte $00 ; |        | $DCB0
       .byte $00 ; |        | $DCB1
       .byte $00 ; |        | $DCB2
LDCB3:
       .byte $00 ; |        | $DCB3
       .byte $00 ; |        | $DCB4
       .byte $00 ; |        | $DCB5
       .byte $00 ; |        | $DCB6
LDCB7:
       .byte $00 ; |        | $DCB7
       .byte $00 ; |        | $DCB8
LDCB9:
       .byte $00 ; |        | $DCB9
       .byte $00 ; |        | $DCBA
       .byte $00 ; |        | $DCBB
       .byte $00 ; |        | $DCBC
       .byte $00 ; |        | $DCBD
       .byte $00 ; |        | $DCBE
       .byte $00 ; |        | $DCBF
       .byte $00 ; |        | $DCC0
       .byte $00 ; |        | $DCC1
       .byte $01 ; |       X| $DCC2
       .byte $03 ; |      XX| $DCC3
       .byte $07 ; |     XXX| $DCC4
       .byte $0F ; |    XXXX| $DCC5
       .byte $1F ; |   XXXXX| $DCC6
       .byte $3F ; |  XXXXXX| $DCC7
       .byte $7F ; | XXXXXXX| $DCC8
       .byte $FF ; |XXXXXXXX| $DCC9
       .byte $FF ; |XXXXXXXX| $DCCA
       .byte $FF ; |XXXXXXXX| $DCCB
       .byte $FF ; |XXXXXXXX| $DCCC
       .byte $FF ; |XXXXXXXX| $DCCD
       .byte $FF ; |XXXXXXXX| $DCCE
       .byte $FF ; |XXXXXXXX| $DCCF
       .byte $FF ; |XXXXXXXX| $DCD0
       .byte $FF ; |XXXXXXXX| $DCD1
       .byte $FF ; |XXXXXXXX| $DCD2
       .byte $FF ; |XXXXXXXX| $DCD3
       .byte $FC ; |XXXXXX  | $DCD4
       .byte $F0 ; |XXXX    | $DCD5
       .byte $C0 ; |XX      | $DCD6
       .byte $00 ; |        | $DCD7
LDCD8:
       .byte $FF ; |XXXXXXXX| $DCD8
       .byte $00 ; |        | $DCD9
       .byte $00 ; |        | $DCDA
       .byte $01 ; |       X| $DCDB
       .byte $01 ; |       X| $DCDC
       .byte $02 ; |      X | $DCDD
       .byte $02 ; |      X | $DCDE
       .byte $03 ; |      XX| $DCDF
       .byte $03 ; |      XX| $DCE0
       .byte $03 ; |      XX| $DCE1
       .byte $04 ; |     X  | $DCE2
       .byte $04 ; |     X  | $DCE3
       .byte $05 ; |     X X| $DCE4
       .byte $05 ; |     X X| $DCE5
       .byte $06 ; |     XX | $DCE6
       .byte $06 ; |     XX | $DCE7
       .byte $06 ; |     XX | $DCE8
       .byte $06 ; |     XX | $DCE9
LDCEA:
       .byte $C0 ; |XX      | $DCEA
       .byte $30 ; |  XX    | $DCEB
       .byte $0C ; |    XX  | $DCEC
       .byte $03 ; |      XX| $DCED
LDCEE:
       .byte $80 ; |X       | $DCEE
       .byte $20 ; |  X     | $DCEF
       .byte $08 ; |    X   | $DCF0
       .byte $02 ; |      X | $DCF1
LDCF2:
       .byte $01 ; |       X| $DCF2
       .byte $02 ; |      X | $DCF3
       .byte $03 ; |      XX| $DCF4
       .byte $06 ; |     XX | $DCF5
       .byte $00 ; |        | $DCF6
       .byte $00 ; |        | $DCF7
       .byte $07 ; |     XXX| $DCF8
       .byte $00 ; |        | $DCF9
LDCFA:
       .byte $0F ; |    XXXX| $DCFA
       .byte $16 ; |   X XX | $DCFB
       .byte $1D ; |   XXX X| $DCFC
       .byte $24 ; |  X  X  | $DCFD
       .byte $00 ; |        | $DCFE
       .byte $00 ; |        | $DCFF
       .byte $01 ; |       X| $DD00
       .byte $08 ; |    X   | $DD01
LDD02:
       .byte $01 ; |       X| $DD02
       .byte $02 ; |      X | $DD03
       .byte $04 ; |     X  | $DD04
       .byte $08 ; |    X   | $DD05
       .byte $10 ; |   X    | $DD06
       .byte $20 ; |  X     | $DD07
       .byte $40 ; | X      | $DD08
       .byte $80 ; |X       | $DD09
LDD0A:
       .byte $80 ; |X       | $DD0A
       .byte $40 ; | X      | $DD0B
       .byte $20 ; |  X     | $DD0C
       .byte $10 ; |   X    | $DD0D
       .byte $08 ; |    X   | $DD0E
       .byte $04 ; |     X  | $DD0F
       .byte $02 ; |      X | $DD10
       .byte $01 ; |       X| $DD11
LDD12:
       .byte $01 ; |       X| $DD12
       .byte $08 ; |    X   | $DD13
       .byte $04 ; |     X  | $DD14
       .byte $08 ; |    X   | $DD15
       .byte $02 ; |      X | $DD16
       .byte $08 ; |    X   | $DD17
       .byte $04 ; |     X  | $DD18
       .byte $08 ; |    X   | $DD19
       .byte $00 ; |        | $DD1A
       .byte $08 ; |    X   | $DD1B
       .byte $04 ; |     X  | $DD1C
       .byte $08 ; |    X   | $DD1D
       .byte $02 ; |      X | $DD1E
       .byte $08 ; |    X   | $DD1F
       .byte $04 ; |     X  | $DD20
       .byte $08 ; |    X   | $DD21
LDD22:
       .byte $00 ; |        | $DD22
       .byte $0B ; |    X XX| $DD23
       .byte $09 ; |    X  X| $DD24
       .byte $08 ; |    X   | $DD25
       .byte $06 ; |     XX | $DD26
       .byte $07 ; |     XXX| $DD27
       .byte $05 ; |     X X| $DD28
       .byte $06 ; |     XX | $DD29
       .byte $09 ; |    X  X| $DD2A
       .byte $03 ; |      XX| $DD2B
       .byte $03 ; |      XX| $DD2C
       .byte $03 ; |      XX| $DD2D
       .byte $06 ; |     XX | $DD2E
       .byte $03 ; |      XX| $DD2F
       .byte $04 ; |     X  | $DD30
       .byte $04 ; |     X  | $DD31
       .byte $00 ; |        | $DD32
       .byte $00 ; |        | $DD33
       .byte $00 ; |        | $DD34
       .byte $00 ; |        | $DD35
LDD36:
       .byte $00 ; |        | $DD36
       .byte $01 ; |       X| $DD37
       .byte $01 ; |       X| $DD38
       .byte $02 ; |      X | $DD39
       .byte $02 ; |      X | $DD3A
       .byte $02 ; |      X | $DD3B
       .byte $01 ; |       X| $DD3C
       .byte $01 ; |       X| $DD3D
       .byte $FE ; |XXXXXXX | $DD3E
       .byte $FE ; |XXXXXXX | $DD3F
       .byte $FF ; |XXXXXXXX| $DD40
       .byte $FF ; |XXXXXXXX| $DD41
       .byte $00 ; |        | $DD42
       .byte $FF ; |XXXXXXXX| $DD43
       .byte $FF ; |XXXXXXXX| $DD44
       .byte $FE ; |XXXXXXX | $DD45
       .byte $00 ; |        | $DD46
LDD47:
       .byte $01 ; |       X| $DD47
       .byte $02 ; |      X | $DD48
       .byte $01 ; |       X| $DD49
       .byte $01 ; |       X| $DD4A
       .byte $00 ; |        | $DD4B
       .byte $FF ; |XXXXXXXX| $DD4C
       .byte $FF ; |XXXXXXXX| $DD4D
       .byte $FE ; |XXXXXXX | $DD4E
       .byte $00 ; |        | $DD4F
       .byte $01 ; |       X| $DD50
       .byte $01 ; |       X| $DD51
       .byte $02 ; |      X | $DD52
       .byte $FF ; |XXXXXXXX| $DD53
       .byte $FE ; |XXXXXXX | $DD54
       .byte $FF ; |XXXXXXXX| $DD55
       .byte $FF ; |XXXXXXXX| $DD56
       .byte $00 ; |        | $DD57
LDD58:
       .byte $02 ; |      X | $DD58
       .byte $FE ; |XXXXXXX | $DD59
       .byte $02 ; |      X | $DD5A
       .byte $FE ; |XXXXXXX | $DD5B
       .byte $02 ; |      X | $DD5C
       .byte $FE ; |XXXXXXX | $DD5D
       .byte $02 ; |      X | $DD5E
       .byte $FE ; |XXXXXXX | $DD5F
       .byte $04 ; |     X  | $DD60
       .byte $FC ; |XXXXXX  | $DD61
       .byte $04 ; |     X  | $DD62
       .byte $FC ; |XXXXXX  | $DD63
       .byte $02 ; |      X | $DD64
       .byte $FE ; |XXXXXXX | $DD65
       .byte $02 ; |      X | $DD66
       .byte $FE ; |XXXXXXX | $DD67
LDD68:
       .byte $01 ; |       X| $DD68
       .byte $01 ; |       X| $DD69
       .byte $FF ; |XXXXXXXX| $DD6A
       .byte $FF ; |XXXXXXXX| $DD6B
       .byte $02 ; |      X | $DD6C
       .byte $02 ; |      X | $DD6D
       .byte $FE ; |XXXXXXX | $DD6E
       .byte $FE ; |XXXXXXX | $DD6F
       .byte $01 ; |       X| $DD70
       .byte $01 ; |       X| $DD71
       .byte $FF ; |XXXXXXXX| $DD72
       .byte $FF ; |XXXXXXXX| $DD73
       .byte $00 ; |        | $DD74
       .byte $00 ; |        | $DD75
       .byte $00 ; |        | $DD76
       .byte $00 ; |        | $DD77
LDD78:
       .byte $00 ; |        | $DD78
       .byte $09 ; |    X  X| $DD79
       .byte $03 ; |      XX| $DD7A
       .byte $0B ; |    X XX| $DD7B
       .byte $03 ; |      XX| $DD7C
       .byte $09 ; |    X  X| $DD7D
       .byte $03 ; |      XX| $DD7E
       .byte $0B ; |    X XX| $DD7F
       .byte $09 ; |    X  X| $DD80
       .byte $09 ; |    X  X| $DD81
       .byte $02 ; |      X | $DD82
       .byte $0A ; |    X X | $DD83
       .byte $0A ; |    X X | $DD84
       .byte $00 ; |        | $DD85
       .byte $00 ; |        | $DD86
       .byte $00 ; |        | $DD87
       .byte $10 ; |   X    | $DD88
       .byte $00 ; |        | $DD89
       .byte $00 ; |        | $DD8A
LDD8B:
       .byte $00 ; |        | $DD8B
       .byte $0A ; |    X X | $DD8C
       .byte $02 ; |      X | $DD8D
       .byte $0A ; |    X X | $DD8E
       .byte $02 ; |      X | $DD8F
       .byte $0A ; |    X X | $DD90
       .byte $02 ; |      X | $DD91
       .byte $0A ; |    X X | $DD92
       .byte $0A ; |    X X | $DD93
       .byte $0A ; |    X X | $DD94
       .byte $0A ; |    X X | $DD95
       .byte $02 ; |      X | $DD96
       .byte $03 ; |      XX| $DD97
       .byte $00 ; |        | $DD98
       .byte $00 ; |        | $DD99
       .byte $00 ; |        | $DD9A
       .byte $10 ; |   X    | $DD9B
       .byte $00 ; |        | $DD9C
       .byte $00 ; |        | $DD9D
LDD9E:
       .byte $00 ; |        | $DD9E
       .byte $0F ; |    XXXX| $DD9F
       .byte $05 ; |     X X| $DDA0
       .byte $0D ; |    XX X| $DDA1
       .byte $05 ; |     X X| $DDA2
       .byte $0F ; |    XXXX| $DDA3
       .byte $05 ; |     X X| $DDA4
       .byte $0D ; |    XX X| $DDA5
       .byte $0F ; |    XXXX| $DDA6
       .byte $0F ; |    XXXX| $DDA7
       .byte $06 ; |     XX | $DDA8
       .byte $0C ; |    XX  | $DDA9
       .byte $05 ; |     X X| $DDAA
       .byte $0C ; |    XX  | $DDAB
       .byte $0C ; |    XX  | $DDAC
       .byte $0C ; |    XX  | $DDAD
       .byte $10 ; |   X    | $DDAE
       .byte $0C ; |    XX  | $DDAF
       .byte $0C ; |    XX  | $DDB0
LDDB1:
       .byte $0C ; |    XX  | $DDB1
       .byte $0E ; |    XXX | $DDB2
       .byte $06 ; |     XX | $DDB3
       .byte $0E ; |    XXX | $DDB4
       .byte $06 ; |     XX | $DDB5
       .byte $0E ; |    XXX | $DDB6
       .byte $06 ; |     XX | $DDB7
       .byte $0E ; |    XXX | $DDB8
       .byte $06 ; |     XX | $DDB9
       .byte $0E ; |    XXX | $DDBA
       .byte $0E ; |    XXX | $DDBB
       .byte $0D ; |    XX X| $DDBC
       .byte $0E ; |    XXX | $DDBD
       .byte $0C ; |    XX  | $DDBE
       .byte $0C ; |    XX  | $DDBF
       .byte $0C ; |    XX  | $DDC0
       .byte $10 ; |   X    | $DDC1
       .byte $0C ; |    XX  | $DDC2
       .byte $0C ; |    XX  | $DDC3
LDDC4:
       .byte $0C ; |    XX  | $DDC4
       .byte $12 ; |   X  X | $DDC5
       .byte $13 ; |   X  XX| $DDC6
       .byte $15 ; |   X X X| $DDC7
       .byte $16 ; |   X XX | $DDC8
       .byte $15 ; |   X X X| $DDC9
       .byte $19 ; |   XX  X| $DDCA
       .byte $19 ; |   XX  X| $DDCB
       .byte $11 ; |   X   X| $DDCC
       .byte $16 ; |   X XX | $DDCD
       .byte $13 ; |   X  XX| $DDCE
       .byte $15 ; |   X X X| $DDCF
       .byte $16 ; |   X XX | $DDD0
       .byte $1F ; |   XXXXX| $DDD1
       .byte $16 ; |   X XX | $DDD2
       .byte $16 ; |   X XX | $DDD3
       .byte $17 ; |   X XXX| $DDD4
       .byte $17 ; |   X XXX| $DDD5
       .byte $18 ; |   XX   | $DDD6
LDDD7:
       .byte $19 ; |   XX  X| $DDD7
       .byte $11 ; |   X   X| $DDD8
       .byte $11 ; |   X   X| $DDD9
       .byte $11 ; |   X   X| $DDDA
       .byte $11 ; |   X   X| $DDDB
       .byte $11 ; |   X   X| $DDDC
       .byte $07 ; |     XXX| $DDDD
       .byte $08 ; |    X   | $DDDE
       .byte $11 ; |   X   X| $DDDF
       .byte $11 ; |   X   X| $DDE0
       .byte $11 ; |   X   X| $DDE1
       .byte $06 ; |     XX | $DDE2
       .byte $11 ; |   X   X| $DDE3
       .byte $09 ; |    X  X| $DDE4
       .byte $11 ; |   X   X| $DDE5
       .byte $11 ; |   X   X| $DDE6
LDDE7:
       .byte $01 ; |       X| $DDE7 ; table of what enemy to put out if level takes too long
       .byte $01 ; |       X| $DDE8
       .byte $01 ; |       X| $DDE9
       .byte $01 ; |       X| $DDEA
       .byte $01 ; |      XX| $DDEB
       .byte $01 ; |      XX| $DDEC
       .byte $01 ; |      X | $DDED
       .byte $01 ; |      X | $DDEE
LDDEF:
       .byte $00 ; |        | $DDEF
       .byte $02 ; |      X | $DDF0; points for list of enemies (high order)
       .byte $00 ; |        | $DDF1
       .byte $02 ; |      X | $DDF2
       .byte $01 ; |       X| $DDF3
       .byte $02 ; |      X | $DDF4
       .byte $01 ; |       X| $DDF5
       .byte $01 ; |       X| $DDF6
       .byte $01 ; |       X| $DDF7
       .byte $01 ; |       X| $DDF8
       .byte $02 ; |      X | $DDF9
       .byte $0A ; |     X X| $DDFA
       .byte $02 ; |      X | $DDFB
       .byte $01 ; |       X| $DDFC
LDDFD:
       .byte $00 ; |        | $DDFD
       .byte $00 ; |        | $DDFE; points for list of enemies (low order)
       .byte $50 ; | X X    | $DDFF
       .byte $00 ; |        | $DE00
       .byte $50 ; | X X    | $DE01
       .byte $00 ; |        | $DE02
       .byte $50 ; | X X    | $DE03
       .byte $50 ; | X X    | $DE04
       .byte $50 ; | X X    | $DE05
       .byte $50 ; | X X    | $DE06
       .byte $00 ; |        | $DE07
       .byte $00 ; |        | $DE08
       .byte $50 ; | X X    | $DE09
       .byte $50 ; | X X    | $DE0A
       .byte $00 ; |        | $DE0B
       .byte $00 ; |        | $DE0C
LDE0D:
       .byte $05 ; |     X X| $DE0D ; Value of catching falling humanoids
       .byte $05 ; |   X    | $DE0E
       .byte $05 ; |   X X X| $DE0F
       .byte $05 ; |  X     | $DE10
       .byte $05 ; |  X     | $DE11
       .byte $05 ; |  X     | $DE12
       .byte $05 ; |  X     | $DE13
       .byte $05 ; |  X     | $DE14
LDE15:
       .byte $AE ; |X X XXX | $DE15
       .byte $53 ; | X X  XX| $DE16
LDE17:
       .byte $FF ; |XXXXXXXX| $DE17
       .byte $FD ; |XXXXXX X| $DE18
       .byte $FD ; |XXXXXX X| $DE19
       .byte $FD ; |XXXXXX X| $DE1A
       .byte $FD ; |XXXXXX X| $DE1B
       .byte $FD ; |XXXXXX X| $DE1C
       .byte $FD ; |XXXXXX X| $DE1D
       .byte $FD ; |XXXXXX X| $DE1E
       .byte $FD ; |XXXXXX X| $DE1F
LDE20:
       .byte $90 ; |X  X    | $DE20
       .byte $9A ; |X  XX X | $DE21
       .byte $9A ; |X  XX X | $DE22
       .byte $9A ; |X  XX X | $DE23
       .byte $9A ; |X  XX X | $DE24
       .byte $9A ; |X  XX X | $DE25
       .byte $9A ; |X  XX X | $DE26
       .byte $9A ; |X  XX X | $DE27
LDE28:
       .byte $9A ; |X  XX X | $DE28
       .byte $80 ; |X       | $DE29
       .byte $80 ; |X       | $DE2A
       .byte $80 ; |X       | $DE2B
       .byte $F8 ; |XXXXX   | $DE2C
       .byte $80 ; |X       | $DE2D
       .byte $80 ; |X       | $DE2E
       .byte $80 ; |X       | $DE2F
LDE30:
       .byte $80 ; |X       | $DE30
       .byte $00 ; |        | $DE31
       .byte $34 ; |  XX X  | $DE32
       .byte $82 ; |X     X | $DE33
       .byte $88 ; |X   X   | $DE34
       .byte $C2 ; |XX    X | $DE35
       .byte $C8 ; |XX  X   | $DE36
       .byte $32 ; |  XX  X | $DE37
       .byte $36 ; |  XX XX | $DE38
       .byte $32 ; |  XX  X | $DE39
       .byte $36 ; |  XX XX | $DE3A
       .byte $32 ; |  XX  X | $DE3B
       .byte $36 ; |  XX XX | $DE3C
LDE3D:
       .byte $00 ; |        | $DE3D
       .byte $8E ; |X   XXX | $DE3E
       .byte $8C ; |X   XX  | $DE3F
       .byte $88 ; |X   X   | $DE40
       .byte $86 ; |X    XX | $DE41
       .byte $84 ; |X    X  | $DE42
       .byte $82 ; |X     X | $DE43
       .byte $80 ; |X       | $DE44
       .byte $68 ; | XX X   | $DE45
       .byte $66 ; | XX  XX | $DE46
       .byte $64 ; | XX  X  | $DE47
       .byte $22 ; |  X   X | $DE48
       .byte $88 ; |X   X   | $DE49
       .byte $86 ; |X    XX | $DE4A
       .byte $84 ; |X    X  | $DE4B
       .byte $82 ; |X     X | $DE4C
       .byte $80 ; |X       | $DE4D
       .byte $48 ; | X  X   | $DE4E
       .byte $46 ; | X   XX | $DE4F
       .byte $42 ; | X    X | $DE50
       .byte $40 ; | X      | $DE51
       .byte $C8 ; |XX  X   | $DE52
       .byte $C6 ; |XX   XX | $DE53
       .byte $C4 ; |XX   X  | $DE54
       .byte $C2 ; |XX    X | $DE55
       .byte $06 ; |     XX | $DE56
       .byte $04 ; |     X  | $DE57
       .byte $02 ; |      X | $DE58
       .byte $00 ; |        | $DE59
LDE5A:
       .byte $82 ; |X     X | $DE5A
       .byte $82 ; |X     X | $DE5B
       .byte $82 ; |X     X | $DE5C
       .byte $82 ; |X     X | $DE5D
       .byte $6E ; | XX XXX | $DE5E
       .byte $6E ; | XX XXX | $DE5F
       .byte $6E ; | XX XXX | $DE60
       .byte $6E ; | XX XXX | $DE61
       .byte $5A ; | X XX X | $DE62
       .byte $40 ; | X      | $DE63
       .byte $50 ; | X X    | $DE64
       .byte $60 ; | XX     | $DE65
       .byte $50 ; | X X    | $DE66
       .byte $40 ; | X      | $DE67
       .byte $46 ; | X   XX | $DE68
       .byte $46 ; | X   XX | $DE69
LDE6A:
       .byte $10 ; |   X    | $DE6A
       .byte $20 ; |  X     | $DE6B
       .byte $30 ; |  XX    | $DE6C
       .byte $40 ; | X      | $DE6D
       .byte $50 ; | X X    | $DE6E
       .byte $60 ; | XX     | $DE6F
       .byte $70 ; | XXX    | $DE70
       .byte $80 ; |X       | $DE71
       .byte $90 ; |X  X    | $DE72
       .byte $A0 ; |X X     | $DE73
       .byte $10 ; |   X    | $DE74
       .byte $20 ; |  X     | $DE75
       .byte $30 ; |  XX    | $DE76
       .byte $40 ; | X      | $DE77
       .byte $50 ; | X X    | $DE78
       .byte $80 ; |X       | $DE79
LDE7A:
       .byte $10 ; |   X    | $DE7A
       .byte $00 ; |        | $DE7B
       .byte $03 ; |      XX| $DE7C
       .byte $E4 ; |XXX  X  | $DE7D
       .byte $E2 ; |XXX   X | $DE7E
       .byte $08 ; |    X   | $DE7F
       .byte $E7 ; |XXX  XXX| $DE80
       .byte $E9 ; |XXX X  X| $DE81
       .byte $A9 ; |X X X  X| $DE82
       .byte $CB ; |XX  X XX| $DE83
       .byte $CD ; |XX  XX X| $DE84
       .byte $AF ; |X X XXXX| $DE85
       .byte $B0 ; |X XX    | $DE86
       .byte $F3 ; |XXXX  XX| $DE87
       .byte $F5 ; |XXXX X X| $DE88
       .byte $97 ; |X  X XXX| $DE89
       .byte $D9 ; |XX XX  X| $DE8A
       .byte $D8 ; |XX XX   | $DE8B
       .byte $FD ; |XXXXXX X| $DE8C
       .byte $FE ; |XXXXXXX | $DE8D
       .byte $FF ; |XXXXXXXX| $DE8E
       .byte $FF ; |XXXXXXXX| $DE8F
       .byte $FF ; |XXXXXXXX| $DE90
       .byte $FF ; |XXXXXXXX| $DE91
       .byte $DF ; |XX XXXXX| $DE92
       .byte $DF ; |XX XXXXX| $DE93
       .byte $BF ; |X XXXXXX| $DE94
       .byte $BF ; |X XXXXXX| $DE95
       .byte $9F ; |X  XXXXX| $DE96
       .byte $7F ; | XXXXXXX| $DE97
       .byte $7C ; | XXXXX  | $DE98
       .byte $03 ; |      XX| $DE99
       .byte $7B ; | XXXX XX| $DE9A
       .byte $9A ; |X  XX X | $DE9B
       .byte $78 ; | XXXX   | $DE9C
       .byte $57 ; | X X XXX| $DE9D
       .byte $35 ; |  XX X X| $DE9E
       .byte $34 ; |  XX X  | $DE9F
       .byte $14 ; |   X X  | $DEA0
       .byte $00 ; |        | $DEA1
       .byte $08 ; |    X   | $DEA2
       .byte $37 ; |  XX XXX| $DEA3
       .byte $00 ; |        | $DEA4
       .byte $08 ; |    X   | $DEA5
       .byte $18 ; |   XX   | $DEA6
       .byte $00 ; |        | $DEA7
       .byte $08 ; |    X   | $DEA8
       .byte $9F ; |X  XXXXX| $DEA9
       .byte $9E ; |X  XXXX | $DEAA
       .byte $7D ; | XXXXX X| $DEAB
       .byte $7C ; | XXXXX  | $DEAC
       .byte $7B ; | XXXX XX| $DEAD
       .byte $7A ; | XXXX X | $DEAE
       .byte $79 ; | XXXX  X| $DEAF
       .byte $78 ; | XXXX   | $DEB0
       .byte $77 ; | XXX XXX| $DEB1
       .byte $76 ; | XXX XX | $DEB2
       .byte $75 ; | XXX X X| $DEB3
       .byte $74 ; | XXX X  | $DEB4
       .byte $73 ; | XXX  XX| $DEB5
       .byte $72 ; | XXX  X | $DEB6
       .byte $71 ; | XXX   X| $DEB7
       .byte $70 ; | XXX    | $DEB8
       .byte $6F ; | XX XXXX| $DEB9
       .byte $6E ; | XX XXX | $DEBA
       .byte $6D ; | XX XX X| $DEBB
       .byte $6C ; | XX XX  | $DEBC
       .byte $6B ; | XX X XX| $DEBD
       .byte $6A ; | XX X X | $DEBE
       .byte $49 ; | X  X  X| $DEBF
       .byte $48 ; | X  X   | $DEC0
       .byte $74 ; | XXX X  | $DEC1
       .byte $46 ; | X   XX | $DEC2
       .byte $45 ; | X   X X| $DEC3
       .byte $44 ; | X   X  | $DEC4
       .byte $00 ; |        | $DEC5
       .byte $08 ; |    X   | $DEC6
       .byte $44 ; | X   X  | $DEC7
       .byte $45 ; | X   X X| $DEC8
       .byte $46 ; | X   XX | $DEC9
       .byte $47 ; | X   XXX| $DECA
       .byte $48 ; | X  X   | $DECB
       .byte $49 ; | X  X  X| $DECC
       .byte $4A ; | X  X X | $DECD
       .byte $4B ; | X  X XX| $DECE
       .byte $4C ; | X  XX  | $DECF
       .byte $4D ; | X  XX X| $DED0
       .byte $4E ; | X  XXX | $DED1
       .byte $4F ; | X  XXXX| $DED2
       .byte $50 ; | X X    | $DED3
       .byte $51 ; | X X   X| $DED4
       .byte $52 ; | X X  X | $DED5
       .byte $53 ; | X X  XX| $DED6
       .byte $54 ; | X X X  | $DED7
       .byte $55 ; | X X X X| $DED8
       .byte $56 ; | X X XX | $DED9
       .byte $57 ; | X X XXX| $DEDA
       .byte $58 ; | X XX   | $DEDB
       .byte $59 ; | X XX  X| $DEDC
       .byte $5A ; | X XX X | $DEDD
       .byte $5B ; | X XX XX| $DEDE
       .byte $5C ; | X XXX  | $DEDF
       .byte $5D ; | X XXX X| $DEE0
       .byte $5E ; | X XXXX | $DEE1
       .byte $5F ; | X XXXXX| $DEE2
       .byte $10 ; |   X    | $DEE3
       .byte $00 ; |        | $DEE4
       .byte $05 ; |     X X| $DEE5
       .byte $4F ; | X  XXXX| $DEE6
       .byte $4C ; | X  XX  | $DEE7
       .byte $4B ; | X  X XX| $DEE8
       .byte $4D ; | X  XX X| $DEE9
       .byte $4C ; | X  XX  | $DEEA
       .byte $4B ; | X  X XX| $DEEB
       .byte $4D ; | X  XX X| $DEEC
       .byte $4E ; | X  XXX | $DEED
       .byte $4F ; | X  XXXX| $DEEE
       .byte $00 ; |        | $DEEF
       .byte $02 ; |      X | $DEF0
       .byte $E4 ; |XXX  X  | $DEF1
       .byte $E4 ; |XXX  X  | $DEF2
       .byte $84 ; |X    X  | $DEF3
       .byte $64 ; | XX  X  | $DEF4
       .byte $10 ; |   X    | $DEF5
       .byte $A6 ; |X X  XX | $DEF6
       .byte $86 ; |X    XX | $DEF7
       .byte $66 ; | XX  XX | $DEF8
       .byte $10 ; |   X    | $DEF9
       .byte $66 ; | XX  XX | $DEFA
       .byte $46 ; | X   XX | $DEFB
       .byte $26 ; |  X  XX | $DEFC
       .byte $10 ; |   X    | $DEFD
       .byte $26 ; |  X  XX | $DEFE
       .byte $26 ; |  X  XX | $DEFF
       .byte $10 ; |   X    | $DF00
       .byte $10 ; |   X    | $DF01
       .byte $26 ; |  X  XX | $DF02
       .byte $10 ; |   X    | $DF03
       .byte $00 ; |        | $DF04
       .byte $0D ; |    XX X| $DF05
       .byte $7B ; | XXXX XX| $DF06
       .byte $7A ; | XXXX X | $DF07
       .byte $79 ; | XXXX  X| $DF08
       .byte $78 ; | XXXX   | $DF09
       .byte $7B ; | XXXX XX| $DF0A
       .byte $7A ; | XXXX X | $DF0B
       .byte $79 ; | XXXX  X| $DF0C
       .byte $76 ; | XXX XX | $DF0D
       .byte $7B ; | XXXX XX| $DF0E
       .byte $7A ; | XXXX X | $DF0F
       .byte $79 ; | XXXX  X| $DF10
       .byte $74 ; | XXX X  | $DF11
       .byte $7B ; | XXXX XX| $DF12
       .byte $7A ; | XXXX X | $DF13
       .byte $79 ; | XXXX  X| $DF14
       .byte $73 ; | XXX  XX| $DF15
       .byte $7B ; | XXXX XX| $DF16
       .byte $7A ; | XXXX X | $DF17
       .byte $79 ; | XXXX  X| $DF18
       .byte $71 ; | XXX   X| $DF19
       .byte $7B ; | XXXX XX| $DF1A
       .byte $7A ; | XXXX X | $DF1B
       .byte $79 ; | XXXX  X| $DF1C
       .byte $6F ; | XX XXXX| $DF1D
       .byte $7B ; | XXXX XX| $DF1E
       .byte $7A ; | XXXX X | $DF1F
       .byte $79 ; | XXXX  X| $DF20
       .byte $6E ; | XX XXX | $DF21
       .byte $7B ; | XXXX XX| $DF22
       .byte $7A ; | XXXX X | $DF23
       .byte $79 ; | XXXX  X| $DF24
       .byte $6C ; | XX XX  | $DF25
       .byte $7B ; | XXXX XX| $DF26
       .byte $7A ; | XXXX X | $DF27
       .byte $79 ; | XXXX  X| $DF28
       .byte $6B ; | XX X XX| $DF29
       .byte $7B ; | XXXX XX| $DF2A
       .byte $7A ; | XXXX X | $DF2B
       .byte $79 ; | XXXX  X| $DF2C
       .byte $6A ; | XX X X | $DF2D
       .byte $7B ; | XXXX XX| $DF2E
       .byte $7A ; | XXXX X | $DF2F
       .byte $79 ; | XXXX  X| $DF30
       .byte $69 ; | XX X  X| $DF31
       .byte $00 ; |        | $DF32
       .byte $01 ; |       X| $DF33
       .byte $62 ; | XX   X | $DF34
       .byte $63 ; | XX   XX| $DF35
       .byte $44 ; | X   X  | $DF36
       .byte $49 ; | X  X  X| $DF37
       .byte $00 ; |        | $DF38
       .byte $05 ; |     X X| $DF39
       .byte $63 ; | XX   XX| $DF3A
       .byte $6F ; | XX XXXX| $DF3B
       .byte $70 ; | XXX    | $DF3C
       .byte $71 ; | XXX   X| $DF3D
       .byte $72 ; | XXX  X | $DF3E
       .byte $73 ; | XXX  XX| $DF3F
       .byte $54 ; | X X X  | $DF40
       .byte $55 ; | X X X X| $DF41
       .byte $56 ; | X X XX | $DF42
       .byte $57 ; | X X XXX| $DF43
       .byte $58 ; | X XX   | $DF44
       .byte $59 ; | X XX  X| $DF45
       .byte $3A ; |  XXX X | $DF46
       .byte $3C ; |  XXXX  | $DF47
       .byte $3E ; |  XXXXX | $DF48
       .byte $3F ; |  XXXXXX| $DF49
       .byte $1F ; |   XXXXX| $DF4A
       .byte $00 ; |        | $DF4B
       .byte $05 ; |     X X| $DF4C
       .byte $68 ; | XX X   | $DF4D
       .byte $6A ; | XX X X | $DF4E
       .byte $6C ; | XX XX  | $DF4F
       .byte $6F ; | XX XXXX| $DF50
       .byte $68 ; | XX X   | $DF51
       .byte $6A ; | XX X X | $DF52
       .byte $6C ; | XX XX  | $DF53
       .byte $6F ; | XX XXXX| $DF54
       .byte $68 ; | XX X   | $DF55
       .byte $6A ; | XX X X | $DF56
       .byte $6C ; | XX XX  | $DF57
       .byte $6F ; | XX XXXX| $DF58
       .byte $00 ; |        | $DF59
       .byte $0A ; |    X X | $DF5A
       .byte $C9 ; |XX  X  X| $DF5B
       .byte $87 ; |X    XXX| $DF5C
       .byte $85 ; |X    X X| $DF5D
       .byte $84 ; |X    X  | $DF5E
       .byte $83 ; |X     XX| $DF5F
       .byte $81 ; |X      X| $DF60
       .byte $10 ; |   X    | $DF61
       .byte $C9 ; |XX  X  X| $DF62
       .byte $87 ; |X    XXX| $DF63
       .byte $85 ; |X    X X| $DF64
       .byte $84 ; |X    X  | $DF65
       .byte $83 ; |X     XX| $DF66
       .byte $81 ; |X      X| $DF67
       .byte $10 ; |   X    | $DF68
       .byte $C9 ; |XX  X  X| $DF69
       .byte $67 ; | XX  XXX| $DF6A
       .byte $65 ; | XX  X X| $DF6B
       .byte $64 ; | XX  X  | $DF6C
       .byte $63 ; | XX   XX| $DF6D
       .byte $61 ; | XX    X| $DF6E
       .byte $10 ; |   X    | $DF6F
       .byte $89 ; |X   X  X| $DF70
       .byte $47 ; | X   XXX| $DF71
       .byte $45 ; | X   X X| $DF72
       .byte $44 ; | X   X  | $DF73
       .byte $43 ; | X    XX| $DF74
       .byte $41 ; | X     X| $DF75
       .byte $00 ; |        | $DF76
       .byte $0D ; |    XX X| $DF77
       .byte $F1 ; |XXXX   X| $DF78
       .byte $51 ; | X X   X| $DF79
LDF7A:
       .byte $30 ; |  XX    | $DF7A
       .byte $28 ; |  X X   | $DF7B
LDF7C:
       .byte $86 ; |X    XX | $DF7C
       .byte $8F ; |X   XXXX| $DF7D
       .byte $98 ; |X  XX   | $DF7E
       .byte $A1 ; |X X    X| $DF7F
LDF80:
       .byte $AA ; |X X X X | $DF80
       .byte $B3 ; |X XX  XX| $DF81
       .byte $BC ; |X XXXX  | $DF82
       .byte $C5 ; |XX   X X| $DF83
       .byte $CE ; |XX  XXX | $DF84
       .byte $D7 ; |XX X XXX| $DF85
;
; Enemy Table:
; 00 - No enemy
; 01 - Baiter
; 02 - Munchy
; 03 - Phred
; 04 - Mutant
; 05 - Yllabian Space Guppy
; 06 - 3 Swarmers
; 07 - 2 Swarmers
; 08 - 1 Swarmer
; 09 - Lander
; 0A - Dynamo
; 0B - Pod
; 0C - FireBomber
; 0D - Lander w/ Humanoid (at top, immediately turns into Mutant)
; 0E - Humanoid (falling)
;
;1st Attack
;1st Wave
       .byte $09 ; |    X  X| $DF86
       .byte $09 ; |    X  X| $DF87
       .byte $09 ; |    X  X| $DF88
       .byte $09 ; |    X  X| $DF89
       .byte $09 ; |    X  X| $DF8A
       .byte $00 ; |        | $DF8B
       .byte $00 ; |        | $DF8C
       .byte $00 ; |        | $DF8D
       .byte $00 ; |        | $DF8E
                ;2nd Wave
       .byte $09 ; |    X  X| $DF8F
       .byte $09 ; |    X  X| $DF90
       .byte $09 ; |    X  X| $DF91
       .byte $09 ; |     X X| $DF92
       .byte $09 ; |    XX  | $DF93
       .byte $0B ; |    X X | $DF94
       .byte $0C ; |     X X| $DF95
       .byte $0C ; |     X X| $DF96
       .byte $0C ; |     X X| $DF97
                ;3rd Wave
       .byte $09 ; |    X  X| $DF98
       .byte $09 ; |    X  X| $DF99
       .byte $09 ; |    X  X| $DF9A
       .byte $0C ; |    X XX| $DF9B
       .byte $0B ; |    XX  | $DF9C
       .byte $09 ; |    X XX| $DF9D
       .byte $0C ; |    X X | $DF9E
       .byte $0B ; |     X X| $DF9F
       .byte $0C ; |    XX  | $DFA0
                ;4th Wave
       .byte $09 ; |    X  X| $DFA1
       .byte $09 ; |    X  X| $DFA2
       .byte $09 ; |    X  X| $DFA3
       .byte $0B ; |    X XX| $DFA4
       .byte $0C ; |    XX  | $DFA5
       .byte $0C ; |    XX  | $DFA6
       .byte $0B ; |    X X | $DFA7
       .byte $0B ; |    X XX| $DFA8
       .byte $0C ; |    X X | $DFA9
                ;5th Wave
       .byte $09 ; |    XX  | $DFAA
       .byte $09 ; |    XX  | $DFAB
       .byte $09 ; |    X X | $DFAC
       .byte $0B ; |    X X | $DFAD
       .byte $0C ; |     X X| $DFAE
       .byte $0B ; |     X X| $DFAF
       .byte $0C ; |     X X| $DFB0
       .byte $0B ; |     X X| $DFB1
       .byte $0C ; |     X X| $DFB2
                ;6th Wave
       .byte $09 ; |    X  X| $DFB3
       .byte $09 ; |    X  X| $DFB4
       .byte $09 ; |    X  X| $DFB5
       .byte $0B ; |    X XX| $DFB6
       .byte $0B ; |    X XX| $DFB7
       .byte $0C ; |    XX  | $DFB8
       .byte $0C ; |    XX  | $DFB9
       .byte $0C ; |    X X | $DFBA
       .byte $0B ; |    X XX| $DFBB
                ;7th Wave
       .byte $09 ; |    X  X| $DFBC
       .byte $09 ; |    X  X| $DFBD
       .byte $09 ; |    X  X| $DFBE
       .byte $0C ; |     X X| $DFBF
       .byte $0B ; |    X XX| $DFC0
       .byte $0C ; |     X X| $DFC1
       .byte $0B ; |    X XX| $DFC2
       .byte $0C ; |     X X| $DFC3
       .byte $0B ; |    X XX| $DFC4
;8th Wave
       .byte $09 ; |    X  X| $DFC5
       .byte $09 ; |    X  X| $DFC6
       .byte $09 ; |    X  X| $DFC7
       .byte $0B ; |     X X| $DFC8
       .byte $0C ; |    XX  | $DFC9
       .byte $0C ; |    X X | $DFCA
       .byte $0B ; |    X XX| $DFCB
       .byte $0B ; |    X XX| $DFCC
       .byte $0C ; |     X X| $DFCD
;9th Wave
       .byte $09 ; |    X  X| $DFCE
       .byte $09 ; |    X  X| $DFCF
       .byte $09 ; |    X  X| $DFD0
       .byte $0B ; |    X XX| $DFD1
       .byte $0C ; |    XX  | $DFD2
       .byte $0B ; |     X X| $DFD3
       .byte $0B ; |    X XX| $DFD4
       .byte $0C ; |    XX  | $DFD5
       .byte $0B ; |     X X| $DFD6
;10th Wave
       .byte $09 ; |    XX  | $DFD7
       .byte $09 ; |    XX  | $DFD8
       .byte $09 ; |    XX  | $DFD9
       .byte $0B ; |    XX  | $DFDA
       .byte $0C ; |    XX  | $DFDB
       .byte $0C ; |    XX  | $DFDC
       .byte $0B ; |    X XX| $DFDD
       .byte $0B ; |    X XX| $DFDE
       .byte $0B ; |    X XX| $DFDF
;2nd Attack - all waves
LDFE0:
       .byte $09 ; |    X  X| $DFE0
       .byte $09 ; |    X  X| $DFE1
       .byte $09 ; |    X  X| $DFE2
       .byte $09 ; |    X  X| $DFE3
       .byte $09 ; |    X  X| $DFE4
       .byte $09 ; |    X  X| $DFE5
       .byte $09 ; |    X  X| $DFE6
       .byte $09 ; |    X  X| $DFE7
       .byte $09 ; |    X  X| $DFE8
       .byte $09 ; |    X  X| $DFE9
       .byte $00 ; |        | $DFEA
       .byte $00 ; |        | $DFEB
       .byte $00 ; |        | $DFEC
       .byte $00 ; |        | $DFED
       .byte $00 ; |        | $DFEE
       .byte $00 ; |        | $DFEF
       .byte $00 ; |        | $DFF0
       .byte $00 ; |        | $DFF1


       ORG  $1FF2
       RORG $DFF2

LDFF2:
       STA    $FFF9                   ;3 bankswitch to #2
       JMP    LD16C                   ;4

       .byte $00 ; |        | $DFF8 bankswitch hotspot
       .byte $00 ; |        | $DFF9 bankswitch hotspot
LDFFA:
       .byte $08 ; |    X   | $DFFA
       .byte $04 ; |     X  | $DFFB
       .word START1
LDFFE:
       .byte $0F ; |    XXXX| $DFFE
       .byte $05 ; |     X X| $DFFF


















       ORG  $2000
       RORG $F000

;1st page reserved for cartridge ram
       .ds 256,0 ;256 zeros

START2:
       STA    $FFF8                   ;4 bankswitch to #1 and boot cartridge

LF103:
       .byte $A8 ; |X X X   | $F103
       .byte $A8 ; |X X X   | $F104
       .byte $A8 ; |X X X   | $F105
       .byte $E8 ; |XXX X   | $F106
       .byte $A8 ; |X X X   | $F107
       .byte $A8 ; |X X X   | $F108
       .byte $5D ; | X XXX X| $F109
LF10A:
       .byte $AB ; |X X X XX| $F10A
       .byte $AA ; |X X X X | $F10B
       .byte $AA ; |X X X X | $F10C
       .byte $BA ; |X XXX X | $F10D
       .byte $AA ; |X X X X | $F10E
       .byte $AA ; |X X X X | $F10F
       .byte $D3 ; |XX XXX X| $F110
LF111:
       .byte $A8 ; |X X X   | $F111
       .byte $A9 ; |X X X  X| $F112
       .byte $31 ; |  XX   X| $F113
       .byte $31 ; |  XX   X| $F114
       .byte $29 ; |  X X  X| $F115
       .byte $A9 ; |X X X  X| $F116
       .byte $A9 ; |X X X  X| $F117

LF118:
       LDA    rAE                     ;3
       BNE    LF142                   ;2
       LDY    #$17                    ;2
       JSR    LFAF4                   ;6
LF121:
       LDA    INTIM                   ;4
       CMP    #$C2                    ;2
       BNE    LF121                   ;2
       LDY    #$7F                    ;2
       JSR    LF904                   ;6
       LDY    #$0B                    ;2
       JSR    LFAF4                   ;6
LF132:
       LDA    INTIM                   ;4
       CMP    #$0C                    ;2
       BNE    LF132                   ;2
       LDA    #$32                    ;2
;       LDY    #$06                    ;2
;       JSR    LF900                   ;6
;       BEQ    LF155                   ;2 always branch (LF900 ends w/zero status set)
;NOTE: Could follow the LDA with a BNE to the line above LF155 to eliminate the LDY, JSR & BEQ
       bne    lf150                   ;2 always branch


LF142:
       LDY    #$51                    ;2
       JSR    LFAF4                   ;6
LF147:
       LDA    INTIM                   ;4
       CMP    #$68                    ;2
       BNE    LF147                   ;2
;       LDY    #$06                    ;2
;       LDA    #$24                    ;2
;swapped order to reuse Y's value of 6 (see above)
       lda    #$24                    ;2
lf150:
       ldy    #$06                    ;2
       JSR    LF900                   ;6
LF155:
       JMP    LF535                   ;3

LF158:
       BNE    LF15B                   ;2
       INY                            ;2
LF15B:
       LDA    rA9                     ;3
       BEQ    LF161                   ;2
       LDY    #$02                    ;2
LF161:
       TXA                            ;2
       STA    Write48                 ;4
       LSR                            ;2
       LDA    Read00                  ;4
       BCC    LF16D                   ;2
       ADC    #$7F                    ;2
LF16D:
       TAX                            ;2
       LDA    LFEFE,Y                 ;4
       STA    rC2                     ;3
       LDA    LFFF0,Y                 ;4
       SEC                            ;2
       SBC    rC2                     ;3
       STA    rC8                     ;3
       LDA    LFEFC,Y                 ;4
       SBC    rC2                     ;3
       STA    rBC                     ;3
       LDA    LFBD0,X                 ;4
       AND    #$F7                    ;2
       STA    rB0                     ;3
       LDA    LFBD0,X                 ;4
       ASL                            ;2
       AND    #$F0                    ;2
       ORA    #$08                    ;2
       STA    rB6                     ;3
       LDA    rA7                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       LDA    LF960,X                 ;4
       STA    rF2+4                   ;3
       LDA    rA6                     ;3
       BEQ    LF1DC                   ;2
       CMP    #$20                    ;2
       BCS    LF1DC                   ;2
       LDX    Read49                  ;4
       STX    rC2                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       LDY    LF95C,X                 ;4
       LDX    r85                     ;3
       LDA    LFBD0,X                 ;4
       TAX                            ;2
       ASL                            ;2
       AND    #$F0                    ;2
       ORA    LF948,Y                 ;4
       STA    rB6                     ;3
       TXA                            ;2
       AND    #$F7                    ;2
       STA    rB0                     ;3
       TYA                            ;2
       ASL                            ;2
       ASL                            ;2
       TAY                            ;2
       LDA    LFB00,Y                 ;4
       SEC                            ;2
       SBC    rC2                     ;3
       STA    rC8                     ;3
       LDA    LFB50,Y                 ;4
       SBC    rC2                     ;3
       STA    rBC                     ;3
       LDX    #$01                    ;2
       BNE    LF255                   ;2 always branch...crosses a page

LF1DC:
       LDX    #$01                    ;2
       LDA    rA2                     ;3
       BEQ    LF255                   ;2
       LDA    r81                     ;3
       LSR                            ;2
       LSR                            ;2
       TAY                            ;2
       AND    #$03                    ;2
       STA    rF2+6                   ;3
       TYA                            ;2
       LSR                            ;2
       AND    #$03                    ;2
       STA    rF2+7                   ;3
       DEX                            ;2
       STX    rF0+1                   ;3
       DEX                            ;2
       STX    rF0                     ;3
LF1F7:
       INC    rF0                     ;5
       LDY    rF0                     ;3
       CPY    rA2                     ;3
       BEQ    LF253                   ;2
       LDA    Read43,Y                ;4
       TAY                            ;2
       BMI    LF1F7                   ;2
       LDX    Read02,Y                ;4
       LDA    LFBD0,X                 ;4
       STA    rF2+2                   ;3
       EOR    Read12,Y                ;4
       AND    #$08                    ;2
       EOR    rF2+2                   ;3
       LDX    rF0+1                   ;3
       STA    rB0+1,X                 ;4
       TYA                            ;2
       STA    Write43,X               ;5
       LDA.wy rE0,Y                   ;4
       STA    rC2+1,X                 ;4
       LDA    Read22,Y                ;4
       TAY                            ;2
       LDA    rA7                     ;3
       BEQ    LF22B                   ;2
       LDY    rF2+4                   ;3
LF22B:
       LDA    rF2+2                   ;3
       ASL                            ;2
       AND    #$F0                    ;2
       ORA    LF948,Y                 ;4
       STA    rB6+1,X                 ;4
       TYA                            ;2
       ASL                            ;2
       ASL                            ;2
       LDX    LFA00,Y                 ;4
       ORA    rF2+6,X                 ;4
       LDX    rF0+1                   ;3
       TAY                            ;2
       LDA    LFB00,Y                 ;4
       SEC                            ;2
       SBC    rC2+1,X                 ;4
       STA    rC8+1,X                 ;4
       LDA    LFB50,Y                 ;4
       SBC    rC2+1,X                 ;4
       STA    rBC+1,X                 ;4
       INC    rF0+1                   ;5
       BNE    LF1F7                   ;2
LF253:
       INX                            ;2
       INX                            ;2
LF255:
       STX    rA2                     ;3
       STX    rA3                     ;3
       LDX    #rF2+11                 ;2
       TXS                            ;2
       LDX    #$02                    ;2
LF25E:
       LDA    #>DigitGfx              ;2 high byte of the digit gfx bitmaps
       PHA                            ;3
       LDA    r8B,X                   ;4
       AND    #$0F                    ;2
       TAY                            ;2
       LDA    LF93E,Y                 ;4 get digit gfx location for the low nybble
       PHA                            ;3
       LDA    #>DigitGfx              ;2 high byte of the digit gfx bitmaps
       PHA                            ;3
       LDA    r8B,X                   ;4
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAY                            ;2
       LDA    LF93E,Y                 ;4 get digit gfx location for the high nybble
       PHA                            ;3
       DEX                            ;2
       BPL    LF25E                   ;2
       LDX    #$05                    ;2
LF27D:
       PLA                            ;4
       CMP    #$26                    ;2
       BNE    LF28A                   ;2
       LDA    #$89                    ;2
       PHA                            ;3
       PLA                            ;4
       PLA                            ;4
       DEX                            ;2
       BNE    LF27D                   ;2
LF28A:
       LDA    #$08                    ;2 Color of scanner
       STA    COLUPF                  ;3
LF28E:
       LDA    $0285                   ;4
       BPL    LF28E                   ;2
       STA    WSYNC                   ;3
       LDA    #$DC                    ;2
       STA    TIM64T                  ;4
       LDX    #$00                    ;2
       STX    VBLANK                  ;3
       STX    GRP0                    ;3
       STX    GRP1                    ;3
       STX    REFP0                   ;3
       STX    REFP1                   ;3
       LDA    #$C0                    ;2
       SBC    r85                     ;3
       STA    HMBL                    ;3
       LDA    #$15                    ;2
       STA    CTRLPF                  ;3
       STA    RESP0                   ;3
       STA    RESP1                   ;3
       DEX                            ;2
       TXS                            ;2 X=$FF...reset stack to beginning
       STA    RESBL                   ;3
       STX    HMP0                    ;3
       LDY    rD7                     ;3
       LDA    (r9B),Y                 ;5
       EOR    rDA                     ;3
       AND    #$0F                    ;2
       EOR    rDA                     ;3
       STA    rDA                     ;3
       LDX    #$03                    ;2
       STX    NUSIZ0                  ;3
       STA    HMOVE                   ;3
       LDA    Read7D                  ;4
       BPL    LF2D9                   ;2
       ASL                            ;2
       AND    #$F7                    ;2
       STA    COLUBK                  ;3
       JMP    LF535                   ;3

LF2D9:
       STX    NUSIZ1                  ;3
       STX    VDELP0                  ;3
       STX    VDEL01                  ;3
       LDY    #$06                    ;2
       LDA    r81                     ;3
       ASL                            ;2
       AND    #$F0                    ;2
       ORA    #$14                    ;2
       JSR    LF900                   ;6
       LDY    r82                     ;3
       BNE    LF2F2                   ;2
       JMP    LF118                   ;3

LF2F2:
       DEY                            ;2
       LDA    #$40                    ;2
       JSR    LF66B                   ;6
       LDA    #$32                    ;2 Reserve Ships Color
       LDY    #$04                    ;2
       JSR    LF900                   ;6
       LDY    r83                     ;3
       LDA    #$53                    ;2
       JSR    LF66B                   ;6
       LDY    #$02                    ;2
       LDA    #$FF                    ;2 Smart Bomb Color?
       JSR    LF900                   ;6

;these not needed when r84 unused...
;       LDY    r84                     ;3
;       LDA    #$DD                    ;2
;       JSR    LF66B                   ;6
;       LDY    #$01                    ;2
;       LDA    #$32                    ;2
;       JSR    LF900                   ;6

       LDA    rAA                     ;3
       BEQ    LF322                   ;2
       JMP    LF553                   ;3

LF322:
;added...
       lda    #$FE                    ;2 the line above the scanner
       sta    PF2                     ;3
       sta    WSYNC                   ;3
;Original branches w/6 cycles on the scanline...so it's OK for these too :)
       lda    #$82                    ;2
       sta.w  PF2                     ;4

       LDA    #$C2                    ;2 Color of Blips inside scanner
       STA    COLUP0                  ;3
       STA    COLUP1                  ;3
       LDA    rF0                     ;3
       LDA    r99                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       LDA    LFA29,X                 ;4
       STA    rF0                     ;3
       SEC                            ;2
       LDA    #$67                    ;2
       SBC    rF0                     ;3
       STA    rF2+6                   ;3
       LDA    #$FE                    ;2
       STA    rF2+7                   ;3
       LDA    #$0D                    ;2
       STA    rF0                     ;3
       LDA    #$02                    ;2 scanner sides
       STA    PF2                     ;3
;
; RPD
LF348:
       LDA    rF0                     ;3
       LSR                            ;2
       TAY                            ;2
       LDA    (rF2+6),Y               ;5 Done
       STA    ENABL                   ;3 @75
       LDA    Read72,Y                ;4 Done
       STA    rF0+1                   ;3
       LDA    Read6B,Y                ;4 Done
       TAX                            ;2
       LDA    Read4F,Y                ;4 Done
       STA    GRP0                    ;3
       LDA    Read56,Y                ;4 Done
       STA    GRP1                    ;3
       LDA    Read5D,Y                ;4 Done
       STA    GRP0                    ;3
       LDA    Read64,Y                ;4 Done
       LDY    rF0+1                   ;3
       STA    GRP1                    ;3
       STX    GRP0                    ;3
       STY    GRP1                    ;3
       STA    GRP0                    ;3
       DEC    rF0                     ;5
       BPL    LF348                   ;2 @59

;complicated...lower-case indicates changes to correct scanner (req. the above optimizations)
       STA    WSYNC                   ;3
       ldx    #$FF                    ;2 give to an unused register to save for PF2 next line
       stx    PF1                     ;3
       lda    #$83                    ;2 sides+the tab in the lower center of the scanner
       sta    PF2                     ;3
       STA    WSYNC                   ;3
       JSR    LF92E                   ;6+17 waste 23 cycles
       stx    PF2                     ;3
       JSR    LF92E                   ;6+17 waste 23 cycles

       ldx    #$03                    ;2
       nop                            ;2
       nop                            ;2 @55
       STA    ENABL                   ;3
       STA    VDEL01                  ;3
       STA    NUSIZ0                  ;3
       STA    NUSIZ1                  ;3 @67
       clc                            ;2 @69
       sta    PF2                     ;3
       sta    PF1                     ;3 @75
       bcc    lf3a0                   ;2 always branch


LF398:
       BCC    LF39C                   ;2
       STA    RESM0,X                 ;4
LF39C:
       STA    WSYNC                   ;3
       LDA    #$00                    ;2
lf3a0:
       STA    PF2                     ;3
LF3A2:
       LDY    r85,X                   ;4
       LDA    LFBD0,Y                 ;4
       BMI    LF3A9                   ;2
LF3A9:
       AND    #$06                    ;2
       BEQ    LF3B2                   ;2
       SEC                            ;2
LF3AE:
       SBC    #$01                    ;2
       BNE    LF3AE                   ;2
LF3B2:
       STA    RESP1,X                 ;4
       LDA    LFBD0,Y                 ;4
       ASL                            ;2
       STA    HMP1,X                  ;4
       LSR                            ;2
       LSR                            ;2
       DEX                            ;2
       BPL    LF398                   ;2
       BCC    LF3C4                   ;2
       NOP                            ;2
       STA    RESP1                   ;3
LF3C4:
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       LDX    #ENAM0                  ;2 set stack pointer to missile/ball enable locations
       TXS                            ;2
;Note: Pushing the processor status after a compare will automatically set or clear the sprite.
;      Not only does this save cycles, but also keeps cycle time exact regardless if a sprite
;      is set to display (and you don't need to burn a register to hold the enable/disable).

       LDY    #$8B                    ;2
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       LDA    r8F                     ;3 Background Color
       STA    COLUBK                  ;3
       LDA    Read4A                  ;4 Player Color
       STA    COLUP1                  ;3
       STA    COLUPF                  ;3
       LDX    Read01                  ;4
       DEX                            ;2
       STX    REFP1                   ;3
       NOP                            ;2
       STA    CXCLR                   ;3
       STA    HMCLR                   ;3
       LDA    rAD                     ;3
       BEQ    LF3EE                   ;2
       JMP    LF535                   ;3

LF3EE:
       LDA    #$30                    ;2
       STA    HMM1                    ;3
       LDA    #$D0                    ;2
       STA    HMBL                    ;3
       LDA    #$00                    ;2
       JMP    LF461                   ;3 could BEQ instead (tho it crosses a page)

LF3FB:
       JMP    LF53B                   ;3

       BRK                            ;7 NOTE: Interrupts not used...these 2 lines superfluous
       BRK                            ;7 but they do keep space filled above the loop below.

       ORG  $2400
       RORG $F400

LF400:
       LDA    (r9F),Y                 ;5
       JMP    LF409                   ;3

LF405:
       STX    rA1                     ;3
LF407:
       LDA    #$FF                    ;2 Enemy Shots?
LF409:
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       STA    COLUP0                  ;3
       LDA    (r94),Y                 ;5
       STA    GRP1                    ;3
       LDA    (r9B),Y                 ;5
       STA    ENAM1                   ;3
       STA    ENABL                   ;3
       AND    #$F0                    ;2
       STA    NUSIZ1                  ;3
       STA    CTRLPF                  ;3
       DEY                            ;2
       BEQ    LF3FB                   ;2
       CPY    r96+1                   ;3
       BCS    LF42A                   ;2
       LDA    r96                     ;3
       STA    r94                     ;3
LF42A:
       LDA    #$00                    ;2
       STA    HMP0                    ;3
       CPY    rA1                     ;3
       BCC    LF438                   ;2
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       BCS    LF444                   ;2 always branch

LF438:
       LDA    (r9D),Y                 ;5
       STA    GRP0                    ;3
       LDA    (r9F),Y                 ;5
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       STA    COLUP0                  ;3
LF444:
       LDA    (r94),Y                 ;5
       STA    GRP1                    ;3
       LDA    (r9B),Y                 ;5
       STA    ENAM1                   ;3
       STA    ENABL                   ;3
       CPY    r9A                     ;3
       PHP                            ;3
       PLA                            ;4
       DEY                            ;2
       CPY    rD7                     ;3
       BEQ    LF4CC                   ;2
LF457:
       CPY    rA1                     ;3
       BCS    LF407                   ;2
       LDA    (r9D),Y                 ;5
       STA    GRP0                    ;3
       BNE    LF400                   ;2
LF461:
       LDX    rA2                     ;3
       BEQ    LF405                   ;2
       DEX                            ;2
       LDA    rC2,X                   ;4
       STA    rA1                     ;3
       LDA    (r94),Y                 ;5
       STA    HMOVE                   ;3
       STA    GRP1                    ;3
       DEY                            ;2
       LDA    rB0,X                   ;4
       STA    REFP0                   ;3
       BMI    LF477                   ;2
LF477:
       AND    #$06                    ;2
       BEQ    LF480                   ;2
       SEC                            ;2
LF47C:
       SBC    #$01                    ;2
       BNE    LF47C                   ;2
LF480:
       STA    RESP0                   ;3
       LSR    rB0,X                   ;6
       LDA    rB6,X                   ;4
       STA    HMP0                    ;3
       ORA    #$F0                    ;2
       STA    r9F+1                   ;3
       STA    r9D+1                   ;3
       BCC    LF492                   ;2
       STA    RESP0                   ;3
LF492:
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       LDA    (r94),Y                 ;5
       STA    GRP1                    ;3
       LDA    (r9B),Y                 ;5
       STA    ENAM1                   ;3
       STA    ENABL                   ;3
       CPY    r9A                     ;3
       PHP                            ;3
       PLA                            ;4
       DEY                            ;2
       LDA    rBC,X                   ;4
       STA    r9F                     ;3
       LDA    rC8,X                   ;4
       STA    r9D                     ;3
       LDA    CXPPMM                  ;3
       STA    rB0,X                   ;4
       STX    rA2                     ;3
       CPY    rD7                     ;3
       BEQ    LF4BF                   ;2
       JMP    LF407                   ;3

LF4BA:
       LDA    rF0                     ;3
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
LF4BF:
       LDX    rDA                     ;3
       STX    PF0                     ;3
       LDA    rDB                     ;3
       STA    PF1                     ;3
       STA    HMOVE                   ;3
       JMP    LF4E4                   ;3

LF4CC:
       STX    rA4                     ;3
       LDX    rDA                     ;3
       CPY    rA1                     ;3
       BCS    LF4BA                   ;2
       STX    PF0                     ;3
       LDA    (r9D),Y                 ;5
       STA    GRP0                    ;3
       LDA    rDB                     ;3
       STA    PF1                     ;3
       LDA    (r9F),Y                 ;5
       STA    HMOVE                   ;3
       STA    COLUP0                  ;3
LF4E4:
       STX    ENABL                   ;3
       STX    ENAM1                   ;3
       LDA    (r94),Y                 ;5
       STA    GRP1                    ;3
       LDA    rDC                     ;3
       STA    PF2                     ;3
       DEY                            ;2
       LDX    #$00                    ;2
       STX    HMP0                    ;3
       LDA    rDD                     ;3
       STA    PF0                     ;3
       LDA    rDE                     ;3
       STA    PF1                     ;3
       LDA    rDF                     ;3
       STA    PF2                     ;3
       CPY    rA1                     ;3
       STX    PF0                     ;3
       BCS    LF527                   ;2
       LDA    (r9D),Y                 ;5
       STX    PF1                     ;3
       STA    GRP0                    ;3
       STX    PF2                     ;3
       CPY    r9A                     ;3
       STA    HMOVE                   ;3
       PHP                            ;3
       LDA    (r9F),Y                 ;5
       STA    COLUP0                  ;3
       LDA    (r9B),Y                 ;5
       STA    ENAM1                   ;3
       STA    ENABL                   ;3
       LDA    (r94),Y                 ;5
       STA    GRP1                    ;3
       PLA                            ;4
       DEY                            ;2
       JMP    LF457                   ;3

LF527:
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       NOP                            ;2
       STX    PF1                     ;3
       STX    PF2                     ;3
       STA    HMOVE                   ;3
       JMP    LF444                   ;3

LF535:
       LDX    #$00                    ;2
       STX    rA3                     ;3
       STX    rA2                     ;3
LF53B:
       LDA    $0285                   ;4
       BPL    LF53B                   ;2
       STA    WSYNC                   ;3
       LDA    #$02                    ;2
       STA    VBLANK                  ;3
       LDA    #$00                    ;2 Color of title screen background / scanner background
       STA    COLUBK                  ;3
       STA    ENAM1                   ;3
       STA    ENAM0                   ;3
       STA    ENABL                   ;3
       JMP    LFFF2                   ;3

LF553:
       LDY    #$23                    ;2
       LDA    Read4E                  ;4
       CMP    #$20                    ;2
       BNE    LF55E                   ;2
       LDY    #$5D                    ;2
LF55E:
       JSR    LFAF4                   ;6
LF561:
       LDA    INTIM                   ;4
       CMP    #$AC                    ;2
       BNE    LF561                   ;2
       LDA    #$82                    ;2
       LDY    #$06                    ;2
       JSR    LF900                   ;6
       LDY    #$2F                    ;2
       JSR    LFAF4                   ;6
       LDA    r89                     ;3
       AND    #$0F                    ;2
       TAX                            ;2
       LDA    Read4E                  ;4
       CMP    #$20                    ;2
       BNE    LF581                   ;2
       INX                            ;2
LF581:
       LDA    LF93E,X                 ;4 attack wave # low digit
       STA    rF2+6                   ;3
       LDA    r89                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       TAX                            ;2
       BEQ    LF594                   ;2 if zero, skip next pointer
       LDA    LF93E,X                 ;4 attack wave # high digit if applicable
       STA    rF2+4                   ;3
LF594:
       LDA    INTIM                   ;4
       CMP    #$9B                    ;2
       BNE    LF594                   ;2
       LDY    #$06                    ;2
       JSR    LF904                   ;6
       LDA    Read4E                  ;4
       CMP    #$20                    ;2
       BEQ    LF5B8                   ;2
       LDY    #$39                    ;2
       JSR    LFAF4                   ;6
LF5AC:
       LDA    INTIM                   ;4
       CMP    #$88                    ;2
       BNE    LF5AC                   ;2
       LDY    #$06                    ;2
       JSR    LF904                   ;6
LF5B8:
       LDA    rAA                     ;3
       AND    #$07                    ;2
       BNE    LF5EE                   ;2
       LDY    #$00                    ;2
       STY    r92                     ;3
       LDA    rD6                     ;3
       LDX    #$07                    ;2
LF5C6:
       LSR                            ;2
       BCC    LF5CA                   ;2
       INY                            ;2
LF5CA:
       DEX                            ;2
       BPL    LF5C6                   ;2
       CPY    rD4                     ;3
       BEQ    LF5EE                   ;2
       INC    rD4                     ;5
       LDA    #$FD                    ;2
       STA    r90                     ;3
       SED                            ;2
       LDA    Read4E                  ;4
       CLC                            ;2
       ADC    r8C                     ;3
       STA    r8C                     ;3
       BCC    LF5EE                   ;2
       INC    r82                     ;5
;       INC    r84                     ;5  No Inviso in Defender...NOP's not needed here
       INC    r83                     ;5
       LDA    #$8B                    ;2
       STA    r93                     ;3
       INC    r8B                     ;5
LF5EE:
       CLD                            ;2
       LDX    #$00                    ;2
       STX    r99                     ;3
       DEC    rAA                     ;5
       BNE    LF615                   ;2
       STX    r8E                     ;3
       STX    rD4                     ;3
       DEX                            ;2
       STX    r81                     ;3
       LDA    r89                     ;3
       AND    #$0F                    ;2
       BEQ    LF608                   ;2
       CMP    #$05                    ;2
       BNE    LF60D                   ;2
LF608:
       STX    rD6                     ;3
       INX                            ;2
       STX    rA9                     ;3
LF60D:
       LDA    #$53                    ;2
       STA    r85                     ;3
       LDA    #$49                    ;2
       STA    r99                     ;3
LF615:
       LDA    #$01                    ;2
       STA    Write01                 ;4
       STA    Write41                 ;4
       LDY    #$45                    ;2
       JSR    LFAF4                   ;6
       LDX    Read4E                  ;4
       CPX    #$20                    ;2
       BEQ    LF62E                   ;2
       LDA    LF93E,X                 ;4
       STA    rF2+8                   ;3
LF62E:
       LDA    INTIM                   ;4
       CMP    #$4F                    ;2
       BNE    LF62E                   ;2
       LDA    #$C2                    ;2 Color of 'bonus' text at end of wave
       LDY    #$06                    ;2
       JSR    LF900                   ;6
       LDY    #$2F                    ;2
       JSR    LFAF4                   ;6
       LDY    rD4                     ;3
       LDX    #$00                    ;2
       TYA                            ;2
LF646:
       BEQ    LF658                   ;2
       LDA    #$56                    ;2
       CPY    #$02                    ;2
       BCS    LF650                   ;2
       LDA    #$5E                    ;2
LF650:
       STA    rF2+2,X                 ;4
       INX                            ;2
       INX                            ;2
       DEY                            ;2
       DEY                            ;2
       BPL    LF646                   ;2
LF658:
       LDA    INTIM                   ;4
       CMP    #$41                    ;2
       BNE    LF658                   ;2
       LDA    #$54                    ;2
       LDY    #$07                    ;2
       JSR    LF900                   ;6
       STA    CXCLR                   ;3
       JMP    LF535                   ;3

LF66B:
       LDX    #$0A                    ;2
LF66D:
       DEY                            ;2
       BMI    LF677                   ;2
       STA    rF2,X                   ;4
       DEX                            ;2
       DEX                            ;2
       BPL    LF66D                   ;2
       RTS                            ;6

LF677:
       LDA    #$89                    ;2
LF679:
       STA    rF2,X                   ;4
       DEX                            ;2
       DEX                            ;2
       BPL    LF679                   ;2
       RTS                            ;6

;NOTE: the above 2 subs could be merged into 1 by putting an LDA #$89 instruction just below
;      the BMI in the first sub (with the BMI pointing to the STA below that). This would
;      eliminate subroutine LF677.

;free
       nop                            ;2
       nop                            ;2


       ORG  $2680
       RORG $F680

LF680:
       .byte $00 ; |        | $F680
       .byte $00 ; |        | $F681
       .byte $00 ; |        | $F682
       .byte $00 ; |        | $F683
       .byte $00 ; |        | $F684
       .byte $00 ; |        | $F685
       .byte $00 ; |        | $F686
       .byte $00 ; |        | $F687
       .byte $00 ; |        | $F688
       .byte $00 ; |        | $F689
       .byte $00 ; |        | $F68A
       .byte $00 ; |        | $F68B
       .byte $00 ; |        | $F68C
       .byte $AA ; |X X X X | $F68D
       .byte $AA ; |X X X X | $F68E
       .byte $EC ; |XXX XX  | $F68F
       .byte $AA ; |X X X X | $F690
       .byte $4C ; | X  XX  | $F691
       .byte $00 ; |        | $F692
       .byte $00 ; |        | $F693
       .byte $07 ; |     XXX| $F694
       .byte $07 ; |     XXX| $F695
       .byte $07 ; |     XXX| $F696
       .byte $07 ; |     XXX| $F697
       .byte $07 ; |     XXX| $F698
       .byte $07 ; |     XXX| $F699
       .byte $07 ; |     XXX| $F69A
       .byte $07 ; |     XXX| $F69B
       .byte $00 ; |        | $F69C
       .byte $07 ; |     XXX| $F69D
       .byte $07 ; |     XXX| $F69E
       .byte $00 ; |        | $F69F
       .byte $00 ; |        | $F6A0
       .byte $00 ; |        | $F6A1
       .byte $01 ; |       X| $F6A2
       .byte $03 ; |      XX| $F6A3
       .byte $07 ; |     XXX| $F6A4
       .byte $07 ; |     XXX| $F6A5
       .byte $07 ; |     XXX| $F6A6
       .byte $07 ; |     XXX| $F6A7
       .byte $07 ; |     XXX| $F6A8
       .byte $07 ; |     XXX| $F6A9
       .byte $03 ; |      XX| $F6AA
       .byte $01 ; |       X| $F6AB
       .byte $00 ; |        | $F6AC
       .byte $00 ; |        | $F6AD
       .byte $00 ; |        | $F6AE
       .byte $07 ; |     XXX| $F6AF
       .byte $07 ; |     XXX| $F6B0
       .byte $07 ; |     XXX| $F6B1
       .byte $07 ; |     XXX| $F6B2
       .byte $07 ; |     XXX| $F6B3
       .byte $07 ; |     XXX| $F6B4
       .byte $07 ; |     XXX| $F6B5
       .byte $00 ; |        | $F6B6
       .byte $07 ; |     XXX| $F6B7
       .byte $07 ; |     XXX| $F6B8
       .byte $07 ; |     XXX| $F6B9
       .byte $00 ; |        | $F6BA
       .byte $00 ; |        | $F6BB
       .byte $00 ; |        | $F6BC
       .byte $07 ; |     XXX| $F6BD
       .byte $07 ; |     XXX| $F6BE
       .byte $07 ; |     XXX| $F6BF
       .byte $07 ; |     XXX| $F6C0
       .byte $07 ; |     XXX| $F6C1
       .byte $07 ; |     XXX| $F6C2
       .byte $07 ; |     XXX| $F6C3
       .byte $07 ; |     XXX| $F6C4
       .byte $07 ; |     XXX| $F6C5
       .byte $07 ; |     XXX| $F6C6
       .byte $07 ; |     XXX| $F6C7
       .byte $00 ; |        | $F6C8
       .byte $00 ; |        | $F6C9
       .byte $00 ; |        | $F6CA
       .byte $01 ; |       X| $F6CB
       .byte $03 ; |      XX| $F6CC
       .byte $07 ; |     XXX| $F6CD
       .byte $07 ; |     XXX| $F6CE
       .byte $07 ; |     XXX| $F6CF
       .byte $07 ; |     XXX| $F6D0
       .byte $07 ; |     XXX| $F6D1
       .byte $07 ; |     XXX| $F6D2
       .byte $03 ; |      XX| $F6D3
       .byte $01 ; |       X| $F6D4
       .byte $00 ; |        | $F6D5
       .byte $00 ; |        | $F6D6
       .byte $07 ; |     XXX| $F6D7
       .byte $07 ; |     XXX| $F6D8
       .byte $07 ; |     XXX| $F6D9
       .byte $07 ; |     XXX| $F6DA
       .byte $07 ; |     XXX| $F6DB
       .byte $07 ; |     XXX| $F6DC
       .byte $07 ; |     XXX| $F6DD
       .byte $07 ; |     XXX| $F6DE
       .byte $00 ; |        | $F6DF
       .byte $07 ; |     XXX| $F6E0
       .byte $07 ; |     XXX| $F6E1
       .byte $07 ; |     XXX| $F6E2
       .byte $00 ; |        | $F6E3
       .byte $00 ; |        | $F6E4
       .byte $00 ; |        | $F6E5
       .byte $01 ; |       X| $F6E6
       .byte $03 ; |      XX| $F6E7
       .byte $07 ; |     XXX| $F6E8
       .byte $07 ; |     XXX| $F6E9
       .byte $07 ; |     XXX| $F6EA
       .byte $07 ; |     XXX| $F6EB
       .byte $07 ; |     XXX| $F6EC
       .byte $07 ; |     XXX| $F6ED
       .byte $03 ; |      XX| $F6EE
       .byte $01 ; |       X| $F6EF
       .byte $00 ; |        | $F6F0
       .byte $00 ; |        | $F6F1
       .byte $00 ; |        | $F6F2
       .byte $1F ; |   XXXXX| $F6F3
       .byte $1F ; |   XXXXX| $F6F4
       .byte $1F ; |   XXXXX| $F6F5
       .byte $1F ; |   XXXXX| $F6F6
       .byte $1F ; |   XXXXX| $F6F7
       .byte $1F ; |   XXXXX| $F6F8
       .byte $1F ; |   XXXXX| $F6F9
       .byte $1F ; |   XXXXX| $F6FA
       .byte $1F ; |   XXXXX| $F6FB
       .byte $00 ; |        | $F6FC
       .byte $7F ; | XXXXXXX| $F6FD
       .byte $7F ; | XXXXXXX| $F6FE
       .byte $7F ; | XXXXXXX| $F6FF
LF700:
       .byte $00 ; |        | $F700
       .byte $00 ; |        | $F701
       .byte $00 ; |        | $F702
       .byte $00 ; |        | $F703
       .byte $00 ; |        | $F704
       .byte $00 ; |        | $F705
       .byte $00 ; |        | $F706
       .byte $00 ; |        | $F707
       .byte $00 ; |        | $F708
       .byte $00 ; |        | $F709
       .byte $00 ; |        | $F70A
       .byte $00 ; |        | $F70B
       .byte $00 ; |        | $F70C
       .byte $4A ; | X  X X | $F70D
       .byte $AA ; |X X X X | $F70E
       .byte $8E ; |X   XXX | $F70F
       .byte $AA ; |X X X X | $F710
       .byte $44 ; | X   X  | $F711
       .byte $00 ; |        | $F712
       .byte $03 ; |      XX| $F713
       .byte $C7 ; |XX   XXX| $F714
       .byte $CF ; |XX  XXXX| $F715
       .byte $DF ; |XX XXXXX| $F716
       .byte $DE ; |XX XXXX | $F717
       .byte $DC ; |XX XXX  | $F718
       .byte $DE ; |XX XXXX | $F719
       .byte $C7 ; |XX   XXX| $F71A
       .byte $C3 ; |XX    XX| $F71B
       .byte $07 ; |     XXX| $F71C
       .byte $FF ; |XXXXXXXX| $F71D
       .byte $FE ; |XXXXXXX | $F71E
       .byte $00 ; |        | $F71F
       .byte $00 ; |        | $F720
       .byte $00 ; |        | $F721
       .byte $FF ; |XXXXXXXX| $F722
       .byte $FF ; |XXXXXXXX| $F723
       .byte $80 ; |X       | $F724
       .byte $80 ; |X       | $F725
       .byte $FF ; |XXXXXXXX| $F726
       .byte $FF ; |XXXXXXXX| $F727
       .byte $8F ; |X   XXXX| $F728
       .byte $8F ; |X   XXXX| $F729
       .byte $FF ; |XXXXXXXX| $F72A
       .byte $FE ; |XXXXXXX | $F72B
       .byte $00 ; |        | $F72C
       .byte $00 ; |        | $F72D
       .byte $00 ; |        | $F72E
       .byte $FC ; |XXXXXX  | $F72F
       .byte $FF ; |XXXXXXXX| $F730
       .byte $FF ; |XXXXXXXX| $F731
       .byte $CF ; |XX  XXXX| $F732
       .byte $C7 ; |XX   XXX| $F733
       .byte $C7 ; |XX   XXX| $F734
       .byte $C7 ; |XX   XXX| $F735
       .byte $0F ; |    XXXX| $F736
       .byte $FF ; |XXXXXXXX| $F737
       .byte $FF ; |XXXXXXXX| $F738
       .byte $FC ; |XXXXXX  | $F739
       .byte $00 ; |        | $F73A
       .byte $00 ; |        | $F73B
       .byte $01 ; |       X| $F73C
       .byte $C3 ; |XX    XX| $F73D
       .byte $C7 ; |XX   XXX| $F73E
       .byte $CF ; |XX  XXXX| $F73F
       .byte $DF ; |XX XXXXX| $F740
       .byte $DF ; |XX XXXXX| $F741
       .byte $DF ; |XX XXXXX| $F742
       .byte $DF ; |XX XXXXX| $F743
       .byte $DB ; |XX XX XX| $F744
       .byte $D3 ; |XX X  XX| $F745
       .byte $C3 ; |XX    XX| $F746
       .byte $C3 ; |XX    XX| $F747
       .byte $00 ; |        | $F748
       .byte $00 ; |        | $F749
       .byte $00 ; |        | $F74A
       .byte $FF ; |XXXXXXXX| $F74B
       .byte $FF ; |XXXXXXXX| $F74C
       .byte $80 ; |X       | $F74D
       .byte $80 ; |X       | $F74E
       .byte $FF ; |XXXXXXXX| $F74F
       .byte $FF ; |XXXXXXXX| $F750
       .byte $8F ; |X   XXXX| $F751
       .byte $8F ; |X   XXXX| $F752
       .byte $FF ; |XXXXXXXX| $F753
       .byte $FE ; |XXXXXXX | $F754
       .byte $00 ; |        | $F755
       .byte $00 ; |        | $F756
       .byte $C0 ; |XX      | $F757
       .byte $C0 ; |XX      | $F758
       .byte $C0 ; |XX      | $F759
       .byte $C0 ; |XX      | $F75A
       .byte $C0 ; |XX      | $F75B
       .byte $FC ; |XXXXXX  | $F75C
       .byte $FC ; |XXXXXX  | $F75D
       .byte $C0 ; |XX      | $F75E
       .byte $00 ; |        | $F75F
       .byte $FF ; |XXXXXXXX| $F760
       .byte $FF ; |XXXXXXXX| $F761
       .byte $FF ; |XXXXXXXX| $F762
       .byte $00 ; |        | $F763
       .byte $00 ; |        | $F764
       .byte $00 ; |        | $F765
       .byte $FF ; |XXXXXXXX| $F766
       .byte $FF ; |XXXXXXXX| $F767
       .byte $80 ; |X       | $F768
       .byte $80 ; |X       | $F769
       .byte $FF ; |XXXXXXXX| $F76A
       .byte $FF ; |XXXXXXXX| $F76B
       .byte $8F ; |X   XXXX| $F76C
       .byte $8F ; |X   XXXX| $F76D
       .byte $FF ; |XXXXXXXX| $F76E
       .byte $FE ; |XXXXXXX | $F76F
       .byte $00 ; |        | $F770
       .byte $00 ; |        | $F771
       .byte $00 ; |        | $F772
       .byte $FF ; |XXXXXXXX| $F773
       .byte $FF ; |XXXXXXXX| $F774
       .byte $FF ; |XXXXXXXX| $F775
       .byte $87 ; |X    XXX| $F776
       .byte $83 ; |X     XX| $F777
       .byte $83 ; |X     XX| $F778
       .byte $83 ; |X     XX| $F779
       .byte $83 ; |X     XX| $F77A
       .byte $83 ; |X     XX| $F77B
       .byte $07 ; |     XXX| $F77C
       .byte $FF ; |XXXXXXXX| $F77D
       .byte $FF ; |XXXXXXXX| $F77E
       .byte $00 ; |        | $F77F
LF780:
       .byte $00 ; |        | $F780
       .byte $00 ; |        | $F781
       .byte $00 ; |        | $F782
       .byte $00 ; |        | $F783
       .byte $00 ; |        | $F784
       .byte $00 ; |        | $F785
       .byte $00 ; |        | $F786
       .byte $00 ; |        | $F787
       .byte $00 ; |        | $F788
       .byte $00 ; |        | $F789
       .byte $00 ; |        | $F78A
       .byte $00 ; |        | $F78B
       .byte $00 ; |        | $F78C
       .byte $CE ; |XX  XXX | $F78D
       .byte $A8 ; |X X X   | $F78E
       .byte $AC ; |X X XX  | $F78F
       .byte $A8 ; |X X X   | $F790
       .byte $CE ; |XX  XXX | $F791
       .byte $00 ; |        | $F792
       .byte $E0 ; |XXX     | $F793
       .byte $C0 ; |XX      | $F794
       .byte $80 ; |X       | $F795
       .byte $00 ; |        | $F796
       .byte $00 ; |        | $F797
       .byte $00 ; |        | $F798
       .byte $00 ; |        | $F799
       .byte $80 ; |X       | $F79A
       .byte $C0 ; |XX      | $F79B
       .byte $C0 ; |XX      | $F79C
       .byte $80 ; |X       | $F79D
       .byte $00 ; |        | $F79E
       .byte $00 ; |        | $F79F
       .byte $00 ; |        | $F7A0
       .byte $00 ; |        | $F7A1
       .byte $00 ; |        | $F7A2
       .byte $00 ; |        | $F7A3
       .byte $00 ; |        | $F7A4
       .byte $00 ; |        | $F7A5
       .byte $00 ; |        | $F7A6
       .byte $80 ; |X       | $F7A7
       .byte $80 ; |X       | $F7A8
       .byte $80 ; |X       | $F7A9
       .byte $00 ; |        | $F7AA
       .byte $00 ; |        | $F7AB
       .byte $00 ; |        | $F7AC
       .byte $00 ; |        | $F7AD
       .byte $00 ; |        | $F7AE
       .byte $00 ; |        | $F7AF
       .byte $00 ; |        | $F7B0
       .byte $80 ; |X       | $F7B1
       .byte $C0 ; |XX      | $F7B2
       .byte $C0 ; |XX      | $F7B3
       .byte $C0 ; |XX      | $F7B4
       .byte $C0 ; |XX      | $F7B5
       .byte $C0 ; |XX      | $F7B6
       .byte $80 ; |X       | $F7B7
       .byte $00 ; |        | $F7B8
       .byte $00 ; |        | $F7B9
       .byte $00 ; |        | $F7BA
       .byte $00 ; |        | $F7BB
       .byte $C0 ; |XX      | $F7BC
       .byte $C0 ; |XX      | $F7BD
       .byte $C0 ; |XX      | $F7BE
       .byte $C0 ; |XX      | $F7BF
       .byte $C0 ; |XX      | $F7C0
       .byte $C0 ; |XX      | $F7C1
       .byte $C0 ; |XX      | $F7C2
       .byte $C0 ; |XX      | $F7C3
       .byte $C0 ; |XX      | $F7C4
       .byte $C0 ; |XX      | $F7C5
       .byte $C0 ; |XX      | $F7C6
       .byte $C0 ; |XX      | $F7C7
       .byte $00 ; |        | $F7C8
       .byte $00 ; |        | $F7C9
       .byte $00 ; |        | $F7CA
       .byte $00 ; |        | $F7CB
       .byte $00 ; |        | $F7CC
       .byte $00 ; |        | $F7CD
       .byte $00 ; |        | $F7CE
       .byte $00 ; |        | $F7CF
       .byte $80 ; |X       | $F7D0
       .byte $80 ; |X       | $F7D1
       .byte $80 ; |X       | $F7D2
       .byte $00 ; |        | $F7D3
       .byte $00 ; |        | $F7D4
       .byte $00 ; |        | $F7D5
       .byte $00 ; |        | $F7D6
       .byte $00 ; |        | $F7D7
       .byte $00 ; |        | $F7D8
       .byte $00 ; |        | $F7D9
       .byte $00 ; |        | $F7DA
       .byte $00 ; |        | $F7DB
       .byte $00 ; |        | $F7DC
       .byte $00 ; |        | $F7DD
       .byte $00 ; |        | $F7DE
       .byte $00 ; |        | $F7DF
       .byte $80 ; |X       | $F7E0
       .byte $80 ; |X       | $F7E1
       .byte $80 ; |X       | $F7E2
       .byte $00 ; |        | $F7E3
       .byte $00 ; |        | $F7E4
       .byte $00 ; |        | $F7E5
       .byte $00 ; |        | $F7E6
       .byte $00 ; |        | $F7E7
       .byte $00 ; |        | $F7E8
       .byte $00 ; |        | $F7E9
       .byte $00 ; |        | $F7EA
       .byte $80 ; |X       | $F7EB
       .byte $80 ; |X       | $F7EC
       .byte $80 ; |X       | $F7ED
       .byte $00 ; |        | $F7EE
       .byte $00 ; |        | $F7EF
       .byte $00 ; |        | $F7F0
       .byte $00 ; |        | $F7F1
       .byte $00 ; |        | $F7F2
       .byte $00 ; |        | $F7F3
       .byte $C0 ; |XX      | $F7F4
       .byte $E0 ; |XXX     | $F7F5
       .byte $F0 ; |XXXX    | $F7F6
       .byte $F0 ; |XXXX    | $F7F7
       .byte $F0 ; |XXXX    | $F7F8
       .byte $F0 ; |XXXX    | $F7F9
       .byte $F0 ; |XXXX    | $F7FA
       .byte $F0 ; |XXXX    | $F7FB
       .byte $F0 ; |XXXX    | $F7FC
       .byte $E0 ; |XXX     | $F7FD
       .byte $C0 ; |XX      | $F7FE
       .byte $00 ; |        | $F7FF

DigitGfx:
Digit7:
       .byte $60 ; | XX     | $F800
       .byte $60 ; | XX     | $F801
       .byte $30 ; |  XX    | $F802
       .byte $18 ; |   XX   | $F803
       .byte $0C ; |    XX  | $F804
       .byte $0C ; |    XX  | $F805
       .byte $7C ; | XXXXX  | $F806
; NOTE: I shared the line between 2 and 3 instead to fix 1 ;)
;       As a matter of fact, more bytes could be saved here...
;       like sharing the upper part of 9 with the lower part
;       of 6, for example (3 more bytes saved). If you want
;       to edit the sprites, much more could be saved (tho the
;       digits won't look as good). The only thing you need to
;       be careful of is that all of the digits reside on the
;       same memory page (including the blank space)...because
;       only the low address byte is updated in the sprite
;       array (using table LF93E).
Digit1:
       .byte $0C ; |    XX  | $F806
       .byte $0C ; |    XX  | $F807
       .byte $0C ; |    XX  | $F808
       .byte $0C ; |    XX  | $F809
       .byte $6C ; | XX XX  | $F80A
       .byte $3C ; |  XXXX  | $F80B
       .byte $1C ; |   XXX  | $F80C

Digit5:
       .byte $7C ; | XXXXX  | $F80D
       .byte $04 ; |     X  | $F80E
       .byte $04 ; |     X  | $F80F
       .byte $7C ; | XXXXX  | $F810
       .byte $60 ; | XX     | $F811
       .byte $60 ; | XX     | $F812
Digit2:
       .byte $7C ; | XXXXX  | $F813 shared
       .byte $40 ; | X      | $F814
       .byte $20 ; |  X     | $F815
       .byte $18 ; |   XX   | $F816
       .byte $0C ; |    XX  | $F817
       .byte $4C ; | X  XX  | $F818
;;       .byte $7C ; | XXXXX  | $F819 upper 2/lower 3 byte identical anyway
Digit3:
       .byte $7C ; | XXXXX  | $F81A shared
       .byte $0C ; |    XX  | $F81B
       .byte $0C ; |    XX  | $F81C
       .byte $3C ; |  XXXX  | $F81D
       .byte $0C ; |    XX  | $F81E
       .byte $0C ; |    XX  | $F81F
Digit9:
       .byte $7C ; | XXXXX  | $F820 shared
       .byte $04 ; |     X  | $F821
       .byte $04 ; |     X  | $F822
       .byte $7C ; | XXXXX  | $F823 note: these 4 bytes identical to first 4 bytes of digit 6
       .byte $64 ; | XX  X  | $F824 ..
       .byte $64 ; | XX  X  | $F825 ..
Digit0:
       .byte $7C ; | XXXXX  | $F826 shared
       .byte $4C ; | X  XX  | $F827
       .byte $4C ; | X  XX  | $F828
       .byte $4C ; | X  XX  | $F829
       .byte $4C ; | X  XX  | $F82A
       .byte $4C ; | X  XX  | $F82B
Digit8:
       .byte $7C ; | XXXXX  | $F82C shared
       .byte $64 ; | XX  X  | $F82D
       .byte $64 ; | XX  X  | $F82E
       .byte $38 ; |  XXX   | $F82F
       .byte $64 ; | XX  X  | $F830
       .byte $64 ; | XX  X  | $F831
Digit6:
       .byte $7C ; | XXXXX  | $F832 shared
       .byte $64 ; | XX  X  | $F833
       .byte $64 ; | XX  X  | $F834
       .byte $7C ; | XXXXX  | $F835
       .byte $60 ; | XX     | $F836
       .byte $60 ; | XX     | $F837
       .byte $7C ; | XXXXX  | $F838

Digit4:
       .byte $0C ; |    XX  | $F839
       .byte $0C ; |    XX  | $F83A
       .byte $0c ; |    XX  | $F83B
       .byte $7C ; | XXXXX  | $F83C
       .byte $4C ; | X  XX  | $F83D
       .byte $2C ; |  X XX  | $F83E
       .byte $1C ; |   XXX  | $F83F



       .byte $70 ; | XXXXXXX| $F840
       .byte $FE ; |XXXXX X | $F841
       .byte $F8 ; |XXXXXX  | $F842
       .byte $E0 ; | XX     | $F843
       .byte $40 ; | X      | $F844
LF845:
       .byte $77 ; | XXX XXX| $F845
       .byte $77 ; | XXX XXX| $F846
       .byte $55 ; | X X X X| $F847
       .byte $55 ; | X X X X| $F848
       .byte $55 ; | X X X X| $F849
       .byte $77 ; | XXX XXX| $F84A
       .byte $77 ; | XXX XXX| $F84B
LF84C:
       .byte $77 ; | XXX XXX| $F84C
       .byte $47 ; | X   XXX| $F84D
       .byte $45 ; | X   X X| $F84E
       .byte $25 ; |  X  X X| $F84F
       .byte $15 ; |   X X X| $F850
       .byte $17 ; |   X XXX| $F851
       .byte $67 ; | XX  XXX| $F852
       .byte $DE ; |XX XXXX | $F853
       .byte $7F ; | XXXXXXX| $F854
       .byte $DE ; |XX XXXX | $F855
       .byte $66 ; | XX  XX | $F856
       .byte $66 ; | XX  XX | $F857
       .byte $66 ; | XX  XX | $F858
       .byte $77 ; | XXX XXX| $F859
       .byte $77 ; | XXX XXX| $F85A
       .byte $77 ; | XXX XXX| $F85B
       .byte $66 ; | XX  XX | $F85C
       .byte $66 ; | XX  XX | $F85D
       .byte $60 ; | XX     | $F85E
       .byte $60 ; | XX     | $F85F
       .byte $60 ; | XX     | $F860
       .byte $70 ; | XXX    | $F861
       .byte $70 ; | XXX    | $F862
       .byte $70 ; | XXX    | $F863
       .byte $60 ; | XX     | $F864
       .byte $60 ; | XX     | $F865
LF866:
       .byte $11 ; |   X   X| $F866
       .byte $11 ; |   X   X| $F867
       .byte $11 ; |   X   X| $F868
       .byte $79 ; | XXXX  X| $F869
       .byte $51 ; | X X   X| $F86A
       .byte $50 ; | X X    | $F86B
       .byte $50 ; | X X    | $F86C
LF86D:
       .byte $B3 ; |X XX  XX| $F86D
       .byte $B3 ; |X XX  XX| $F86E
       .byte $F3 ; |XXXX  XX| $F86F
       .byte $B3 ; |X XX  XX| $F870
       .byte $B3 ; |X XX  XX| $F871
       .byte $EB ; |XXX X XX| $F872
       .byte $4F ; | X  XXXX| $F873
LF874:
       .byte $36 ; |  XX XX | $F874
       .byte $36 ; |  XX XX | $F875
       .byte $3E ; |  XXXXX | $F876
       .byte $36 ; |  XX XX | $F877
       .byte $36 ; |  XX XX | $F878
       .byte $5C ; | X XXX  | $F879
       .byte $C8 ; |XX  X   | $F87A
LF87B:
       .byte $DB ; |XX XX XX| $F87B
       .byte $DB ; |XX XX XX| $F87C
       .byte $D3 ; |XX X  XX| $F87D
       .byte $F3 ; |XXXX  XX| $F87E
       .byte $DB ; |XX XX XX| $F87F
       .byte $DB ; |XX XX XX| $F880
       .byte $E3 ; |XXX   XX| $F881
LF882:
       .byte $27 ; |  X  XXX| $F882
       .byte $54 ; | X X X  | $F883
       .byte $54 ; | X X X  | $F884
       .byte $56 ; | X X XX | $F885
       .byte $54 ; | X X X  | $F886
       .byte $54 ; | X X X  | $F887
       .byte $57 ; | X X XXX| $F888
LF889:
       .byte $00 ; |        | $F889
       .byte $00 ; |        | $F88A
       .byte $00 ; |        | $F88B
       .byte $00 ; |        | $F88C
       .byte $00 ; |        | $F88D
       .byte $00 ; |        | $F88E
       .byte $00 ; |        | $F88F
       .byte $00 ; |        | $F890
       .byte $00 ; |XXXXXXX | $F891
       .byte $30 ; |  XX    | $F892
       .byte $30 ; |  XX    | $F893
       .byte $30 ; |  XX    | $F894
       .byte $38 ; |  XXX   | $F895
       .byte $38 ; |  XXX   | $F896
       .byte $38 ; |  XXX   | $F897
       .byte $30 ; |  XX    | $F898
       .byte $30 ; |  XX    | $F899
       .byte $00 ; |        | $F89A
       .byte $00 ; |        | $F89B
       .byte $00 ; |        | $F89C
       .byte $00 ; |        | $F89D
       .byte $30 ; |  XX    | $F89E
       .byte $30 ; |  XX    | $F89F
       .byte $30 ; |  XX    | $F8A0
       .byte $38 ; |  XXX   | $F8A1
       .byte $38 ; |  XXX   | $F8A2
       .byte $38 ; |  XXX   | $F8A3
       .byte $30 ; |  XX    | $F8A4
       .byte $30 ; |  XX    | $F8A5
       .byte $10 ; |   X    | $F8A6
       .byte $92 ; |X  X  X | $F8A7
       .byte $54 ; | X X X  | $F8A8
       .byte $38 ; |  XXX   | $F8A9
       .byte $FE ; |XXXXXXX | $F8AA
       .byte $92 ; |X  X  X | $F8AB
       .byte $92 ; |X  X  X | $F8AC
       .byte $7C ; | XXXXX  | $F8AD
       .byte $38 ; |  XXX   | $F8AE
       .byte $0F ; |    XXXX| $F8AF
       .byte $C6 ; |XX   XX | $F8B0
       .byte $54 ; | X X X  | $F8B1
       .byte $54 ; | X X X  | $F8B2
       .byte $54 ; | X X X  | $F8B3
       .byte $54 ; | X X X  | $F8B4
       .byte $54 ; | X X X  | $F8B5
       .byte $54 ; | X X X  | $F8B6
       .byte $C4 ; |XX   X  | $F8B7
       .byte $C4 ; |XX   X  | $F8B8
       .byte $00 ; |        | $F8B9
       .byte $C4 ; |XX   X  | $F8BA
       .byte $C4 ; |XX   X  | $F8BB
       .byte $C4 ; |XX   X  | $F8BC
       .byte $C4 ; |XX   X  | $F8BD
       .byte $C4 ; |XX   X  | $F8BE
       .byte $C4 ; |XX   X  | $F8BF
       .byte $E6 ; |XXX  XX | $F8C0
       .byte $C4 ; |XX   X  | $F8C1
       .byte $00 ; |        | $F8C2
       .byte $00 ; |        | $F8C3
       .byte $00 ; |        | $F8C4
       .byte $00 ; |        | $F8C5
       .byte $38 ; |  XXX   | $F8C6
       .byte $38 ; |  XXX   | $F8C7
       .byte $38 ; |  XXX   | $F8C8
       .byte $38 ; |  XXX   | $F8C9
       .byte $38 ; |  XXX   | $F8CA
       .byte $00 ; |        | $F8CB
       .byte $00 ; |        | $F8CC
       .byte $00 ; |        | $F8CD
       .byte $00 ; |        | $F8CE
       .byte $38 ; |  XXX   | $F8CF
       .byte $38 ; |  XXX   | $F8D0
       .byte $20 ; |  X     | $F8D1
       .byte $38 ; |  XXX   | $F8D2
       .byte $38 ; |  XXX   | $F8D3
       .byte $00 ; |        | $F8D4
       .byte $00 ; |        | $F8D5
       .byte $00 ; |        | $F8D6
       .byte $00 ; |        | $F8D7
       .byte $38 ; |  XXX   | $F8D8
       .byte $20 ; |  X     | $F8D9
       .byte $20 ; |  X     | $F8DA
       .byte $20 ; |  X     | $F8DB
       .byte $38 ; |  XXX   | $F8DC
       .byte $FF ; |XXXXXXXX| $F8DD
       .byte $FF ; |XXXXXXXX| $F8DE
       .byte $C4 ; |XX   X  | $F8DF
       .byte $C4 ; |XX   X  | $F8E0
       .byte $C4 ; |XX   X  | $F8E1
       .byte $C4 ; |XX   X  | $F8E2
       .byte $C4 ; |XX   X  | $F8E3
       .byte $00 ; |        | $F8E4
       .byte $00 ; |        | $F8E5
       .byte $00 ; |        | $F8E6
       .byte $00 ; |        | $F8E7
       .byte $08 ; |    X   | $F8E8
       .byte $88 ; |X   X   | $F8E9
       .byte $41 ; | X     X| $F8EA
       .byte $10 ; |   X    | $F8EB
       .byte $10 ; |   X    | $F8EC
       .byte $C1 ; |XX     X| $F8ED
       .byte $10 ; |   X    | $F8EE
       .byte $10 ; |   X    | $F8EF
       .byte $41 ; | X     X| $F8F0
       .byte $88 ; |X   X   | $F8F1
       .byte $08 ; |    X   | $F8F2
       .byte $0F ; |    XXXX| $F8F3
       .byte $0F ; |    XXXX| $F8F4
       .byte $0F ; |    XXXX| $F8F5
       .byte $0F ; |    XXXX| $F8F6
       .byte $0F ; |    XXXX| $F8F7
       .byte $00 ; |        | $F8F8
       .byte $00 ; |        | $F8F9
       .byte $0F ; |    XXXX| $F8FA
       .byte $00 ; |        | $F8FB
       .byte $00 ; |        | $F8FC
       .byte $0F ; |    XXXX| $F8FD
       .byte $0F ; |    XXXX| $F8FE
       .byte $0F ; |    XXXX| $F8FF

;55
LF900:
       STA    COLUP0                  ;3
       STA    COLUP1                  ;3
LF904:
       STY    rF0                     ;3
LF906:
       LDY    rF0                     ;3
       LDA    (rF2+10),Y              ;5
       STA    rF0+1                   ;3
       STA    WSYNC                   ;3
       LDA    (rF2+8),Y               ;5
       TAX                            ;2
       LDA    (rF2),Y                 ;5
       NOP                            ;2
       STA    GRP0                    ;3
       LDA    (rF2+2),Y               ;5
       STA    GRP1                    ;3
       LDA    (rF2+4),Y               ;5
       STA    GRP0                    ;3
       LDA    (rF2+6),Y               ;5
       LDY    rF0+1                   ;3
       STA    GRP1                    ;3
       STX    GRP0                    ;3
       STY    GRP1                    ;3
       STA    GRP0                    ;3
       DEC    rF0                     ;5
       BPL    LF906                   ;2
LF92E:
       LDA    #$00                    ;2
       STA    GRP0                    ;3
       STA    GRP1                    ;3
       STA    GRP0                    ;3
       RTS                            ;6

LF937:
       .byte $A5 ; |X X  X X| $F937
       .byte $55 ; | X X X X| $F938
       .byte $55 ; | X X X X| $F939
       .byte $57 ; | X X XXX| $F93A
       .byte $15 ; |   X X X| $F93B
       .byte $15 ; |   X X X| $F93C
       .byte $12 ; |   X  X | $F93D

LF93E: ;digit lookup table
        .byte <Digit0 ; $F93E
        .byte <Digit1 ; $F93F
        .byte <Digit2 ; $F940
        .byte <Digit3 ; $F941
        .byte <Digit4 ; $F942
        .byte <Digit5 ; $F943
        .byte <Digit6 ; $F944
        .byte <Digit7 ; $F945
        .byte <Digit8 ; $F946
        .byte <Digit9 ; $F947

LF948:
       .byte $08 ; |    X   | $F948
       .byte $0C ; |    XX  | $F949
       .byte $08 ; |    X   | $F94A
       .byte $0B ; |    X XX| $F94B
       .byte $0F ; |    XXXX| $F94C
       .byte $0C ; |    XX  | $F94D
       .byte $09 ; |    X  X| $F94E
       .byte $09 ; |    X  X| $F94F
       .byte $09 ; |    X  X| $F950
       .byte $0F ; |    XXXX| $F951
       .byte $0D ; |    XX X| $F952
       .byte $0B ; |    X XX| $F953
       .byte $0A ; |    X X | $F954
       .byte $08 ; |    X   | $F955
       .byte $08 ; |    X   | $F956
       .byte $08 ; |    X   | $F957
       .byte $09 ; |    X  X| $F958
       .byte $0D ; |    XX X| $F959
       .byte $0D ; |    XX X| $F95A
       .byte $08 ; |    X   | $F95B
LF95C:
       .byte $00 ; |        | $F95C
       .byte $13 ; |   X  XX| $F95D
       .byte $12 ; |   X  X | $F95E
       .byte $11 ; |   X   X| $F95F
LF960:
       .byte $11 ; |   X   X| $F960
       .byte $12 ; |   X  X | $F961
       .byte $13 ; |   X  XX| $F962
       .byte $00 ; |        | $F963
LF964:
       .byte $17 ; |   X XXX| $F964
       .byte $15 ; |   X X X| $F965
       .byte $15 ; |   X X X| $F966
       .byte $17 ; |   X XXX| $F967
       .byte $75 ; | XXX X X| $F968
       .byte $55 ; | X X X X| $F969
       .byte $77 ; | XXX XXX| $F96A
LF96B:
       .byte $C9 ; |XX  X  X| $F96B
       .byte $09 ; |    X  X| $F96C
       .byte $09 ; |    X  X| $F96D
       .byte $89 ; |X   X  X| $F96E
       .byte $09 ; |    X  X| $F96F
       .byte $09 ; |    X  X| $F970
       .byte $DD ; |XX XXX X| $F971
       .byte $00 ; |        | $F972
       .byte $00 ; |        | $F973
       .byte $00 ; |        | $F974
       .byte $00 ; |        | $F975
       .byte $00 ; |        | $F976
       .byte $00 ; |        | $F977
       .byte $00 ; |        | $F978
       .byte $00 ; |        | $F979
       .byte $00 ; |        | $F97A
       .byte $00 ; |        | $F97B
       .byte $00 ; |        | $F97C
       .byte $00 ; |        | $F97D
       .byte $00 ; |        | $F97E
       .byte $32 ; |  XX  X | $F97F
       .byte $32 ; |  XX  X | $F980
       .byte $32 ; |  XX  X | $F981
       .byte $32 ; |  XX  X | $F982
       .byte $32 ; |  XX  X | $F983
       .byte $32 ; |  XX  X | $F984
       .byte $32 ; |  XX  X | $F985
       .byte $32 ; |  XX  X | $F986
       .byte $32 ; |  XX  X | $F987
       .byte $E8 ; |XXX X   | $F988
       .byte $E8 ; |XXX X   | $F989
       .byte $E8 ; |XXX X   | $F98A
       .byte $E8 ; |XXX X   | $F98B
       .byte $E8 ; |XXX X   | $F98C
       .byte $E8 ; |XXX X   | $F98D
       .byte $E8 ; |XXX X   | $F98E
       .byte $E8 ; |XXX X   | $F98F
       .byte $E8 ; |XXX X   | $F990
       .byte $00 ; |        | $F991
       .byte $00 ; |        | $F992
       .byte $00 ; |        | $F993
       .byte $00 ; |        | $F994
       .byte $00 ; |   XX   | $F995
       .byte $00 ; |  XXXX  | $F996
       .byte $00 ; |   XX   | $F997
       .byte $00 ; |   X    | $F998
       .byte $00 ; |     XX | $F999
       .byte $00 ; |    XXXX| $F99A
       .byte $00 ; |     XX | $F99B
       .byte $00 ; |   X    | $F99C
       .byte $00 ; |   XX   | $F99D
       .byte $00 ; |  XXXX  | $F99E
       .byte $00 ; |   XX   | $F99F
       .byte $00 ; |        | $F9A0
       .byte $00 ; |        | $F9A1
       .byte $00 ; |        | $F9A2
       .byte $00 ; |        | $F9A3
       .byte $66 ; | XX  XX | $F9A4
       .byte $FF ; |XXXXXXXX| $F9A5
       .byte $66 ; | XX  XX | $F9A6
       .byte $10 ; |   X    | $F9A7
       .byte $18 ; |   XX   | $F9A8
       .byte $3C ; |  XXXX  | $F9A9
       .byte $18 ; |   XX   | $F9AA
       .byte $00 ; |        | $F9AB
       .byte $00 ; |        | $F9AC
       .byte $00 ; |        | $F9AD
       .byte $00 ; |        | $F9AE
       .byte $18 ; |   XX   | $F9AF
       .byte $3C ; |  XXXX  | $F9B0
       .byte $18 ; |   XX   | $F9B1
       .byte $10 ; |   X    | $F9B2
       .byte $60 ; | XX     | $F9B3
       .byte $F0 ; |XXXX    | $F9B4
       .byte $60 ; | XX     | $F9B5
       .byte $10 ; |   X    | $F9B6
       .byte $18 ; |   XX   | $F9B7
       .byte $3C ; |  XXXX  | $F9B8
       .byte $18 ; |   XX   | $F9B9
       .byte $00 ; |        | $F9BA
       .byte $00 ; |        | $F9BB
       .byte $00 ; |        | $F9BC
       .byte $00 ; |        | $F9BD
       .byte $18 ; |   XX   | $F9BE
       .byte $3C ; |  XXXX  | $F9BF
       .byte $18 ; |   XX   | $F9C0
       .byte $10 ; |   X    | $F9C1
       .byte $66 ; | XX  XX | $F9C2
       .byte $FF ; |XXXXXXXX| $F9C3
       .byte $66 ; | XX  XX | $F9C4
       .byte $10 ; |   X    | $F9C5
       .byte $10 ; |   X    | $F9C6
       .byte $10 ; |   X    | $F9C7
       .byte $10 ; |   X    | $F9C8
       .byte $0F ; |    XXXX| $F9C9
       .byte $0F ; |    XXXX| $F9CA
       .byte $44 ; | X   X  | $F9CB
       .byte $44 ; | X   X  | $F9CC
       .byte $44 ; | X   X  | $F9CD
       .byte $00 ; |        | $F9CE
       .byte $44 ; | X   X  | $F9CF
       .byte $44 ; | X   X  | $F9D0
       .byte $44 ; | X   X  | $F9D1
       .byte $00 ; |        | $F9D2
       .byte $44 ; | X   X  | $F9D3
       .byte $44 ; | X   X  | $F9D4
       .byte $44 ; | X   X  | $F9D5
       .byte $0F ; |    XXXX| $F9D6
       .byte $0F ; |    XXXX| $F9D7
       .byte $44 ; | X   X  | $F9D8
       .byte $44 ; | X   X  | $F9D9
       .byte $44 ; | X   X  | $F9DA
       .byte $00 ; |        | $F9DB
       .byte $44 ; | X   X  | $F9DC
       .byte $44 ; | X   X  | $F9DD
       .byte $44 ; | X   X  | $F9DE
       .byte $00 ; |        | $F9DF
       .byte $00 ; |        | $F9E0
       .byte $00 ; |        | $F9E1
       .byte $00 ; |        | $F9E2
       .byte $00 ; |        | $F9E3
       .byte $00 ; |        | $F9E4
       .byte $00 ; |        | $F9E5
       .byte $00 ; |        | $F9E6
       .byte $60 ; | XX     | $F9E7
       .byte $F0 ; |XXXX    | $F9E8
       .byte $60 ; | XX     | $F9E9
       .byte $10 ; |   X    | $F9EA
       .byte $18 ; |   XX   | $F9EB
       .byte $3C ; |  XXXX  | $F9EC
       .byte $18 ; |   XX   | $F9ED
       .byte $00 ; |        | $F9EE
       .byte $00 ; |        | $F9EF
       .byte $00 ; |        | $F9F0
       .byte $00 ; |        | $F9F1
       .byte $06 ; |     XX | $F9F2
       .byte $0F ; |    XXXX| $F9F3
       .byte $06 ; |     XX | $F9F4
       .byte $10 ; |   X    | $F9F5
       .byte $18 ; |   XX   | $F9F6
       .byte $3C ; |  XXXX  | $F9F7
       .byte $18 ; |   XX   | $F9F8
       .byte $44 ; | X   X  | $F9F9
       .byte $44 ; | X   X  | $F9FA
       .byte $44 ; | X   X  | $F9FB
       .byte $00 ; |        | $F9FC
       .byte $44 ; | X   X  | $F9FD
       .byte $44 ; | X   X  | $F9FE
       .byte $44 ; | X   X  | $F9FF
LFA00:
       .byte $00 ; |        | $FA00
       .byte $00 ; |        | $FA01
       .byte $01 ; |       X| $FA02
       .byte $01 ; |       X| $FA03
       .byte $01 ; |       X| $FA04
       .byte $01 ; |       X| $FA05
       .byte $01 ; |       X| $FA06
       .byte $01 ; |       X| $FA07
       .byte $00 ; |        | $FA08
       .byte $01 ; |       X| $FA09
       .byte $00 ; |        | $FA0A
       .byte $00 ; |        | $FA0B
       .byte $00 ; |        | $FA0C
       .byte $00 ; |        | $FA0D
       .byte $00 ; |        | $FA0E
       .byte $00 ; |        | $FA0F
       .byte $00 ; |        | $FA10
       .byte $00 ; |        | $FA11
       .byte $00 ; |        | $FA12
       .byte $00 ; |        | $FA13
LFA14:
       .byte $E6 ; |XXX  XX | $FA14
       .byte $AF ; |X X XXXX| $FA15
       .byte $89 ; |X   X  X| $FA16
       .byte $89 ; |X   X  X| $FA17
       .byte $89 ; |X   X  X| $FA18
       .byte $AF ; |X X XXXX| $FA19
       .byte $E6 ; |XXX  XX | $FA1A
LFA1B:
       .byte $45 ; | X   X X| $FA1B
       .byte $45 ; | X   X X| $FA1C
       .byte $55 ; | X X X X| $FA1D
       .byte $55 ; | X X X X| $FA1E
       .byte $7D ; | XXXXX X| $FA1F
       .byte $6D ; | XX XX X| $FA20
       .byte $45 ; | X   X X| $FA21
LFA22:
       .byte $1D ; |   XXX X| $FA22
       .byte $1D ; |   XXX X| $FA23
       .byte $11 ; |   X   X| $FA24
       .byte $D1 ; |XX X   X| $FA25
       .byte $51 ; | X X   X| $FA26
       .byte $51 ; | X X   X| $FA27
       .byte $D1 ; |XX X   X| $FA28
LFA29:
       .byte $FF ; |XXXXXXXX| $FA29
       .byte $00 ; |        | $FA2A
       .byte $00 ; |        | $FA2B
       .byte $01 ; |       X| $FA2C
       .byte $01 ; |       X| $FA2D
       .byte $02 ; |      X | $FA2E
       .byte $02 ; |      X | $FA2F
       .byte $03 ; |      XX| $FA30
       .byte $03 ; |      XX| $FA31
       .byte $03 ; |      XX| $FA32
       .byte $04 ; |     X  | $FA33
       .byte $04 ; |     X  | $FA34
       .byte $05 ; |     X X| $FA35
       .byte $05 ; |     X X| $FA36
       .byte $06 ; |     XX | $FA37
       .byte $06 ; |     XX | $FA38
       .byte $06 ; |     XX | $FA39
       .byte $06 ; |     XX | $FA3A

LFA3B:
       .word LFA99   ; $FA3B/C
       .word LF964   ; $FA3D/E
       .word LF866   ; $FA3F/40
       .word LF86D   ; $FA41/2
       .word LF874   ; $FA43/4
       .word LF87B   ; $FA45/6
       .word LFF00   ; $FA47/8
       .word LFF00   ; $FA49/A
       .word LF680   ; $FA4B/C
       .word LF700   ; $FA4D/E
       .word LF780   ; $FA4F/50
       .word LFF00   ; $FA51/2
       .word LF889   ; $FA53/4
       .word LF103   ; $FA55/6
       .word LF10A   ; $FA57/8
       .word LF111   ; $FA59/A
       .word LF937   ; $FA5B/C
       .word LF882   ; $FA5D/E
       .word LF889   ; $FA5F/60
       .word LF889   ; $FA61/2
       .word LF889   ; $FA63/4
       .word LF889   ; $FA65/6
       .word LF889   ; $FA67/8
       .word LF889   ; $FA69/A
       .word LFA14   ; $FA6B/C
       .word LFA1B   ; $FA6D/E
       .word LFA22   ; $FA6F/70
       .word LF96B   ; $FA71/2
       .word LFBF7   ; $FA73/4
       .word LF889   ; $FA75/6
       .word LFDF2   ; $FA77/8
       .word LFDF9   ; $FA79/A
       .word LFEF5   ; $FA7B/C
       .word LF84C   ; $FA7D/E
       .word LF845   ; $FA7F/80
       .word LF889   ; $FA81/2
       .word LFEA8   ; $FA83/4
       .word LFEAF   ; $FA85/6
       .word LFEB6   ; $FA87/8
       .word LFEBD   ; $FA89/A
       .word LFEC4   ; $FA8B/C
       .word LFECB   ; $FA8D/E
       .word LFED2   ; $FA8F/90
       .word LFED9   ; $FA91/2
       .word LFEE0   ; $FA93/4
       .word LFEE7   ; $FA95/6
       .word LFEEE   ; $FA97/8

LFA99:
       .byte $79 ; | XXXX  X| $FA99
       .byte $85 ; |X    X X| $FA9A
       .byte $B5 ; |X XX X X| $FA9B
       .byte $A5 ; |X X  X X| $FA9C
       .byte $B5 ; |X XX X X| $FA9D
       .byte $85 ; |X    X X| $FA9E
       .byte $79 ; | XXXX  X| $FA9F
       .byte $00 ; |        | $FACB
       .byte $00 ; |        | $FACC
       .byte $30 ; |        | $FACD
       .byte $00 ; |        | $FAA0
       .byte $00 ; |        | $FAA1
       .byte $7F ; |        | $FAA2
       .byte $7F ; | XXXXXXX| $FAA3
       .byte $01 ; | XXXXXXX| $FAA4
       .byte $FD ; |       X| $FAA5
       .byte $CD ; |XXXXXX X| $FAA6
       .byte $CD ; |XX  XX X| $FAA7
       .byte $FC ; |XX  XX X| $FAA8
       .byte $00 ; |XXXXXX  | $FAA9
       .byte $00 ; |        | $FAAA
       .byte $00 ; |        | $FAAB
       .byte $00 ; |        | $FAAC
       .byte $7F ; |        | $FAAD
LFAAB:
       .byte $7F ; | XXXXXXX| $FAAE
       .byte $01 ; | XXXXXXX| $FAAF
       .byte $FD ; |       X| $FAB0
       .byte $CD ; |XXXXXX X| $FAB1
       .byte $CD ; |XX  XX X| $FAB2
       .byte $FC ; |XX  XX X| $FAB3
       .byte $00 ; |XXXXXX  | $FAB4
       .byte $00 ; |        | $FAB5
       .byte $7F ; |        | $FAB6
       .byte $7F ; |        | $FAB7
       .byte $01 ; |        | $FAB8
       .byte $FD ; |XXXXXXX | $FAB9
       .byte $CD ; |XXXXXXX | $FABA
       .byte $CD ; |X       | $FABB
       .byte $FC ; |X XXXXXX| $FABC
       .byte $00 ; |X XX  XX| $FABD
       .byte $00 ; |X XX  XX| $FABE
       .byte $00 ; |  XXXXXX| $FABF
       .byte $00 ; |        | $FAC0
       .byte $00 ; |        | $FAC1
       .byte $00 ; |        | $FAC2
       .byte $00 ; |        | $FAC3
       .byte $7F ; |XXXXXXX | $FAC4
       .byte $7F ; |XXXXXXX | $FAC5
       .byte $01 ; |X       | $FAC6
       .byte $FD ; |X XXXXXX| $FAC7
       .byte $CD ; |X XX  XX| $FAC8
       .byte $CD ; |X XX  XX| $FAC9
       .byte $FC ; |  XXXXXX| $FACA
       .byte $0F ; |    XXXX| $FACE
       .byte $0F ; |    XXXX| $FACF
       .byte $D6 ; |XX X XX | $FAD0
       .byte $D6 ; |XX X XX | $FAD1
       .byte $D6 ; |XX X XX | $FAD2
       .byte $D6 ; |XX X XX | $FAD3
       .byte $D6 ; |XX X XX | $FAD4
       .byte $D6 ; |XX X XX | $FAD5
       .byte $D6 ; |XX X XX | $FAD6
       .byte $D6 ; |XX X XX | $FAD7
       .byte $0F ; |    XXXX| $FAD8
       .byte $0F ; |    XXXX| $FAD9
       .byte $E8 ; |XXX X   | $FADA
       .byte $E8 ; |XXX X   | $FADB
       .byte $E8 ; |XXX X   | $FADC
       .byte $E8 ; |XXX X   | $FADD
       .byte $E8 ; |XXX X   | $FADE
       .byte $E8 ; |XXX X   | $FADF
       .byte $E8 ; |XXX X   | $FAE0
       .byte $E8 ; |XXX X   | $FAE1
       .byte $0F ; |    XXXX| $FAE2
       .byte $0F ; |    XXXX| $FAE3
       .byte $D6 ; |XX X XX | $FAE4
       .byte $D6 ; |XX X XX | $FAE5
       .byte $D6 ; |XX X XX | $FAE6
       .byte $D6 ; |XX X XX | $FAE7
       .byte $00 ; |        | $FAE8
       .byte $00 ; |        | $FAE9
       .byte $0F ; |    XXXX| $FAEA
       .byte $0F ; |    XXXX| $FAEB
       .byte $56 ; | X X XX | $FAEC
       .byte $56 ; | X X XX | $FAED
       .byte $56 ; | X X XX | $FAEE
       .byte $56 ; | X X XX | $FAEF
       .byte $56 ; | X X XX | $FAF0
       .byte $56 ; | X X XX | $FAF1
       .byte $56 ; | X X XX | $FAF2
       .byte $56 ; | X X XX | $FAF3

;12
LFAF4:
       LDX    #$0B                    ;2
LFAF6:
       LDA    LFA3B,Y                 ;4
       STA    rF2,X                   ;4
       DEY                            ;2
       DEX                            ;2
       BPL    LFAF6                   ;2
       RTS                            ;6

LFB00:
       .byte $D8 ; |XX XX   | $FB00
       .byte $D8 ; |XX XX   | $FB01
       .byte $D8 ; |XX XX   | $FB02
       .byte $D8 ; |XX XX   | $FB03
       .byte $DE ; |XX XXXX | $FB04
       .byte $EA ; |XXX X X | $FB05
       .byte $F2 ; |XXXX  X | $FB06
       .byte $FA ; |XXXXX X | $FB07
       .byte $CB ; |XX  X XX| $FB08
       .byte $D4 ; |XX X X  | $FB09
       .byte $DD ; |XX XXX X| $FB0A
       .byte $D4 ; |XX X X  | $FB0B
       .byte $AB ; |X X X XX| $FB0C
       .byte $BD ; |X XXXX X| $FB0D
       .byte $C8 ; |XX  X   | $FB0E
       .byte $DA ; |XX XX X | $FB0F
       .byte $D3 ; |XX X  XX| $FB10
       .byte $D3 ; |XX X  XX| $FB11
       .byte $D3 ; |XX X  XX| $FB12
       .byte $D3 ; |XX X  XX| $FB13
       .byte $AB ; |X X X XX| $FB14
       .byte $B5 ; |X XX X X| $FB15
       .byte $BE ; |X XXXXX | $FB16
       .byte $B5 ; |X XX X X| $FB17
       .byte $A0 ; |X X     | $FB18
       .byte $AB ; |X X X XX| $FB19
       .byte $BA ; |X XXX X | $FB1A
       .byte $C9 ; |XX  X  X| $FB1B
       .byte $EE ; |XXX XXX | $FB1C
       .byte $BA ; |X XXX X | $FB1D
       .byte $A0 ; |X X     | $FB1E
       .byte $F9 ; |XXXXX  X| $FB1F
       .byte $C1 ; |XX     X| $FB20
       .byte $C1 ; |XX     X| $FB21
       .byte $C1 ; |XX     X| $FB22
       .byte $C1 ; |XX     X| $FB23
       .byte $9E ; |X  XXXX | $FB24
       .byte $B2 ; |X XX  X | $FB25
       .byte $C7 ; |XX   XXX| $FB26
       .byte $D3 ; |XX X  XX| $FB27
       .byte $A4 ; |X X  X  | $FB28
       .byte $B2 ; |X XX  X | $FB29
       .byte $BB ; |X XXX XX| $FB2A
       .byte $C4 ; |XX   X  | $FB2B
       .byte $EC ; |XXX XX  | $FB2C
       .byte $F7 ; |XXXX XXX| $FB2D
       .byte $EC ; |XXX XX  | $FB2E
       .byte $F7 ; |XXXX XXX| $FB2F
       .byte $AC ; |X X XX  | $FB30
       .byte $B8 ; |X XXX   | $FB31
       .byte $C2 ; |XX    X | $FB32
       .byte $CE ; |XX  XXX | $FB33
       .byte $AF ; |X X XXXX| $FB34
       .byte $AF ; |X X XXXX| $FB35
       .byte $AF ; |X X XXXX| $FB36
       .byte $AF ; |X X XXXX| $FB37
       .byte $A6 ; |X X  XX | $FB38
       .byte $A6 ; |X X  XX | $FB39
       .byte $A6 ; |X X  XX | $FB3A
       .byte $A6 ; |X X  XX | $FB3B
       .byte $A6 ; |X X  XX | $FB3C
       .byte $A6 ; |X X  XX | $FB3D
       .byte $A6 ; |X X  XX | $FB3E
       .byte $A6 ; |X X  XX | $FB3F
       .byte $7F ; | XXXXXXX| $FB40
       .byte $7F ; | XXXXXXX| $FB41
       .byte $7F ; | XXXXXXX| $FB42
       .byte $7F ; | XXXXXXX| $FB43
       .byte $E4 ; |XXX  X  | $FB44
       .byte $E4 ; |XXX  X  | $FB45
       .byte $E4 ; |XXX  X  | $FB46
       .byte $E4 ; |XXX  X  | $FB47
       .byte $F2 ; |XXXX  X | $FB48
       .byte $F2 ; |XXXX  X | $FB49
       .byte $F2 ; |XXXX  X | $FB4A
       .byte $F2 ; |XXXX  X | $FB4B
       .byte $F3 ; |XXXX  XX| $FB4C
       .byte $F3 ; |XXXX  XX| $FB4D
       .byte $F3 ; |XXXX  XX| $FB4E
       .byte $F3 ; |XXXX  XX| $FB4F
LFB50:
       .byte $DF ; |XX XXXXX| $FB50
       .byte $DF ; |XX XXXXX| $FB51
       .byte $DF ; |XX XXXXX| $FB52
       .byte $DF ; |XX XXXXX| $FB53
       .byte $FE ; |XXXXXXX | $FB54
       .byte $FE ; |XXXXXXX | $FB55
       .byte $E2 ; |XXX   X | $FB56
       .byte $E2 ; |XXX   X | $FB57
       .byte $E4 ; |XXX  X  | $FB58
       .byte $E4 ; |XXX  X  | $FB59
       .byte $E4 ; |XXX  X  | $FB5A
       .byte $E4 ; |XXX  X  | $FB5B
       .byte $E1 ; |XXX    X| $FB5C
       .byte $E1 ; |XXX    X| $FB5D
       .byte $E1 ; |XXX    X| $FB5E
       .byte $E1 ; |XXX    X| $FB5F
       .byte $A6 ; |X X  XX | $FB60
       .byte $BB ; |X XXX XX| $FB61
       .byte $E6 ; |XXX  XX | $FB62
       .byte $F0 ; |XXXX    | $FB63
       .byte $C7 ; |XX   XXX| $FB64
       .byte $CF ; |XX  XXXX| $FB65
       .byte $D6 ; |XX X XX | $FB66
       .byte $CF ; |XX  XXXX| $FB67
       .byte $D6 ; |XX X XX | $FB68
       .byte $D2 ; |XX X  X | $FB69
       .byte $D6 ; |XX X XX | $FB6A
       .byte $E3 ; |XXX   XX| $FB6B
       .byte $00 ; |        | $FB6C
       .byte $E3 ; |XXX   XX| $FB6D
       .byte $E3 ; |XXX   XX| $FB6E
       .byte $00 ; |        | $FB6F
       .byte $CE ; |XX  XXX | $FB70
       .byte $CE ; |XX  XXX | $FB71
       .byte $CE ; |XX  XXX | $FB72
       .byte $CE ; |XX  XXX | $FB73
       .byte $DD ; |XX XXX X| $FB74
       .byte $DD ; |XX XXX X| $FB75
       .byte $DD ; |XX XXX X| $FB76
       .byte $DD ; |XX XXX X| $FB77
       .byte $A9 ; |X X X  X| $FB78
       .byte $CF ; |XX  XXXX| $FB79
       .byte $D7 ; |XX X XXX| $FB7A
       .byte $CF ; |XX  XXXX| $FB7B
       .byte $CF ; |XX  XXXX| $FB7C
       .byte $B2 ; |X XX  X | $FB7D
       .byte $CF ; |XX  XXXX| $FB7E
       .byte $B2 ; |X XX  X | $FB7F
       .byte $D8 ; |XX XX   | $FB80
       .byte $E2 ; |XXX   X | $FB81
       .byte $EA ; |XXX X X | $FB82
       .byte $F4 ; |XXXX X  | $FB83
       .byte $C2 ; |XX    X | $FB84
       .byte $C2 ; |XX    X | $FB85
       .byte $C2 ; |XX    X | $FB86
       .byte $C2 ; |XX    X | $FB87
       .byte $B9 ; |X XXX  X| $FB88
       .byte $B9 ; |X XXX  X| $FB89
       .byte $B9 ; |X XXX  X| $FB8A
       .byte $B9 ; |X XXX  X| $FB8B
       .byte $B9 ; |X XXX  X| $FB8C
       .byte $B9 ; |X XXX  X| $FB8D
       .byte $B9 ; |X XXX  X| $FB8E
       .byte $B9 ; |X XXX  X| $FB8F
       .byte $88 ; |X   X   | $FB90
       .byte $88 ; |X   X   | $FB91
       .byte $88 ; |X   X   | $FB92
       .byte $91 ; |X  X   X| $FB93
       .byte $D0 ; |XX X    | $FB94
       .byte $D0 ; |XX X    | $FB95
       .byte $D0 ; |XX X    | $FB96
       .byte $D0 ; |XX X    | $FB97
       .byte $CF ; |XX  XXXX| $FB98
       .byte $CF ; |XX  XXXX| $FB99
       .byte $CF ; |XX  XXXX| $FB9A
       .byte $CF ; |XX  XXXX| $FB9B
       .byte $00 ; |        | $FB9C
       .byte $00 ; |        | $FB9D
       .byte $00 ; |        | $FB9E
       .byte $00 ; |        | $FB9F
       .byte $00 ; |        | $FBA0
       .byte $00 ; |        | $FBA1
       .byte $00 ; |        | $FBA2
       .byte $00 ; |        | $FBA3
       .byte $00 ; | XXXXX  | $FBA4
       .byte $00 ; | XXXXX  | $FBA5
       .byte $00 ; | XXXXX  | $FBA6
       .byte $7E ; | XXXXX  | $FBA7
       .byte $E7 ; | XXXXX  | $FBA8
       .byte $66 ; | XXXXX  | $FBA9
       .byte $3C ; | XXXXX  | $FBAA
       .byte $42 ; | X    X | $FBAB
       .byte $42 ; | X    X | $FBAC
       .byte $42 ; | X    X | $FBAD
       .byte $42 ; | X    X | $FBAE
       .byte $42 ; | X    X | $FBAF
       .byte $42 ; | X    X | $FBB0
       .byte $42 ; | X    X | $FBB1
       .byte $00 ; |        | $FBB2
       .byte $00 ; |        | $FBB3
       .byte $00 ; |        | $FBB4
       .byte $00 ; |        | $FBB5
       .byte $00 ; | XXXXX  | $FBB6
       .byte $00 ; | XX     | $FBB7
       .byte $00 ; | XX     | $FBB8
       .byte $7E ; | XX     | $FBB9
       .byte $CF ; | XX     | $FBBA
       .byte $4E ; | XX     | $FBBB
       .byte $3C ; | XXXXX  | $FBBC
       .byte $00 ; |        | $FBBD
       .byte $00 ; |        | $FBBE
       .byte $00 ; |        | $FBBF
       .byte $00 ; |        | $FBC0
       .byte $00 ; | XXXXX  | $FBC1
       .byte $00 ; | XXXXX  | $FBC2
       .byte $00 ; | XX     | $FBC3
       .byte $7E ; | XX     | $FBC4
       .byte $E7 ; | XX     | $FBC5
       .byte $66 ; | XXXXX  | $FBC6
       .byte $3C ; | XXXXX  | $FBC7
       .byte $64 ; | XX  X  | $FBC8
       .byte $64 ; | XX  X  | $FBC9
       .byte $64 ; | XX  X  | $FBCA
       .byte $64 ; | XX  X  | $FBCB
       .byte $64 ; | XX  X  | $FBCC
       .byte $64 ; | XX  X  | $FBCD
       .byte $64 ; | XX  X  | $FBCE
       .byte $00 ; |        | $FBCF
LFBD0:
       .byte $00 ; |        | $FBD0
       .byte $00 ; |        | $FBD1
       .byte $00 ; |        | $FBD2
       .byte $00 ; | XXXXX  | $FBD3
       .byte $00 ; | XXXXX  | $FBD4
       .byte $00 ; | XXXXX  | $FBD5
       .byte $7E ; | XX     | $FBD6
       .byte $F3 ; | XXXXX  | $FBD7
       .byte $72 ; | XXXXX  | $FBD8
       .byte $3C ; | XXXXX  | $FBD9
       .byte $0C ; |    XX  | $FBDA
       .byte $56 ; | X X XX | $FBDB
       .byte $56 ; | X X XX | $FBDC
       .byte $56 ; | X X XX | $FBDD
       .byte $56 ; | X X XX | $FBDE
       .byte $56 ; | X X XX | $FBDF
       .byte $0C ; |    XX  | $FBE0
       .byte $00 ; |        | $FBE1
       .byte $00 ; |        | $FBE2
       .byte $00 ; |        | $FBE3
       .byte $00 ; |        | $FBE4
       .byte $10 ; |   X    | $FBE5
       .byte $10 ; |   X    | $FBE6
       .byte $38 ; |  XXX   | $FBE7
       .byte $FE ; |XXXXXXX | $FBE8
       .byte $38 ; |  XXX   | $FBE9
       .byte $10 ; |   X    | $FBEA
       .byte $10 ; |   X    | $FBEB
       .byte $00 ; |        | $FBEC
       .byte $00 ; |        | $FBED
       .byte $00 ; |        | $FBEE
       .byte $00 ; |        | $FBEF
       .byte $10 ; |   X    | $FBF0
       .byte $54 ; | X X X  | $FBF1
       .byte $38 ; |  XXX   | $FBF2
       .byte $7C ; | XXXXX  | $FBF3
       .byte $38 ; |  XXX   | $FBF4
       .byte $54 ; | X X X  | $FBF5
       .byte $10 ; |   X    | $FBF6
LFBF7:
       .byte $D8 ; |XX XX   | $FBF7
       .byte $14 ; |   X X  | $FBF8
       .byte $14 ; |   X X  | $FBF9
       .byte $94 ; |X  X X  | $FBFA
       .byte $14 ; |   X X  | $FBFB
       .byte $14 ; |   X X  | $FBFC
       .byte $D8 ; |XX XX   | $FBFD
       .byte $00 ; |        | $FBFE
       .byte $00 ; |        | $FBFF
       .byte $30 ; |  XX    | $FC00
       .byte $B8 ; |X XXX   | $FC01
       .byte $28 ; |  X X   | $FC02
       .byte $B0 ; |X XX    | $FC03
       .byte $20 ; |  X     | $FC04
       .byte $A8 ; |X X X   | $FC05
       .byte $18 ; |   XX   | $FC06
       .byte $A0 ; |X X     | $FC07
       .byte $10 ; |   X    | $FC08
       .byte $98 ; |X  XX   | $FC09
       .byte $08 ; |    X   | $FC0A
       .byte $90 ; |X  X    | $FC0B
       .byte $00 ; |        | $FC0C
       .byte $88 ; |X   X   | $FC0D
       .byte $78 ; | XXXX   | $FC0E
       .byte $80 ; |X       | $FC0F
       .byte $70 ; | XXX    | $FC10
       .byte $F8 ; |XXXXX   | $FC11
       .byte $68 ; | XX X   | $FC12
       .byte $F0 ; |XXXX    | $FC13
       .byte $60 ; | XX     | $FC14
       .byte $E8 ; |XXX X   | $FC15
       .byte $58 ; | X XX   | $FC16
       .byte $E0 ; |XXX     | $FC17
       .byte $50 ; | X X    | $FC18
       .byte $D8 ; |XX XX   | $FC19
       .byte $48 ; | X  X   | $FC1A
       .byte $D0 ; |XX X    | $FC1B
       .byte $40 ; | X      | $FC1C
       .byte $C8 ; |XX  X   | $FC1D
       .byte $32 ; |  XX  X | $FC1E
       .byte $BA ; |X XXX X | $FC1F
       .byte $2A ; |  X X X | $FC20
       .byte $B2 ; |X XX  X | $FC21
       .byte $22 ; |  X   X | $FC22
       .byte $AA ; |X X X X | $FC23
       .byte $1A ; |   XX X | $FC24
       .byte $A2 ; |X X   X | $FC25
       .byte $12 ; |   X  X | $FC26
       .byte $9A ; |X  XX X | $FC27
       .byte $0A ; |    X X | $FC28
       .byte $92 ; |X  X  X | $FC29
       .byte $02 ; |      X | $FC2A
       .byte $8A ; |X   X X | $FC2B
       .byte $7A ; | XXXX X | $FC2C
       .byte $82 ; |X     X | $FC2D
       .byte $72 ; | XXX  X | $FC2E
       .byte $FA ; |XXXXX X | $FC2F
       .byte $6A ; | XX X X | $FC30
       .byte $F2 ; |XXXX  X | $FC31
       .byte $62 ; | XX   X | $FC32
       .byte $EA ; |XXX X X | $FC33
       .byte $5A ; | X XX X | $FC34
       .byte $E2 ; |XXX   X | $FC35
       .byte $52 ; | X X  X | $FC36
       .byte $DA ; |XX XX X | $FC37
       .byte $4A ; | X  X X | $FC38
       .byte $D2 ; |XX X  X | $FC39
       .byte $42 ; | X    X | $FC3A
       .byte $CA ; |XX  X X | $FC3B
       .byte $34 ; |  XX X  | $FC3C
       .byte $BC ; |X XXXX  | $FC3D
       .byte $2C ; |  X XX  | $FC3E
       .byte $B4 ; |X XX X  | $FC3F
       .byte $24 ; |  X  X  | $FC40
       .byte $AC ; |X X XX  | $FC41
       .byte $1C ; |   XXX  | $FC42
       .byte $A4 ; |X X  X  | $FC43
       .byte $14 ; |   X X  | $FC44
       .byte $9C ; |X  XXX  | $FC45
       .byte $0C ; |    XX  | $FC46
       .byte $94 ; |X  X X  | $FC47
       .byte $04 ; |     X  | $FC48
       .byte $8C ; |X   XX  | $FC49
       .byte $7C ; | XXXXX  | $FC4A
       .byte $84 ; |X    X  | $FC4B
       .byte $74 ; | XXX X  | $FC4C
       .byte $FC ; |XXXXXX  | $FC4D
       .byte $6C ; | XX XX  | $FC4E
       .byte $F4 ; |XXXX X  | $FC4F
       .byte $29 ; |  X X  X| $FC50
       .byte $B1 ; |X XX   X| $FC51
       .byte $21 ; |  X    X| $FC52
       .byte $A9 ; |X X X  X| $FC53
       .byte $19 ; |   XX  X| $FC54
       .byte $A1 ; |X X    X| $FC55
       .byte $11 ; |   X   X| $FC56
       .byte $99 ; |X  XX  X| $FC57
       .byte $09 ; |    X  X| $FC58
       .byte $91 ; |X  X   X| $FC59
       .byte $01 ; |       X| $FC5A
       .byte $89 ; |X   X  X| $FC5B
       .byte $79 ; | XXXX  X| $FC5C
       .byte $81 ; |X      X| $FC5D
       .byte $71 ; | XXX   X| $FC5E
       .byte $F9 ; |XXXXX  X| $FC5F
       .byte $69 ; | XX X  X| $FC60
       .byte $F1 ; |XXXX   X| $FC61
       .byte $61 ; | XX    X| $FC62
       .byte $E9 ; |XXX X  X| $FC63
       .byte $59 ; | X XX  X| $FC64
       .byte $E1 ; |XXX    X| $FC65
       .byte $51 ; | X X   X| $FC66
       .byte $D9 ; |XX XX  X| $FC67
       .byte $49 ; | X  X  X| $FC68
       .byte $D1 ; |XX X   X| $FC69
       .byte $41 ; | X     X| $FC6A
       .byte $C9 ; |XX  X  X| $FC6B
       .byte $33 ; |  XX  XX| $FC6C
       .byte $BB ; |X XXX XX| $FC6D
       .byte $2B ; |  X X XX| $FC6E
       .byte $B3 ; |X XX  XX| $FC6F
       .byte $23 ; |  X   XX| $FC70
       .byte $AB ; |X X X XX| $FC71
       .byte $1B ; |   XX XX| $FC72
       .byte $A3 ; |X X   XX| $FC73
       .byte $13 ; |   X  XX| $FC74
       .byte $9B ; |X  XX XX| $FC75
       .byte $0B ; |    X XX| $FC76
       .byte $93 ; |X  X  XX| $FC77
       .byte $03 ; |      XX| $FC78
       .byte $8B ; |X   X XX| $FC79
       .byte $7B ; | XXXX XX| $FC7A
       .byte $83 ; |X     XX| $FC7B
       .byte $73 ; | XXX  XX| $FC7C
       .byte $FB ; |XXXXX XX| $FC7D
       .byte $6B ; | XX X XX| $FC7E
       .byte $F3 ; |XXXX  XX| $FC7F
       .byte $63 ; | XX   XX| $FC80
       .byte $EB ; |XXX X XX| $FC81
       .byte $5B ; | X XX XX| $FC82
       .byte $E3 ; |XXX   XX| $FC83
       .byte $53 ; | X X  XX| $FC84
       .byte $DB ; |XX XX XX| $FC85
       .byte $4B ; | X  X XX| $FC86
       .byte $D3 ; |XX X  XX| $FC87
       .byte $43 ; | X    XX| $FC88
       .byte $CB ; |XX  X XX| $FC89
       .byte $35 ; |  XX X X| $FC8A
       .byte $BD ; |X XXXX X| $FC8B
       .byte $2D ; |  X XX X| $FC8C
       .byte $B5 ; |X XX X X| $FC8D
       .byte $25 ; |  X  X X| $FC8E
       .byte $AD ; |X X XX X| $FC8F
       .byte $1D ; |   XXX X| $FC90
       .byte $A5 ; |X X  X X| $FC91
       .byte $15 ; |   X X X| $FC92
       .byte $9D ; |X  XXX X| $FC93
       .byte $0D ; |    XX X| $FC94
       .byte $95 ; |X  X X X| $FC95
       .byte $05 ; |     X X| $FC96
       .byte $8D ; |X   XX X| $FC97
       .byte $7D ; | XXXXX X| $FC98
       .byte $85 ; |X    X X| $FC99
       .byte $75 ; | XXX X X| $FC9A
       .byte $FD ; |XXXXXX X| $FC9B
       .byte $6D ; | XX XX X| $FC9C
       .byte $F5 ; |XXXX X X| $FC9D
       .byte $65 ; | XX  X X| $FC9E
       .byte $ED ; |XXX XX X| $FC9F
       .byte $00 ; |        | $FCA0
       .byte $00 ; |        | $FCA1
       .byte $00 ; |        | $FCA2
       .byte $00 ; |        | $FCA3
       .byte $30 ; |  XX    | $FCA4
       .byte $78 ; | XXXX   | $FCA5
       .byte $30 ; |  XX    | $FCA6
       .byte $7E ; | XXXXXX | $FCA7
       .byte $30 ; |  XX    | $FCA8
       .byte $78 ; | XXXX   | $FCA9
       .byte $30 ; |  XX    | $FCAA
       .byte $00 ; |        | $FCAB
       .byte $00 ; |        | $FCAC
       .byte $00 ; |        | $FCAD
       .byte $00 ; |        | $FCAE
       .byte $30 ; |  XX    | $FCAF
       .byte $78 ; | XXXX   | $FCB0
       .byte $7E ; | XXXXXX | $FCB1
       .byte $78 ; | XXXX   | $FCB2
       .byte $30 ; |  XX    | $FCB3
       .byte $10 ; |   X    | $FCB4
       .byte $00 ; |        | $FCB5
       .byte $00 ; |        | $FCB6
       .byte $00 ; |        | $FCB7
       .byte $00 ; |        | $FCB8
       .byte $30 ; |  XX    | $FCB9
       .byte $7E ; | XXXXXX | $FCBA
       .byte $30 ; |  XX    | $FCBB
       .byte $10 ; |   X    | $FCBC
       .byte $10 ; |   X    | $FCBD
       .byte $0F ; |    XXXX| $FCBE
       .byte $0F ; |    XXXX| $FCBF
       .byte $E6 ; |XXX  XX | $FCC0
       .byte $56 ; | X X XX | $FCC1
       .byte $56 ; | X X XX | $FCC2
       .byte $E6 ; |XXX  XX | $FCC3
       .byte $C4 ; |XX   X  | $FCC4
       .byte $C4 ; |XX   X  | $FCC5
       .byte $E6 ; |XXX  XX | $FCC6
       .byte $0F ; |    XXXX| $FCC7
       .byte $0F ; |    XXXX| $FCC8
       .byte $56 ; | X X XX | $FCC9
       .byte $56 ; | X X XX | $FCCA
       .byte $C4 ; |XX   X  | $FCCB
       .byte $56 ; | X X XX | $FCCC
       .byte $56 ; | X X XX | $FCCD
       .byte $00 ; |        | $FCCE
       .byte $0F ; |    XXXX| $FCCF
       .byte $0F ; |    XXXX| $FCD0
       .byte $56 ; | X X XX | $FCD1
       .byte $E6 ; |XXX  XX | $FCD2
       .byte $56 ; | X X XX | $FCD3
       .byte $00 ; |        | $FCD4
       .byte $00 ; |        | $FCD5
       .byte $00 ; |        | $FCD6
       .byte $00 ; |        | $FCD7
       .byte $00 ; |        | $FCD8
       .byte $00 ; |        | $FCD9
       .byte $7E ; | XXXXXX | $FCDA
       .byte $CF ; |XX  XXXX| $FCDB
       .byte $4E ; | X  XXX | $FCDC
       .byte $3C ; |  XXXX  | $FCDD
       .byte $C4 ; |XX   X  | $FCDE
       .byte $56 ; | X X XX | $FCDF
       .byte $56 ; | X X XX | $FCE0
       .byte $C4 ; |XX   X  | $FCE1
       .byte $00 ; |        | $FCE2
       .byte $00 ; |        | $FCE3
       .byte $00 ; |        | $FCE4
       .byte $00 ; |        | $FCE5
       .byte $7E ; | XXXXXX | $FCE6
       .byte $E7 ; |XXX  XXX| $FCE7
       .byte $66 ; | XX  XX | $FCE8
       .byte $3C ; |  XXXX  | $FCE9
       .byte $00 ; |        | $FCEA
       .byte $00 ; |        | $FCEB
       .byte $00 ; |        | $FCEC
       .byte $00 ; |        | $FCED
       .byte $7E ; | XXXXXX | $FCEE
       .byte $F3 ; |XXXX  XX| $FCEF
       .byte $72 ; | XXX  X | $FCF0
       .byte $3C ; |  XXXX  | $FCF1
       .byte $00 ; |        | $FCF2
       .byte $00 ; |        | $FCF3
       .byte $00 ; |        | $FCF4
       .byte $00 ; |        | $FCF5
       .byte $7E ; | XXXXXX | $FCF6
       .byte $DB ; |XX XX XX| $FCF7
       .byte $5A ; | X XX X | $FCF8
       .byte $3C ; |  XXXX  | $FCF9
       .byte $C4 ; |XX   X  | $FCFA
       .byte $E6 ; |XXX  XX | $FCFB
       .byte $E6 ; |XXX  XX | $FCFC
       .byte $C4 ; |XX   X  | $FCFD
       .byte $00 ; |        | $FCFE
       .byte $00 ; |        | $FCFF
       .byte $00 ; |        | $FD00
       .byte $00 ; |        | $FD01
       .byte $00 ; |        | $FD02
       .byte $00 ; |        | $FD03
       .byte $00 ; |        | $FD04
       .byte $00 ; |        | $FD05
       .byte $00 ; |        | $FD06
       .byte $00 ; |        | $FD07
       .byte $00 ; |        | $FD08
       .byte $00 ; |        | $FD09
       .byte $00 ; |        | $FD0A
       .byte $00 ; |        | $FD0B
       .byte $00 ; |        | $FD0C
       .byte $00 ; |        | $FD0D
       .byte $00 ; |        | $FD0E
       .byte $00 ; |        | $FD0F
       .byte $00 ; |        | $FD10
       .byte $00 ; |        | $FD11
       .byte $00 ; |        | $FD12
       .byte $00 ; |        | $FD13
       .byte $00 ; |        | $FD14
       .byte $00 ; |        | $FD15
       .byte $00 ; |        | $FD16
       .byte $00 ; |        | $FD17
       .byte $00 ; |        | $FD18
       .byte $00 ; |        | $FD19
       .byte $00 ; |        | $FD1A
       .byte $00 ; |        | $FD1B
       .byte $00 ; |        | $FD1C
       .byte $00 ; |        | $FD1D
       .byte $00 ; |        | $FD1E
       .byte $00 ; |        | $FD1F
       .byte $00 ; |        | $FD20
       .byte $00 ; |        | $FD21
       .byte $00 ; |        | $FD22
       .byte $00 ; |        | $FD23
       .byte $00 ; |        | $FD24
       .byte $00 ; |        | $FD25
       .byte $00 ; |        | $FD26
       .byte $00 ; |        | $FD27
       .byte $00 ; |        | $FD28
       .byte $00 ; |        | $FD29
       .byte $00 ; |        | $FD2A
       .byte $00 ; |        | $FD2B
       .byte $00 ; |        | $FD2C
       .byte $00 ; |        | $FD2D
       .byte $00 ; |        | $FD2E
       .byte $00 ; |        | $FD2F
       .byte $00 ; |        | $FD30
       .byte $00 ; |        | $FD31
       .byte $00 ; |        | $FD32
       .byte $00 ; |        | $FD33
       .byte $00 ; |        | $FD34
       .byte $00 ; |        | $FD35
       .byte $00 ; |        | $FD36
       .byte $00 ; |        | $FD37
       .byte $00 ; |        | $FD38
       .byte $00 ; |        | $FD39
       .byte $00 ; |        | $FD3A
       .byte $00 ; |        | $FD3B
       .byte $00 ; |        | $FD3C
       .byte $00 ; |        | $FD3D
       .byte $00 ; |        | $FD3E
       .byte $00 ; |        | $FD3F
       .byte $00 ; |        | $FD40
       .byte $00 ; |        | $FD41
       .byte $00 ; |        | $FD42
       .byte $00 ; |        | $FD43
       .byte $00 ; |        | $FD44
       .byte $00 ; |        | $FD45
       .byte $00 ; |        | $FD46
       .byte $00 ; |        | $FD47
       .byte $00 ; |        | $FD48
       .byte $00 ; |        | $FD49
       .byte $00 ; |        | $FD4A
       .byte $00 ; |        | $FD4B
       .byte $00 ; |        | $FD4C
       .byte $00 ; |        | $FD4D
       .byte $00 ; |        | $FD4E
       .byte $00 ; |        | $FD4F
       .byte $00 ; |        | $FD50
       .byte $00 ; |        | $FD51
       .byte $00 ; |        | $FD52
       .byte $00 ; |        | $FD53
       .byte $00 ; |        | $FD54
       .byte $00 ; |        | $FD55
       .byte $00 ; |        | $FD56
       .byte $00 ; |        | $FD57
       .byte $00 ; |        | $FD58
       .byte $00 ; |        | $FD59
       .byte $00 ; |        | $FD5A
       .byte $00 ; |        | $FD5B
       .byte $00 ; |        | $FD5C
       .byte $00 ; |        | $FD5D
       .byte $00 ; |        | $FD5E
       .byte $00 ; |        | $FD5F
       .byte $00 ; |        | $FD60
       .byte $00 ; |        | $FD61
       .byte $00 ; |        | $FD62
       .byte $00 ; |        | $FD63
       .byte $00 ; |        | $FD64
       .byte $00 ; |        | $FD65
       .byte $00 ; |        | $FD66
       .byte $00 ; |        | $FD67
       .byte $00 ; |        | $FD68
       .byte $00 ; |        | $FD69
       .byte $00 ; |        | $FD6A
       .byte $00 ; |        | $FD6B
       .byte $00 ; |        | $FD6C
       .byte $00 ; |        | $FD6D
       .byte $00 ; |        | $FD6E
       .byte $00 ; |        | $FD6F
       .byte $00 ; |        | $FD70
       .byte $00 ; |        | $FD71
       .byte $00 ; |        | $FD72
       .byte $00 ; |        | $FD73
       .byte $00 ; |        | $FD74
       .byte $00 ; |        | $FD75
       .byte $00 ; |        | $FD76
       .byte $00 ; |        | $FD77
       .byte $00 ; |        | $FD78
       .byte $00 ; |        | $FD79
       .byte $00 ; |        | $FD7A
       .byte $00 ; |        | $FD7B
       .byte $00 ; |        | $FD7C
       .byte $00 ; |        | $FD7D
       .byte $00 ; |        | $FD7E
       .byte $00 ; |        | $FD7F
       .byte $00 ; |        | $FD80
       .byte $00 ; |        | $FD81
       .byte $00 ; |        | $FD82
       .byte $00 ; |        | $FD83
       .byte $00 ; |        | $FD84
       .byte $00 ; |        | $FD85
       .byte $00 ; |        | $FD86
       .byte $00 ; |        | $FD87
       .byte $00 ; |        | $FD88
       .byte $00 ; |        | $FD89
       .byte $00 ; |        | $FD8A
       .byte $00 ; |        | $FD8B
       .byte $18 ; |   XX   | $FD8C
       .byte $18 ; |   XX   | $FD8D
       .byte $18 ; |   XX   | $FD8E
       .byte $38 ; |  XXX   | $FD8F
       .byte $38 ; |  XXX   | $FD90
       .byte $38 ; |  XXX   | $FD91
       .byte $18 ; |   XX   | $FD92
       .byte $18 ; |   XX   | $FD93
       .byte $00 ; |        | $FD94
       .byte $00 ; |        | $FD95
       .byte $70 ; | XXXX   | $FD96
       .byte $FF ; |XXXXXXXX| $FD97
       .byte $FA ; |XXXX  X | $FD98
       .byte $E0 ; | XX     | $FD99
       .byte $40 ; |        | $FD9A
       .byte $00 ; |        | $FD9B
       .byte $00 ; |        | $FD9C
       .byte $00 ; |        | $FD9D
       .byte $00 ; |        | $FD9E
       .byte $00 ; |        | $FD9F
       .byte $28 ; |  X X   | $FDA0
       .byte $54 ; | X X X  | $FDA1
       .byte $28 ; |  X X   | $FDA2
       .byte $0F ; |    XXXX| $FDA3
       .byte $0F ; |    XXXX| $FDA4
       .byte $46 ; | X   XX | $FDA5
       .byte $46 ; | X   XX | $FDA6
       .byte $46 ; | X   XX | $FDA7
       .byte $00 ; |        | $FDA8
       .byte $00 ; |        | $FDA9
       .byte $00 ; |        | $FDAA
       .byte $00 ; |        | $FDAB
       .byte $00 ; |        | $FDAC
       .byte $10 ; |   X    | $FDAD
       .byte $28 ; |  X X   | $FDAE
       .byte $50 ; | X X    | $FDAF
       .byte $20 ; |  X     | $FDB0
       .byte $10 ; |   X    | $FDB1
       .byte $00 ; |        | $FDB2
       .byte $00 ; |        | $FDB3
       .byte $00 ; |        | $FDB4
       .byte $00 ; |        | $FDB5
       .byte $10 ; |   X    | $FDB6
       .byte $28 ; |  X X   | $FDB7
       .byte $10 ; |   X    | $FDB8
       .byte $28 ; |  X X   | $FDB9
       .byte $10 ; |   X    | $FDBA
       .byte $00 ; |        | $FDBB
       .byte $00 ; |        | $FDBC
       .byte $00 ; |        | $FDBD
       .byte $00 ; |        | $FDBE
       .byte $10 ; |   X    | $FDBF
       .byte $28 ; |  X X   | $FDC0
       .byte $14 ; |   X X  | $FDC1
       .byte $08 ; |    X   | $FDC2
       .byte $10 ; |   X    | $FDC3
       .byte $0F ; |    XXXX| $FDC4
       .byte $0F ; |    XXXX| $FDC5
       .byte $0F ; |    XXXX| $FDC6
       .byte $0F ; |    XXXX| $FDC7
       .byte $0F ; |    XXXX| $FDC8
       .byte $0F ; |    XXXX| $FDC9
       .byte $EA ; |XXX X X | $FDCA
       .byte $EA ; |XXX X X | $FDCB
       .byte $EA ; |XXX X X | $FDCC
       .byte $EA ; |XXX X X | $FDCD
       .byte $00 ; |        | $FDCE
       .byte $00 ; |        | $FDCF
       .byte $0F ; |    XXXX| $FDD0
       .byte $0F ; |    XXXX| $FDD1
       .byte $46 ; | X   XX | $FDD2
       .byte $46 ; | X   XX | $FDD3
       .byte $46 ; | X   XX | $FDD4
       .byte $46 ; | X   XX | $FDD5
       .byte $46 ; | X   XX | $FDD6
       .byte $00 ; |        | $FDD7
       .byte $00 ; |        | $FDD8
       .byte $00 ; |        | $FDD9
       .byte $00 ; |        | $FDDA
       .byte $08 ; |    X   | $FDDB
       .byte $2A ; |  X X X | $FDDC
       .byte $14 ; |   X X  | $FDDD
       .byte $22 ; |  X   X | $FDDE
       .byte $14 ; |   X X  | $FDDF
       .byte $2A ; |  X X X | $FDE0
       .byte $08 ; |    X   | $FDE1
       .byte $10 ; |   X    | $FDE2
       .byte $10 ; |   X    | $FDE3
       .byte $00 ; |        | $FDE4
       .byte $00 ; |        | $FDE5
       .byte $00 ; |        | $FDE6
       .byte $00 ; |        | $FDE7
       .byte $08 ; |    X   | $FDE8
       .byte $49 ; | X  X  X| $FDE9
       .byte $22 ; |  X   X | $FDEA
       .byte $08 ; |    X   | $FDEB
       .byte $63 ; | XX   XX| $FDEC
       .byte $08 ; |    X   | $FDED
       .byte $22 ; |  X   X | $FDEE
       .byte $49 ; | X  X  X| $FDEF
       .byte $08 ; |    X   | $FDF0
       .byte $10 ; |   X    | $FDF1
LFDF2:
       .byte $C4 ; |XX   X  | $FDF2
       .byte $AA ; |X X X X | $FDF3
       .byte $AA ; |X X X X | $FDF4
       .byte $CA ; |XX  X X | $FDF5
       .byte $AA ; |X X X X | $FDF6
       .byte $AA ; |X X X X | $FDF7
       .byte $C4 ; |XX   X  | $FDF8
LFDF9:
       .byte $97 ; |X  X XXX| $FDF9
       .byte $97 ; |X  X XXX| $FDFA
       .byte $B5 ; |X XX X X| $FDFB
       .byte $F5 ; |XXXX X X| $FDFC
       .byte $D5 ; |XX X X X| $FDFD
       .byte $95 ; |X  X X X| $FDFE
       .byte $95 ; |X  X X X| $FDFF
       .byte $1F ; |  X XXXX| $FE00 Was $2F - Suggested by Supercat - lessen the planet surface
       .byte $1F ; |  X XXXX| $FE01    |
       .byte $1F ; |  X XXXX| $FE02    |
       .byte $1F ; |  X XXXX| $FE03   \|/
       .byte $1F ; |  X XXXX| $FE04
       .byte $1F ; |  X XXXX| $FE05
       .byte $1F ; |  X XXXX| $FE06
       .byte $1F ; |  X XXXX| $FE07
       .byte $1F ; |  X XXXX| $FE08
       .byte $1F ; |  X XXXX| $FE09
       .byte $1F ; |  X XXXX| $FE0A
       .byte $1F ; |  X XXXX| $FE0B
       .byte $1F ; |  X XXXX| $FE0C
       .byte $1F ; |  X XXXX| $FE0D
       .byte $1F ; |  X XXXX| $FE0E
       .byte $1F ; |  X XXXX| $FE0F
       .byte $1F ; |  X XXXX| $FE10
       .byte $1F ; |  X XXXX| $FE11
       .byte $1F ; |  X XXXX| $FE12
       .byte $1F ; |  X XXXX| $FE13
       .byte $1F ; |  X XXXX| $FE14
       .byte $1F ; |  X XXXX| $FE15
       .byte $1F ; |  X XXXX| $FE16
       .byte $1F ; |  X XXXX| $FE17
       .byte $1F ; |  X XXXX| $FE18
       .byte $1F ; |  X XXXX| $FE19   /|\
       .byte $1F ; |  X XXXX| $FE1A    |
       .byte $1F ; |  X XXXX| $FE1B    |
       .byte $1F ; |  X XXXX| $FE1C was $2F
       .byte $10 ; |  X     | $FE1D
       .byte $10 ; |  X     | $FE1E
       .byte $10 ; |  X     | $FE1F
       .byte $10 ; |  X     | $FE20
       .byte $10 ; |  X     | $FE21
       .byte $00 ; |        | $FE22
       .byte $00 ; |        | $FE23
       .byte $00 ; |        | $FE24
       .byte $00 ; |        | $FE25
       .byte $00 ; |        | $FE26
       .byte $0F ; |    XXXX| $FE27
       .byte $00 ; |        | $FE28
       .byte $00 ; |        | $FE29
       .byte $00 ; |        | $FE2A
       .byte $00 ; |        | $FE2B
       .byte $00 ; |        | $FE2C
       .byte $00 ; |        | $FE2D
       .byte $00 ; |        | $FE2E
       .byte $00 ; |        | $FE2F
       .byte $00 ; |        | $FE30
       .byte $0F ; |    XXXX| $FE31
       .byte $00 ; |        | $FE32
       .byte $00 ; |        | $FE33
       .byte $00 ; |        | $FE34
       .byte $00 ; |        | $FE35
       .byte $00 ; |        | $FE36
       .byte $00 ; |        | $FE37
       .byte $00 ; |        | $FE38
       .byte $00 ; |        | $FE39
       .byte $00 ; |        | $FE3A
       .byte $00 ; |        | $FE3B
       .byte $00 ; |        | $FE3C
       .byte $00 ; |        | $FE3D
       .byte $00 ; |        | $FE3E
       .byte $00 ; |        | $FE3F
       .byte $00 ; |        | $FE40
       .byte $00 ; |        | $FE41
       .byte $00 ; |        | $FE42
       .byte $0F ; |    XXXX| $FE43
       .byte $00 ; |        | $FE44
       .byte $00 ; |        | $FE45
       .byte $00 ; |        | $FE46
       .byte $00 ; |        | $FE47
       .byte $00 ; |        | $FE48
       .byte $00 ; |        | $FE49
       .byte $00 ; |        | $FE4A
       .byte $00 ; |        | $FE4B
       .byte $00 ; |        | $FE4C
       .byte $0F ; |    XXXX| $FE4D
       .byte $00 ; |        | $FE4E
       .byte $00 ; |        | $FE4F
       .byte $00 ; |        | $FE50
       .byte $00 ; |        | $FE51
       .byte $00 ; |        | $FE52
       .byte $00 ; |        | $FE53
       .byte $00 ; |        | $FE54
       .byte $00 ; |        | $FE55
       .byte $00 ; |        | $FE56
       .byte $00 ; |        | $FE57
       .byte $00 ; |        | $FE58
       .byte $00 ; |        | $FE59
       .byte $00 ; |        | $FE5A
       .byte $00 ; |        | $FE5B
       .byte $00 ; |        | $FE5C
       .byte $0F ; |    XXXX| $FE5D
       .byte $00 ; |        | $FE5E
       .byte $00 ; |        | $FE5F
       .byte $00 ; |        | $FE60
       .byte $00 ; |        | $FE61
       .byte $00 ; |        | $FE62
       .byte $00 ; |        | $FE63
       .byte $00 ; |        | $FE64
       .byte $00 ; |        | $FE65
       .byte $00 ; |        | $FE66
       .byte $0F ; |    XXXX| $FE67
       .byte $00 ; |        | $FE68
       .byte $00 ; |        | $FE69
       .byte $00 ; |        | $FE6A
       .byte $00 ; |        | $FE6B
       .byte $00 ; |        | $FE6C
       .byte $00 ; |        | $FE6D
       .byte $00 ; |        | $FE6E
       .byte $00 ; |        | $FE6F
       .byte $00 ; |        | $FE70
       .byte $00 ; |        | $FE71
       .byte $00 ; |        | $FE72
       .byte $00 ; |        | $FE73
       .byte $00 ; |        | $FE74
       .byte $00 ; |        | $FE75
       .byte $00 ; |        | $FE76
       .byte $00 ; |        | $FE77
       .byte $00 ; |        | $FE78
       .byte $00 ; |        | $FE79
       .byte $00 ; |        | $FE7A
       .byte $00 ; |        | $FE7B
       .byte $00 ; |        | $FE7C
       .byte $0F ; |    XXXX| $FE7D
       .byte $00 ; |        | $FE7E
       .byte $00 ; |        | $FE7F
       .byte $00 ; |        | $FE80
       .byte $00 ; |        | $FE81
       .byte $00 ; |        | $FE82
       .byte $00 ; |        | $FE83
       .byte $00 ; |        | $FE84
       .byte $0F ; |    XXXX| $FE85
       .byte $00 ; |        | $FE86
       .byte $00 ; |        | $FE87
       .byte $00 ; |        | $FE88
       .byte $00 ; |        | $FE89
       .byte $00 ; |        | $FE8A
       .byte $00 ; |        | $FE8B
       .byte $00 ; |        | $FE8C
       .byte $00 ; |        | $FE8D
       .byte $00 ; |        | $FE8E
       .byte $00 ; |        | $FE8F
       .byte $00 ; |        | $FE90
       .byte $00 ; |        | $FE91
       .byte $00 ; |        | $FE92
       .byte $00 ; |        | $FE93
       .byte $00 ; |        | $FE94
       .byte $00 ; |        | $FE95
       .byte $00 ; |        | $FE96
       .byte $0F ; |    XXXX| $FE97
       .byte $00 ; |        | $FE98
       .byte $00 ; |        | $FE99
       .byte $00 ; |        | $FE9A
       .byte $00 ; |        | $FE9B
       .byte $00 ; |        | $FE9C
       .byte $00 ; |        | $FE9D
       .byte $00 ; |        | $FE9E
       .byte $00 ; |        | $FE9F
       .byte $00 ; |        | $FEA0
       .byte $0F ; |    XXXX| $FEA1
       .byte $00 ; |        | $FEA2
       .byte $00 ; |        | $FEA3
       .byte $00 ; |        | $FEA4
       .byte $00 ; |        | $FEA5
       .byte $00 ; |        | $FEA6
       .byte $00 ; |        | $FEA7
LFEA8:
       .byte $65 ; | XX  X X| $FEA8
       .byte $95 ; |X  X X X| $FEA9
       .byte $95 ; |X  X X X| $FEAA
       .byte $A7 ; |X X  XXX| $FEAB
       .byte $85 ; |X    X X| $FEAC
       .byte $95 ; |X  X X X| $FEAD
       .byte $62 ; | XX   X | $FEAE
LFEAF:
       .byte $55 ; | X X X X| $FEAF
       .byte $55 ; | X X X X| $FEB0
       .byte $55 ; | X X X X| $FEB1
       .byte $55 ; | X X X X| $FEB2
       .byte $55 ; | X X X X| $FEB3
       .byte $55 ; | X X X X| $FEB4
       .byte $29 ; |  X X  X| $FEB5
LFEB6:
       .byte $C0 ; |XX      | $FEB6
       .byte $00 ; |        | $FEB7
       .byte $00 ; |        | $FEB8
       .byte $80 ; |X       | $FEB9
       .byte $00 ; |        | $FEBA
       .byte $00 ; |        | $FEBB
       .byte $C0 ; |XX      | $FEBC
LFEBD:
       .byte $62 ; | XX   X | $FEBD
       .byte $95 ; |X  X X X| $FEBE
       .byte $95 ; |X  X X X| $FEBF
       .byte $95 ; |X  X X X| $FEC0
       .byte $95 ; |X  X X X| $FEC1
       .byte $95 ; |X  X X X| $FEC2
       .byte $65 ; | XX  X X| $FEC3
LFEC4:
       .byte $75 ; | XXX X X| $FEC4
       .byte $45 ; | X   X X| $FEC5
       .byte $45 ; | X   X X| $FEC6
       .byte $66 ; | XX  XX | $FEC7
       .byte $45 ; | X   X X| $FEC8
       .byte $45 ; | X   X X| $FEC9
       .byte $76 ; | XXX XX | $FECA
LFECB:
       .byte $52 ; | X X  X | $FECB
       .byte $AA ; |X X X X | $FECC
       .byte $AA ; |X X X X | $FECD
       .byte $AB ; |X X X XX| $FECE
       .byte $8A ; |X   X X | $FECF
       .byte $8A ; |X   X X | $FED0
       .byte $89 ; |X   X  X| $FED1
LFED2:
       .byte $AA ; |X X X X | $FED2
       .byte $AA ; |X X X X | $FED3
       .byte $AA ; |X X X X | $FED4
       .byte $B3 ; |X XX  XX| $FED5
       .byte $AA ; |X X X X | $FED6
       .byte $AA ; |X X X X | $FED7
       .byte $33 ; |  XX  XX| $FED8
LFED9:
       .byte $04 ; |     X  | $FED9
       .byte $05 ; |     X X| $FEDA
       .byte $05 ; |     X X| $FEDB
       .byte $05 ; |     X X| $FEDC
       .byte $85 ; |X    X X| $FEDD
       .byte $85 ; |X    X X| $FEDE
       .byte $0E ; |    XXX | $FEDF
LFEE0:
       .byte $87 ; |X    XXX| $FEE0
       .byte $44 ; | X   X  | $FEE1
       .byte $44 ; | X   X  | $FEE2
       .byte $44 ; | X   X  | $FEE3
       .byte $44 ; | X   X  | $FEE4
       .byte $44 ; | X   X  | $FEE5
       .byte $84 ; |X    X  | $FEE6
LFEE7:
       .byte $72 ; | XXX  X | $FEE7
       .byte $45 ; | X   X X| $FEE8
       .byte $45 ; | X   X X| $FEE9
       .byte $65 ; | XX  X X| $FEEA
       .byte $45 ; | X   X X| $FEEB
       .byte $45 ; | X   X X| $FEEC
       .byte $75 ; | XXX X X| $FEED
LFEEE:
       .byte $77 ; | XXX XXX| $FEEE
       .byte $44 ; | X   X  | $FEEF
       .byte $44 ; | X   X  | $FEF0
       .byte $64 ; | XX  X  | $FEF1
       .byte $44 ; | X   X  | $FEF2
       .byte $44 ; | X   X  | $FEF3
       .byte $74 ; | XXX X  | $FEF4
LFEF5:
       .byte $70 ; | XXX    | $FEF5
       .byte $10 ; |   X    | $FEF6
       .byte $15 ; |   X X X| $FEF7
       .byte $72 ; | XXX  X | $FEF8
       .byte $45 ; | X   X X| $FEF9
       .byte $40 ; | X      | $FEFA
       .byte $70 ; | XXX    | $FEFB
LFEFC:
       .byte $B9 ; |X XXX  X| $FEFC
       .byte $B1 ; |X XX   X| $FEFD
LFEFE:
       .byte $0A ; |    X X | $FEFE
       .byte $02 ; |      X | $FEFF
LFF00:
       .byte $00 ; |        | $FF00
       .byte $00 ; |        | $FF01
       .byte $00 ; |        | $FF02
       .byte $00 ; |        | $FF03
       .byte $00 ; |        | $FF04
       .byte $00 ; |        | $FF05
       .byte $00 ; |        | $FF06
       .byte $00 ; |        | $FF07
       .byte $00 ; |        | $FF08
       .byte $00 ; |        | $FF09
       .byte $00 ; |        | $FF0A
       .byte $00 ; |        | $FF0B
       .byte $00 ; |        | $FF0C
       .byte $00 ; |        | $FF0D
       .byte $00 ; |        | $FF0E
       .byte $00 ; |        | $FF0F
       .byte $00 ; |        | $FF10
       .byte $00 ; |        | $FF11
       .byte $00 ; |        | $FF12
       .byte $00 ; |        | $FF13
       .byte $00 ; |        | $FF14
       .byte $00 ; |        | $FF15
       .byte $00 ; |        | $FF16
       .byte $00 ; |        | $FF17
       .byte $00 ; |        | $FF18
       .byte $00 ; |        | $FF19
       .byte $00 ; |        | $FF1A
       .byte $00 ; |        | $FF1B
       .byte $00 ; |        | $FF1C
       .byte $00 ; |        | $FF1D
       .byte $00 ; |        | $FF1E
       .byte $00 ; |        | $FF1F
       .byte $00 ; |        | $FF20
       .byte $00 ; |        | $FF21
       .byte $00 ; |        | $FF22
       .byte $00 ; |        | $FF23
       .byte $00 ; |        | $FF24
       .byte $00 ; |        | $FF25
       .byte $00 ; |        | $FF26
       .byte $00 ; |        | $FF27
       .byte $00 ; |        | $FF28
       .byte $00 ; |        | $FF29
       .byte $00 ; |        | $FF2A
       .byte $00 ; |        | $FF2B
       .byte $00 ; |        | $FF2C
       .byte $00 ; |        | $FF2D
       .byte $00 ; |        | $FF2E
       .byte $00 ; |        | $FF2F
       .byte $00 ; |        | $FF30
       .byte $00 ; |        | $FF31
       .byte $00 ; |        | $FF32
       .byte $00 ; |        | $FF33
       .byte $00 ; |        | $FF34
       .byte $00 ; |        | $FF35
       .byte $00 ; |        | $FF36
       .byte $00 ; |        | $FF37
       .byte $00 ; |        | $FF38
       .byte $00 ; |        | $FF39
       .byte $00 ; |        | $FF3A
       .byte $00 ; |        | $FF3B
       .byte $00 ; |        | $FF3C
       .byte $00 ; |        | $FF3D
       .byte $00 ; |        | $FF3E
       .byte $00 ; |        | $FF3F
       .byte $00 ; |        | $FF40
       .byte $00 ; |        | $FF41
       .byte $00 ; |        | $FF42
       .byte $00 ; |        | $FF43
       .byte $00 ; |        | $FF44
       .byte $00 ; |        | $FF45
       .byte $00 ; |        | $FF46
       .byte $00 ; |        | $FF47
       .byte $00 ; |        | $FF48
       .byte $00 ; |        | $FF49
       .byte $00 ; |        | $FF4A
       .byte $00 ; |        | $FF4B
       .byte $00 ; |        | $FF4C
       .byte $00 ; |        | $FF4D
       .byte $00 ; |        | $FF4E
       .byte $00 ; |        | $FF4F
       .byte $00 ; |        | $FF50
       .byte $00 ; |        | $FF51
       .byte $00 ; |        | $FF52
       .byte $00 ; |        | $FF53
       .byte $00 ; |        | $FF54
       .byte $00 ; |        | $FF55
       .byte $00 ; |        | $FF56
       .byte $00 ; |        | $FF57
       .byte $00 ; |        | $FF58
       .byte $00 ; |        | $FF59
       .byte $00 ; |        | $FF5A
       .byte $00 ; |        | $FF5B
       .byte $00 ; |        | $FF5C
       .byte $00 ; |        | $FF5D
       .byte $00 ; |        | $FF5E
       .byte $00 ; |        | $FF5F
       .byte $00 ; |        | $FF60
       .byte $00 ; |        | $FF61
       .byte $00 ; |        | $FF62
       .byte $00 ; |        | $FF63
       .byte $00 ; |        | $FF64
       .byte $00 ; |        | $FF65
       .byte $00 ; |        | $FF66
       .byte $00 ; |        | $FF67
       .byte $00 ; |        | $FF68
       .byte $00 ; |        | $FF69
       .byte $00 ; |        | $FF6A
       .byte $00 ; |        | $FF6B
       .byte $00 ; |        | $FF6C
       .byte $00 ; |        | $FF6D
       .byte $00 ; |        | $FF6E
       .byte $00 ; |        | $FF6F
       .byte $00 ; |        | $FF70
       .byte $00 ; |        | $FF71
       .byte $00 ; |        | $FF72
       .byte $00 ; |        | $FF73
       .byte $00 ; |        | $FF74
       .byte $00 ; |        | $FF75
       .byte $00 ; |        | $FF76
       .byte $00 ; |        | $FF77
       .byte $00 ; |        | $FF78
       .byte $00 ; |        | $FF79
       .byte $00 ; |        | $FF7A
       .byte $00 ; |        | $FF7B
       .byte $00 ; |        | $FF7C
       .byte $00 ; |        | $FF7D
       .byte $00 ; |        | $FF7E
       .byte $00 ; |        | $FF7F
       .byte $00 ; |        | $FF80
       .byte $00 ; |        | $FF81
       .byte $00 ; |        | $FF82
       .byte $00 ; |        | $FF83
       .byte $00 ; |        | $FF84
       .byte $00 ; |        | $FF85
       .byte $00 ; |        | $FF86
       .byte $00 ; |        | $FF87
       .byte $00 ; |        | $FF88
       .byte $00 ; |        | $FF89
       .byte $00 ; |        | $FF8A
       .byte $00 ; |        | $FF8B
       .byte $70 ; | XXXXXXX| $FF8C
       .byte $FF ; |XXXXX X | $FF8D
       .byte $FA ; |XXXXXX  | $FF8E
       .byte $E0 ; | XX     | $FF8F
       .byte $40 ; | X      | $FF90
       .byte $00 ; |        | $FF91
       .byte $00 ; |        | $FF92
       .byte $00 ; |        | $FF93
       .byte $00 ; |        | $FF94
       .byte $00 ; |        | $FF95
       .byte $92 ; |X  X  X | $FF96
       .byte $54 ; | X X X  | $FF97
       .byte $38 ; |  XXX   | $FF98
       .byte $FE ; |XXXXXXX | $FF99
       .byte $B2 ; |X XX  X | $FF9A
       .byte $B2 ; |X XX  X | $FF9B
       .byte $7C ; | XXXXX  | $FF9C
       .byte $38 ; |  XXX   | $FF9D
       .byte $C4 ; |XX   X  | $FF9E
       .byte $C4 ; |XX   X  | $FF9F
       .byte $C4 ; |XX   X  | $FFA0
       .byte $C4 ; |XX   X  | $FFA1
       .byte $56 ; | X X XX | $FFA2
       .byte $56 ; | X X XX | $FFA3
       .byte $56 ; | X X XX | $FFA4
       .byte $56 ; | X X XX | $FFA5
       .byte $00 ; |        | $FFA6
       .byte $00 ; |        | $FFA7
       .byte $00 ; |        | $FFA8
       .byte $00 ; |        | $FFA9
       .byte $92 ; |X  X  X | $FFAA
       .byte $54 ; | X X X  | $FFAB
       .byte $38 ; |  XXX   | $FFAC
       .byte $FE ; |XXXXXXX | $FFAD
       .byte $E6 ; |XXX  XX | $FFAE
       .byte $E6 ; |XXX  XX | $FFAF
       .byte $7C ; | XXXXX  | $FFB0
       .byte $38 ; |  XXX   | $FFB1
       .byte $E6 ; |XXX  XX | $FFB2
       .byte $E6 ; |XXX  XX | $FFB3
       .byte $E6 ; |XXX  XX | $FFB4
       .byte $E6 ; |XXX  XX | $FFB5
       .byte $C4 ; |XX   X  | $FFB6
       .byte $56 ; | X X XX | $FFB7
       .byte $56 ; | X X XX | $FFB8
       .byte $C4 ; |XX   X  | $FFB9
       .byte $C4 ; |XX   X  | $FFBA
       .byte $00 ; |        | $FFBB
       .byte $00 ; |        | $FFBC
       .byte $00 ; |        | $FFBD
       .byte $00 ; |        | $FFBE
       .byte $92 ; |X  X  X | $FFBF
       .byte $54 ; | X X X  | $FFC0
       .byte $38 ; |  XXX   | $FFC1
       .byte $FE ; |XXXXXXX | $FFC2
       .byte $CE ; |XX  XXX | $FFC3
       .byte $CE ; |XX  XXX | $FFC4
       .byte $7C ; | XXXXX  | $FFC5
       .byte $38 ; |  XXX   | $FFC6
       .byte $00 ; |        | $FFC7
       .byte $00 ; |        | $FFC8
       .byte $00 ; |        | $FFC9
       .byte $00 ; |        | $FFCA
       .byte $92 ; |X  X  X | $FFCB
       .byte $54 ; | X X X  | $FFCC
       .byte $38 ; |  XXX   | $FFCD
       .byte $FE ; |XXXXXXX | $FFCE
       .byte $9A ; |X  XX X | $FFCF
       .byte $9A ; |X  XX X | $FFD0
       .byte $7C ; | XXXXX  | $FFD1
       .byte $38 ; |  XXX   | $FFD2
       .byte $0F ; |    XXXX| $FFD3
       .byte $0F ; |    XXXX| $FFD4
       .byte $C4 ; |XX   X  | $FFD5
       .byte $C4 ; |XX   X  | $FFD6
       .byte $C4 ; |XX   X  | $FFD7
       .byte $C4 ; |XX   X  | $FFD8
       .byte $C4 ; |XX   X  | $FFD9
       .byte $C4 ; |XX   X  | $FFDA
       .byte $E6 ; |XXX  XX | $FFDB
       .byte $C4 ; |XX   X  | $FFDC
       .byte $0F ; |    XXXX| $FFDD
       .byte $C4 ; |XX   X  | $FFDE
       .byte $C4 ; |XX   X  | $FFDF
       .byte $C4 ; |XX   X  | $FFE0
       .byte $C4 ; |XX   X  | $FFE1
       .byte $C4 ; |XX   X  | $FFE2
       .byte $C4 ; |XX   X  | $FFE3
       .byte $E6 ; |XXX  XX | $FFE4
       .byte $E6 ; |XXX  XX | $FFE5
       .byte $0F ; |    XXXX| $FFE6
       .byte $0F ; |    XXXX| $FFE7
       .byte $56 ; | X X XX | $FFE8
       .byte $56 ; | X X XX | $FFE9
       .byte $56 ; | X X XX | $FFEA
       .byte $D6 ; |XX X XX | $FFEB
       .byte $56 ; | X X XX | $FFEC
       .byte $56 ; | X X XX | $FFED
       .byte $C4 ; |XX   X  | $FFEE
       .byte $C4 ; |XX   X  | $FFEF
LFFF0:
       .byte $9A ; |X  XX X | $FFF0
       .byte $92 ; |X  X  X | $FFF1

       ORG  $2FF2
       RORG $FFF2

LFFF2:
       STA    $FFF8                   ;4 bankswitch to #1
       JMP    LF158                   ;3

       .byte $00 ; |        | $FFF8 bankswitch hotspot
       .byte $00 ; |        | $FFF9 bankswitch hotspot
       .word START2,START2,START2

       IF (START2 != START1+$1FFD)
 	  ECHO "WARNING: Cart boot bankswitch @$F100 does not line up!"
       ENDIF	

       IF (LFFF2 != LDFF2+$2000)
 	  ECHO "WARNING: Program bankswitches @$xFF2 do not line up!"
       ENDIF	
